#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
typedef long long LL;

const int N = 2e5 + 5;

struct edge {
	int nt, to, fr, nxt;
}e[N << 1];

LL ans;
int n, tot, head[N], sz[N];
int d[N];

void add(int u, int v) {
	e[++tot].to = v;
	e[tot].nxt = head[u];
	e[tot].fr = u;
	head[u] = tot;
}

int ch(int x) {
	return ((x - 1) ^ 1) + 1;
}

void dfs(int u, int fa) {
	sz[u] = 1;
	for (int i = head[u]; i; i = e[i].nxt) {
		int nt = e[i].to;
		if (nt == fa) continue;
		dfs(nt, u);
		sz[u] += sz[nt];
	}
}

void solve(int u, int fa, int x) {
	int flag = 1;
	if (x - sz[u] > x / 2)
		flag = 0;
	for (int i = head[u]; i; i = e[i].nxt) {
		int nt = e[i].to;
		if (nt == fa) continue;
		if (sz[nt] > x / 2)
			flag = 0;
		solve(nt, u, x);
	}
	if (flag) ans += u;
}

int stk[N], tp;

void dfs_chain(int x, int fa, int dep) {
	stk[dep] = x;
	if (dep % 2) 
		ans += stk[dep / 2 + 1];
	else ans += stk[dep / 2] + stk[dep / 2 + 1];
	for (int i = head[x]; i; i = e[i].nxt) {
		int nt = e[i].to;
		if (nt == fa) continue;
		dfs_chain(nt, x, dep + 1);
	}
}

void solve_chain() {
	memset(d, 0, sizeof(d));
	for (int i = 1; i < n; ++i) {
		int u, v; scanf("%d%d", &u, &v);
		add(u, v); add(v, u);
		d[u]++; d[v]++;
	}
	int x = 0;
	for (int i = 1; i <= n; ++i) if (d[i] == 1) {
		x = i; break;
	}
	dfs_chain(x, 0, 1);
	for (int i = n; i; --i) if (d[i] == 1) {
		x = i; break;
	}
	dfs_chain(x, 0, 1);
	if (n % 2) 
		ans -= stk[n / 2 + 1] * 2;
	else ans -= (stk[n / 2] + stk[n / 2 + 1]) * 2;
	printf("%lld\n", ans);
}

int main() {// 55pts
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	for (; T; T--) {
		ans = tot = 0; memset(head, 0, sizeof(head));
		scanf("%d", &n);
		if (n >= 3000) { // 9~11 15pts
			solve_chain();
			continue;
		}
		
		for (int i = 1; i < n; ++i) { //40 pts
			int u, v; scanf("%d%d", &u, &v);
			add(u, v); add(v, u);
		}
		for (int i = 1; i < n; ++i) {
			int u = e[i << 1].fr, v = e[i << 1].to;
			dfs(u, v);
			solve(u, v, sz[u]);
			dfs(v, u);
			solve(v, u, sz[v]);
		}
		printf("%lld\n", ans);
	}
	return 0;
}
