#include <set>
#include <cstdio>
#include <algorithm>
#include <cstring>
using std::set;
typedef set<int>::iterator ITR;
const int maxn = 3123456;
struct edge{
	int v, nxt;
}e[maxn << 1];
int fir[maxn], esiz(1);
inline void add(int u, int v){
	e[++esiz].v = v; e[esiz].nxt = fir[u]; fir[u] = esiz;
}
int siz[maxn], bsiz[maxn], son[maxn], son2[maxn], h[maxn], fa[maxn];
void dfs1(int now, int fr){
	siz[now] = 1;
	for(int itr(fir[now]), to; itr; itr = e[itr].nxt){
		if((to = e[itr].v) == fr) continue;
		fa[to] = now; h[to] = h[now] + 1;
		dfs1(to, now); siz[now] += siz[to];
		if(!son[now]) son[now] = to;
		else{
			if(siz[son[now]] < siz[to]){
				son2[now] = son[now]; son[now] = to; 
			}			
			else if(!son2[now] || siz[son2[now]] < siz[to]){
				son2[now] = to;
			}
		}
	}
}
int top[maxn], dfn[maxn], last[maxn], mp[maxn], dfs_clock;
void dfs2(int now, int fr, int tp){
	top[now] = tp; dfn[now] = ++dfs_clock; 
	mp[dfs_clock] = now;last[tp] = now;
	if(son[now]) dfs2(son[now], now, tp);
	if(son2[now]) dfs2(son2[now], now, son2[now]);
	for(int itr(fir[now]), to; itr; itr = e[itr].nxt){
		to = e[itr].v;
		if(to == fr || to == son[now] || to == son2[now]) continue;
		dfs2(to, now, to);
	}
	last[now] = last[tp];
}
int times[maxn];
inline int get2h(int x){
	while(fa[x] != 1){
		x = top[x];
		if(fa[x] == 1) break;
		x = fa[x];
	}
	return x;
}
inline void calc(int p){
	//p
	if(siz[p] == 1){
		++times[p];
	}
	else{
		int l1 = dfn[p], r1 = dfn[last[p]], t1 = r1; 
		while(l1 <= r1){
			int mid((l1 + r1) >> 1), now = mp[mid];
			if(son[now] == 0 || siz[son[now]] > siz[p] / 2 ){
				l1 = mid + 1;
			}
			else{
				r1 = mid - 1; t1 = mid;
			}
		}
		int l2 = dfn[p], r2 = dfn[last[p]], t2 = l2;
		while(l2 <= r2){
			int mid((l2 + r2) >> 1), now = mp[mid];
			if(bsiz[now] - bsiz[p] > siz[p] / 2){
				r2 = mid - 1;
			}
			else{
				l2 = mid + 1; t2 = mid;
			}
		}
		for(int i(t1); i <= t2; ++i) ++times[mp[i]];
	}
	//ǳp 
	//1ʼ滻
	if(get2h(p) == son[1]){
		int tmp = p;
		while(top[tmp] != 1){
			tmp = fa[top[tmp]];
		}
		int x = 1;
		while(son[x]){
			if(son2[x]){
				if(siz[son[x]] - siz[p] < siz[son2[x]]);
			}
		}
	} 
	else{
		int l1 = dfn[1], r1 = dfn[last[1]], t1 = r1; 
		while(l1 <= r1){
			int mid((l1 + r1) >> 1), now = mp[mid];
			if(son[now] == 0 || siz[son[now]] > (siz[1] - siz[p]) / 2 ){
				l1 = mid + 1;
			}
			else{
				r1 = mid - 1; t1 = mid;
			}
		}
		int l2 = dfn[p], r2 = dfn[last[p]], t2 = l2;
		while(l2 <= r2){
			int mid((l2 + r2) >> 1), now = mp[mid];
			if(bsiz[now] - siz[p] > (siz[1] - siz[p]) / 2){
				r2 = mid - 1;
			}
			else{
				l2 = mid + 1; t2 = mid;
			}
		}
		for(int i(t1); i <= t2; ++i) ++times[mp[i]];
	}// 
}//pϾӹϵ 
int SIZ[maxn], SON[maxn], P;
void DFS(int now, int fr){
	SIZ[now] = 1;
	for(int itr(fir[now]), to; itr; itr = e[itr].nxt){
		if((to = e[itr].v) == fr || to == P) continue;
		dfs1(to, now); SIZ[now] += SIZ[to];
		if(!SON[now]) SON[now] = to;
		else{
			if(siz[SON[now]] < siz[to]){
				SON[now] = to; 
			}			
		}
	}
}
int n; 
void CALC(int p){
	for(int i(dfn[p]); i <= dfn[p] + siz[p] - 1; ++i){
		if(siz[son[mp[i]]] <= siz[p] / 2 && bsiz[mp[i]] - bsiz[p] <= siz[p] / 2)
			++times[mp[i]];
	}
	DFS(1, 0); int tmpsiz = siz[1] - siz[p];
	for(int i(1); i <= n; ++i){
		if(dfn[i] >= p && dfn[i] <= dfn[p] + siz[p] - 1) continue;
		 if(SIZ[SON[i]] <= tmpsiz / 2 && tmpsiz - SIZ[i] <= tmpsiz / 2)
			++times[i];
	}
}
int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	while(T--){
		esiz = 1;
		memset(fir, 0, sizeof(fir)); dfs_clock = 0;
		scanf("%d", &n);
		for(int i(1), u, v; i < n; ++i){
			scanf("%d%d", &u, &v); 
			add(u, v); add(v, u); 
		}
		dfs1(1, 0); dfs2(1, 0, 1);
		for(int i(1); i <= n; ++i){
			bsiz[i] = n - siz[i];
		}
		for(int i(2); i <= n; ++i){
			CALC(i);
		}
		long long ans(0);
		for(long long i(1); i <= n; ++i){
			printf("%d\n", times[i]);
			ans += i*times[i];
		}
		printf("%lld\n", ans);
		
	}
	return 0;
}
//ֻϵĵ 
