#include <bits/stdc++.h>

typedef long long LL;

const int MAXN = 3e5 + 10;

int n, sum;
int head[MAXN], in[MAXN];
struct Edge { int link, to; } e[MAXN << 1];
inline void add(int u, int v) { e[++sum] = (Edge) { v, head[u] }, head[u] = sum; }

inline void clear(int n) {
	sum = 0;
	for (int i = 0; i <= n; ++i) head[i] = in[i] = 0;
}

namespace Subtask1 {
	const int N = 2e3 + 10;
	int sz[N], son[N], min, tot;
	void dfs1(int u, int fa) {
		sz[u] = 1, son[u] = 0;
		for (int i = head[u]; i; i = e[i].to) {
			int v = e[i].link;
			if (v == fa) continue;
			dfs1(v, u), sz[u] += sz[v], son[u] = std::max(son[u], sz[v]);
		}
	}
	void dfs2(int u, int fa, int rt) {
		son[u] = std::max(son[u], sz[rt] - sz[u]);
		if (son[u] < min) min = son[u], tot = u;
		else if (son[u] == min) tot += u;
		for (int i = head[u]; i; i = e[i].to) {
			int v = e[i].link;
			if (v == fa) continue;
			dfs2(v, u, rt);
		}
	}
	inline void gao() {
		int ans = 0;
		for (int i = 1; i <= sum; i += 2) {
			int u = e[i].link, v = e[i + 1].link;
			min = 2333, tot = 0, dfs1(u, v), dfs2(u, v, u), ans += tot;
			min = 2333, tot = 0, dfs1(v, u), dfs2(v, u, v), ans += tot;
		}
		printf("%d\n", ans);
	}
	/*
	2 5
	1 2
	2 3
	2 4
	3 5
	*/
};
namespace Subtask2 {
	int id[MAXN], tot;
	void dfs(int u, int fa) {
		id[++tot] = u;
		for (int i = head[u]; i; i = e[i].to) {
			int v = e[i].link;
			if (v == fa) continue;
			dfs(v, u);
		}
	}
	inline void gao() {
		int rt;
		for (int i = 1; i <= n; ++i) if (in[i] == 1) { rt = i; break; }
		tot = 0, dfs(rt, 0);
		LL ans = 0;
		for (int i = 1; i < n; ++i) {
			if (i & 1) ans += id[(i + 1) / 2];
			else ans += id[i / 2] + id[i / 2 + 1];
			if ((n - i) & 1) ans += id[(n + i + 1) / 2];
			else ans += id[(n + i + 1) / 2] + id[(n + i) / 2 + 1];
		}
		printf("%lld\n", ans);
	}
};
namespace Subtask3 {
	int rt, dep[MAXN], sz[MAXN];
	void getRoot(int u, int fa) {
		sz[u] = 1; int max = 0;
		for (int i = head[u]; i; i = e[i].to) {
			int v = e[i].link;
			if (v == fa) continue;
			getRoot(v, u), sz[u] += sz[v], max = std::max(max, sz[v]);
		}
		max = std::max(max, n - sz[u]);
		if (max == n / 2) rt = u;
	}
	void dfs(int u, int fa) {
		dep[u] = dep[fa] + 1;
		for (int i = head[u]; i; i = e[i].to) {
			int v = e[i].link;
			if (v == fa) continue;
			dfs(v, u);
		}
	}
	inline void gao() {
		getRoot(1, 0), dfs(rt, 0);
		LL ans = 0;
		for (int i = 1; i <= n; ++i)
			if (dep[i] <= 2) ans += 1LL * ((n + 1) >> 1) * i;
			else ans += i;
		printf("%lld\n", ans);
	}
};

inline void solve() {
	scanf("%d", &n), clear(n);
	for (int i = 1, u, v; i < n; ++i) scanf("%d%d", &u, &v), add(u, v), add(v, u), ++in[u], ++in[v];
	if (n == 1) puts("1"); 
	else if (n <= 2000) Subtask1::gao();
	else if (n % 10 == 1) Subtask2::gao();
	else if (n % 10 == 3) Subtask3::gao();
}

int main() {
	freopen("centroid.in", "r", stdin); freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	for (; T --> 0;) solve();
	return 0;
}
