#include <cstdio>
#include <algorithm>
#include <vector>
#include <memory.h>
#define MAXN 300000
#define int long long
struct Edge{ int to,nxt; };
static Edge e[MAXN<<1];
static int head[MAXN],deg[MAXN],cnt;
inline void AddEdge(register int u,register int v){
	e[++cnt]=(Edge){v,head[u]}, head[u]=cnt;
	e[++cnt]=(Edge){u,head[v]}, head[v]=cnt;
	deg[u]++, deg[v]++;
}
int n;
namespace Task1{
	static int Size(register int u,register int f){
		register int ret=1;
		for(register int i=head[u];i;i=e[i].nxt) if(e[i].to!=f)
			ret+=Size(e[i].to,u);
		return ret;
	}
	std::vector<int> V; int MX;
	static int DFS(register int u,register int f,register int n){
		register int ret=1,mx=0;
		for(register int i=head[u];i;i=e[i].nxt) if(e[i].to!=f){
			register int tmp=DFS(e[i].to,u,n);
			ret+=tmp; mx=std::max(mx,tmp);
		}
		mx=std::max(mx,n-ret);
		if(mx<MX){ MX=mx; V.clear(); }
		if(mx==MX) V.push_back(u);
		return ret;
	}
	inline void Solve(){
		register int ans=0;
		for(register int i=1;i<cnt;i+=2){
			register int u=e[i+1].to,v=e[i].to,s=Size(u,v);
			MX=n; V.clear(); DFS(u,v,s); ans+=V[0]; if(V.size()==2) ans+=V[1];
			MX=n; V.clear(); DFS(v,u,n-s); ans+=V[0]; if(V.size()==2) ans+=V[1];
		}
		printf("%lld\n",ans);
	}
}
namespace Task2{
	static int dep[MAXN],num[MAXN];
	inline void DFS(register int u){
		register int flag=true;
		while(flag){
			num[dep[u]]=u; flag=false;
			for(register int i=head[u];i;i=e[i].nxt) if(!dep[e[i].to]){
				flag=true; dep[e[i].to]=dep[u]+1, u=e[i].to; break;
			}
		}
		num[dep[u]]=u;
	}
	inline void Solve(){
		memset(dep,0,sizeof(dep));
		register int top=1; for(;top<=n;top++) if(deg[top]==1) break;
		dep[top]=1; DFS(top); register int ans=0;
		for(register int i=1;i<n;i++){
			if(i&1) ans+=num[i/2+1];
			else ans+=num[i/2]+num[i/2+1];
			if((n-i)&1) ans+=num[i+(n-i)/2+1];
			else ans+=num[i+(n-i)/2]+num[i+(n-i)/2+1];
		}
		printf("%lld\n",ans);
	}
}
namespace Task3{
	int mx=0,dep[MAXN],col[MAXN];
	void DFS(int u,int f){
		if(dep[u]>mx) mx=dep[u];
		for(int i=head[u];i;i=e[i].nxt) if(e[i].to!=f){
			dep[e[i].to]=dep[u]+1; DFS(e[i].to,u);
		}
	}
	void Color(int u,int f,int c){
		col[u]=c;
		for(int i=head[u];i;i=e[i].nxt) if(e[i].to!=f)
			Color(e[i].to,u,c);
	}
	void Solve(){
		int rt=1; for(;rt<=n;rt++) if(deg[rt]==2) break;
		dep[rt]=1; DFS(rt,0);
		int t1=e[head[rt]].to,t2=e[e[head[rt]].nxt].to;
		Color(t1,rt,t2), Color(t2,rt,t1);
		int ans=0;
		for(int i=1;i<=cnt;i+=2){
			int u=e[i].to,v=e[i+1].to;
			if(dep[u]<dep[v]) std::swap(u,v);
			ans+=u;
			int sum1=std::max((1<<mx-1)-(1<<mx-dep[u]+1)+1,(1<<mx-2)-1);
			int sum2=(1<<mx-1)-1;
			if(sum1<=sum2) ans+=t1^t2^col[u];
			if(sum1>=sum2) ans+=rt;
		}
		printf("%lld\n",ans);
	}
}
signed main(){
	freopen("centroid.in","r",stdin); freopen("centroid.out","w",stdout);
	int T; scanf("%lld",&T);
	while(T--){
		scanf("%lld",&n); cnt=0; memset(head,0,sizeof(head));
		for(int i=1,u,v;i<n;i++) scanf("%lld%lld",&u,&v), AddEdge(u,v);
		if(n<=2000) Task1::Solve();
		if(n==49991) Task2::Solve();
		if(n==262143) Task3::Solve();
	}
	return 0;
}
