//centroid
#include <cstdio>
#include <cstring>
#include <algorithm>
//#include <stdlib.h>
//#include <unistd.h>

inline int GC() {
#define MAX (1 << 15)
	static char Buffer[MAX];
	static char *l = Buffer, *r = Buffer;
	if (l == r) {
		l = Buffer;
		r = Buffer + fread(Buffer, 1, MAX, stdin);
	}
	return *l++;
}

inline void Read(int &x) {
	static char ch;
	for (ch = GC(); ch < 48 || ch > 57; ch = GC());
	for (x = 0; ch > 47 && ch < 58; x = (x << 1) + (x << 3) + (ch ^ 48), ch = GC());
	return;
}

inline void Main();

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	Read(T);
	for (; T; --T) Main();
	return 0;
}

#define Maxn 300010
struct edge {
	int To, Next;
	edge() {}
	edge(int _To, int _Next) : To(_To), Next(_Next) {}
};
edge Edge[Maxn << 1];
int n, Start[Maxn], Used;
int X[Maxn], Y[Maxn];
int Size[Maxn];
int Degree[Maxn], List[Maxn], Cnt;
long long Ans;

inline void AddEdge(int x, int y) {
	Edge[++Used] = edge(y, Start[x]);
	Start[x] = Used;
	return;
}

inline void Dfs1(int u, int Fa) {
//	fprintf(stderr, "Dfs1 %d\n", u);
	Size[u] = 1;
	for (int t = Start[u]; t; t = Edge[t].Next) {
		int v = Edge[t].To;
		if (v == Fa) continue;
		Dfs1(v, u);
		Size[u] += Size[v];
	}
	return;
}

inline void Get(int u, int Fa, int k) {
//	fprintf(stderr, "Get %d %d\n", u, k);
	int Flag = 1;
	for (int t = Start[u]; t; t = Edge[t].Next) {
		int v = Edge[t].To;
		if (v == Fa) continue;
		Get(v, u, k);
		if (Size[v] > k / 2) Flag = 0;
	}
	if (k - Size[u] > k / 2) Flag = 0;
	if (Flag) Ans += u;
	return;
}

inline void Solve1() {
//	fprintf(stderr, "***\n");
	Ans = 0;
	for (int i = 1; i < n; ++i) {
		memset(Size, 0, sizeof(Size));
//		fprintf(stderr, "%d %d\n", X[i], Y[i]);
		Dfs1(X[i], Y[i]);
		Get(X[i], Y[i], Size[X[i]]);
		Dfs1(Y[i], X[i]);
		Get(Y[i], X[i], Size[Y[i]]);
	}
	printf("%lld\n", Ans);
//	fprintf(stderr, "***\n");
	return;
}

inline void Get2(int u, int Fa) {
	List[++Cnt] = u;
	for (int t = Start[u]; t; t = Edge[t].Next) {
		int v = Edge[t].To;
		if (v == Fa) continue;
		Get2(v, u);
	}
	return;
}

inline void Solve2() {
	memset(Degree, 0, sizeof(Degree));
	int Rt = 0;
	Ans = 0;
	for (int i = 1; i < n; ++i) ++Degree[X[i]], ++Degree[Y[i]];
	for (int i = 1; i <= n; ++i) if (Degree[i] == 1) Rt = i;
	Cnt = 0;
	Get2(Rt, 0);
	for (int i = 1; i < n; ++i) {
		if (i & 1) {
			Ans += List[i / 2 + 1];
		} else {
			Ans += List[i / 2];
			Ans += List[i / 2 + 1];
		}
	}
	for (int i = 1; i + i <= n; ++i) 
		std::swap(List[i], List[n - i + 1]);
	for (int i = 1; i < n; ++i) {
		if (i & 1) {
			Ans += List[i / 2 + 1];
		} else {
			Ans += List[i / 2];
			Ans += List[i / 2 + 1];
		}
	}
	printf("%lld\n", Ans);
	return;
}

inline void Dfs3(int u, int Fa, int Rt, int k) {
	Ans += u; Ans += k;
	if (Degree[u] == 1) Ans += Rt;
	for (int t = Start[u]; t; t = Edge[t].Next) {
		int v = Edge[t].To;
		if (v == Fa) continue;
		Dfs3(v, u, Rt, k);
	}
	return;
}

inline void Solve3() {
	memset(Degree, 0, sizeof(Degree));
	int Rt = 0;
	Ans = 0;
	for (int i = 1; i < n; ++i) ++Degree[X[i]], ++Degree[Y[i]];
	for (int i = 1; i <= n; ++i) if (Degree[i] == 2) Rt = i;
	int Temp1 = 0, Temp2 = 0;
	for (int t = Start[Rt]; t; t = Edge[t].Next) 
		if (!Temp1) Temp1 = Edge[t].To;
		else Temp2 = Edge[t].To;
	Dfs3(Temp1, Rt, Rt, Temp2);
	Dfs3(Temp2, Rt, Rt, Temp1);
	printf("%lld\n", Ans);
	return;
}

inline void Main() {
	Read(n);
	memset(Start, 0, sizeof(Start)); Used = 0;
	for (int i = 1; i < n; ++i) Read(X[i]), Read(Y[i]);
	for (int i = 1; i < n; ++i) AddEdge(X[i], Y[i]), AddEdge(Y[i], X[i]);
	if (n <= 2000) Solve1();
	else if (n <= 50000) Solve2();
	else Solve3();
//	printf("!!!\n");
//	Solve2();
	return;
}
