#include <bits/stdc++.h>

using namespace std;

struct edge_t {
	int u, v, nxt;

	edge_t(int x = 0, int y = 0, int z = 0) {
		u = x, v = y, nxt = z;
	}
};

int cnt_test;
int n;
edge_t adj[600005];
int head[300005];
int cnt_e = 0;
bool is_subtask2;
bool is_erased[600005];
int dep[300005], sz[300005];
int sz2[300005], smax[300005];
int deg[300005];
long long ans = 0;

void add_edge(int u, int v) {
	adj[++cnt_e] = edge_t(u, v, head[u]);
	head[u] = cnt_e;
}

void dfs(int u, int prt) {
	sz[u] = 1, dep[u] = dep[prt] + 1;
	for (int i = head[u]; i; i = adj[i].nxt) {
		int v = adj[i].v;
		if (v == prt) {
			continue;
		}
		dfs(v, u);
		sz[u] += sz[v];
	}
}

void get_centroids(int u, int prt, int szt, int &rt1, int &rt2) {
	sz2[u] = 1, smax[u] = 0;
	for (int i = head[u]; i; i = adj[i].nxt) {
		if (is_erased[i]) {
			continue;
		}
		int v = adj[i].v;
		if (v == prt) {
			continue;
		}
		get_centroids(v, u, szt, rt1, rt2);
		sz2[u] += sz2[v];
		if (sz2[v] > smax[u]) {
			smax[u] = sz2[v];
		}
	}
	smax[u] = max(smax[u], szt - sz2[u]);
	if (!rt1 || smax[u] < smax[rt1]) {
		rt1 = u;
		rt2 = 0;
	} else if (smax[u] == smax[rt1]) {
		rt2 = u;
	}
}

namespace subtask2 {
int a[300005];
long long ans;

void main() {
	for (int i = 1; i <= n; i++) {
		a[i] = 0;
	}
	for (int i = 1; i <= n; i++) {
		if (deg[i] == 1) {
			a[1] = i;
			for (int j = 1; j < n; j++) {
				for (int k = head[a[j]]; k; k = adj[k].nxt) {
					if (j == 1 || adj[k].v != a[j - 1]) {
						a[j + 1] = adj[k].v;
					}
				}
			}
			break;
		}
	}
	ans = 0;
	for (int i = 1; i < n; i++) {
		ans += a[(i + 1) / 2] + ((i + 1) & 1) * a[(i + 1) / 2 + 1];
		ans += a[(i + 1 + n) / 2] + ((i + 1 + n) & 1) * a[(i + 1 + n) / 2 + 1];
		// cerr << (i + 1) / 2 << ' ' << (i + ) / 2 + 1 << ' ' << (i + 1 + n) / 2 << ' ' << (i + 1 + n) / 2 + 1 << '\n';
		// cerr << ans << '\n';
	}
	printf("%lld\n", ans);
}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);

	scanf("%d", &cnt_test);
	while (cnt_test--) {
		scanf("%d", &n);
		for (int i = 1; i <= ((n - 1) << 1); i++) {
			adj[i] = edge_t();
			is_erased[i] = false;
		}
		for (int i = 1; i <= n; i++) {
			head[i] = 0;
			dep[i] = 0, sz[i] = 0;
			deg[i] = 0;
			sz2[i] = smax[i] = 0;
		}
		cnt_e = 0;
		is_subtask2 = true;
		ans = 0;

		for (int i = 1; i < n; i++) {
			int u, v;
			scanf("%d%d", &u, &v);
			add_edge(u, v), add_edge(v, u);
			deg[u]++, deg[v]++;
		}

		for (int i = 1; i <= n; i++) {
			is_subtask2 &= deg[i] <= 2;
		}

		if (is_subtask2) {
			subtask2::main();
			continue;
		}

		dfs(1, 0);

		for (int i = 1; i <= ((n - 1) << 1); i += 2) {
			is_erased[i] = is_erased[i + 1] = true;
			int u = adj[i].u, v = adj[i].v;
			if (dep[u] < dep[v]) {
				swap(u, v);
			}
			int rt1_u = 0, rt2_u = 0, rt1_v = 0, rt2_v = 0;
			get_centroids(u, 0, sz[u], rt1_u, rt2_u);
			get_centroids(v, 0, sz[1] - sz[u], rt1_v, rt2_v);
			ans += 1LL * (rt1_u + rt2_u + rt1_v + rt2_v);
			is_erased[i] = is_erased[i + 1] = false;
		}
		printf("%lld\n", ans);
	}
	return 0;
}
