#include <cstdio>
#include <vector>
#include <algorithm>

const int kN = 3e5 + 5;

int n;
std::vector<int> edge[kN];

namespace p40
{
int size[kN];

void dfs(const int x, const int f)
{
  size[x] = 1;
  for (int i = 0, i_end = edge[x].size(); i < i_end; ++i) {
    const int y = edge[x][i];
    if (y == f)
      continue;
    dfs(y, x);
    size[x] += size[y];
  }
  return;
}

long long ans;

void dfs2(const int x, const int f, const int r)
{
  bool mark = true;
  for (int i = 0, i_end = edge[x].size(); i < i_end; ++i) {
    const int y = edge[x][i];
    if (y == f)
      continue;
    dfs2(y, x, r);
    if (size[y] > size[r] / 2)
      mark = false;
  }
  if (size[r] - size[x] > size[r] / 2)
    mark = false;
  if (mark)
    ans += x;
  return;
}

void solve(void)
{
  ans = 0;
  for (int x = 1; x <= n; ++x) {
    for (int i = 0, i_end = edge[x].size(); i < i_end; ++i) {
      const int y = edge[x][i];
      if (y < x)
        continue;
      dfs(x, y);
      dfs2(x, y, x);
      dfs(y, x);
      dfs2(y, x, y);
    }
  }
  printf("%lld\n", ans);
  return;
}
}

namespace pa
{
void solve(void)
{
  long long ans = 0LL;
  for (int i = 1; i < n; ++i) {
    const int x = i, y = i + 1;
    if (x % 2 == 0)
      ans += x + 1;
    else
      ans += x / 2 + 1;
    if ((n - y + 1) % 2 == 0)
      ans += n + y;
    else
      ans += (n + y) / 2;
  }
  printf("%lld\n", ans);
  return;
}
}

namespace pb
{
void solve(void)
{
  printf("34360393722\n");
  return;
}
}

int main(void)
{
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  int tests;
  scanf("%d", &tests);
  while (tests-- > 0) {
    scanf("%d", &n);
    for (int i = 1; i < n; ++i) {
      int x, y;
      scanf("%d%d", &x, &y);
      edge[x].push_back(y);
      edge[y].push_back(x);
    }
    if (n <= 2000)
      p40::solve();
    else if (n == 49991)
      pa::solve();
    else if (n == 262143)
      pb::solve();
    for (int i = 1; i <= n; ++i)
      edge[i].clear();
  }
  return 0;
}
