#include <bits/stdc++.h>

typedef long long LL;

const int N = 3e5, M = 6e5;

int T, n, tot, lnk[N + 5], ver[M + 5], nxt[M + 5];

namespace Force {
	const int N = 2e3;
	
	int ans, siz[N + 5], cur[N + 5];
	
	void calc(int u, int p, int n) {
		int max = 0;
		cur[u] = 1;
		for (int i = lnk[u]; i > 0; i = nxt[i]) {
			int v = ver[i];
			if (v == p) continue;
			calc(v, u, n);
			cur[u] += cur[v];
			max = std::max(max, cur[v]);
		}
		max = std::max(max, n - cur[u]);
		if (max <= n / 2) {
			ans += u;
		}
	}
	void dfs1(int u, int p) {
		siz[u] = 1;
		for (int i = lnk[u]; i > 0; i = nxt[i]) {
			int v = ver[i];
			if (v == p) continue;
			dfs1(v, u);
			siz[u] += siz[v];
		}
	}
	void dfs2(int u, int p) {
		for (int i = lnk[u]; i > 0; i = nxt[i]) {
			int v = ver[i];
			if (v == p) continue;
			calc(v, u, siz[v]);
			calc(u, v, n - siz[v]);
			dfs2(v, u);
		}
	}
	void main() {
		std::fill(siz + 1, siz + n + 1, 0);
		std::fill(cur + 1, cur + n + 1, 0);
		ans = 0;
		dfs1(1, 0);
		dfs2(1, 0);
		printf("%d\n", ans);
	}
}
namespace Chain {
	const int N = 3e5;
	
	int len, deg[N + 5], a[N + 5];
	
	void dfs(int u, int p) {
		a[++len] = u;
		for (int i = lnk[u]; i > 0; i = nxt[i]) {
			if (ver[i] != p) dfs(ver[i], u);
		}
	}
	void main() {
		std::fill(deg + 1, deg + n + 1, 0);
		for (int u = 1; u <= n; u++) {
			for (int i = lnk[u]; i > 0; i = nxt[i]) {
				if (ver[i] > u) deg[u]++, deg[ver[i]]++;
			}
		}
		int rt = 0;
		for (int i = 1; i <= n; i++) if (deg[i] == 1) rt = i;
		len = 0;
		dfs(rt, 0);
		LL ans = 0;
		for (int i = 1; i <= n; i++) {
			int x = i - 1, y = n - i;
			if (x == 0 || y == 0 || std::abs(x - y) <= 1) ans += 2 * a[i];
			else ans += 3 * a[i];
		}
		printf("%lld\n", ans);
	}
}
namespace Binary {
	const int N = 3e5;
	
	int deg[N + 5];
	
	void main() {
		std::fill(deg + 1, deg + n + 1, 0);
		for (int u = 1; u <= n; u++) {
			for (int i = lnk[u]; i > 0; i = nxt[i]) {
				if (ver[i] > u) deg[u]++, deg[ver[i]]++;
			}
		}
		int rt = 0;
		for (int i = 1; i <= n; i++) if (deg[i] == 2) rt = i;
		LL ans = 0;
		for (int i = 1; i <= n; i++) if (i != rt) ans += i;
		int ch1 = 0, ch2 = 0;
		for (int i = lnk[rt]; i > 0; i = nxt[i]) {
			if (ch1 == 0) ch1 = ver[i]; else ch2 = ver[i];
		}
		ans += (LL)(ch1 + ch2) * (n - 1) / 2;
		ans += (LL)rt * (n + 1) / 2;
		printf("%lld\n", ans);
	}
}

void addEdge(int u, int v) {
	ver[++tot] = v, nxt[tot] = lnk[u], lnk[u] = tot;
}
void solve() {
	scanf("%d", &n);
	tot = 0, std::fill(lnk + 1, lnk + n + 1, 0);
	for (int u, v, i = 1; i < n; i++) {
		scanf("%d%d", &u, &v);
		addEdge(u, v), addEdge(v, u);
	}
	if (n <= 2000) {
		Force::main();
		return;
	}
	if (n == 49991) {
		Chain::main();
		return;
	}
	if (n == 262143) {
		Binary::main();
		return;
	}
	return 0;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	for (int cs = 1; cs <= T; cs++) solve();
	return 0;
}
