#include<bits/stdc++.h>
namespace Console{
using std::cin;
using std::cout;
const char endl='\n';
typedef unsigned long long ull;

class Tree{
	struct Edge{
		int v;
		bool acc,done;
		Edge *next,*opp;
		Edge(){next=opp=NULL;v=0;acc=true;done=0;}
	};
	struct Vertex{
		Edge *head;
		int size;
		Vertex(){head=NULL;}
	};
	std::vector<Vertex> m_v;
	void add_edge(int x,int y);
	void calc(int fa,int x,ull &ans,int size);
	int dfs(int fa,int x);
public:
	Tree(int v){m_v.resize(v+1);}
	~Tree();
	void add_double_edge(int x,int y);
	void solve();
};
}
using namespace Console;
int main(){
	std::freopen("centroid.in","r",stdin);
	std::freopen("centroid.out","w",stdout);
	std::ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int T,n,x,y;
	Tree *t;
	cin>>T;
	while(T--){
		int n;
		cin>>n;
		t=new Tree(n);
		for(int i=1;i<n;++i){
			cin>>x>>y;
			t->add_double_edge(x,y);
		}
		t->solve();
		delete t;
	}
	return 0;
}
Tree::~Tree(){
	for(int i=0;i<m_v.size();++i)
		for(Edge *p=m_v[i].head,*t;p!=NULL;p=t){
			t=p->next;
			delete p;
		}
}
void Tree::add_edge(int x,int y){
	using std::max;
	if(max(x,y)>=m_v.size())
		m_v.resize(max(x,y)+1);
	Edge *p=new Edge;
	p->v=y;
	p->next=m_v[x].head;
	m_v[x].head=p;
}
void Tree::add_double_edge(int x,int y){
	add_edge(x,y);
	add_edge(y,x);
	m_v[x].head->opp=m_v[y].head;
	m_v[y].head->opp=m_v[x].head;
}
void Tree::solve(){
	ull ans=0;
	for(int i=1;i<m_v.size();++i)
		for(Edge *p=m_v[i].head;p!=NULL;p=p->next){
			if(p->done)	continue;
			p->acc=p->opp->acc=false;
			dfs(0,i),dfs(0,p->v);
			int l_size=m_v[i].size,r_size=m_v[p->v].size;
			calc(0,i,ans,l_size),calc(0,p->v,ans,r_size);
			p->acc=p->opp->acc=p->done=p->opp->done=true;
		}
	cout<<ans<<endl;
}
void Tree::calc(int fa,int x,ull &ans,int size){
	int m=0,y;
	for(Edge *p=m_v[x].head;p!=NULL;p=p->next){
		if(!p->acc || p->v==fa)	continue;
		if(m<m_v[p->v].size){m=m_v[p->v].size,y=p->v;}
		calc(x,p->v,ans,size);
	}
	if(std::max(size-m-1,m)<=(size>>1))	ans+=x;
}
int Tree::dfs(int fa,int x){
	using std::max;
	m_v[x].size=1;
	for(Edge *p=m_v[x].head;p!=NULL;p=p->next){
		if(!p->acc || p->v==fa)	continue;
		dfs(x,p->v);
		m_v[x].size+=m_v[p->v].size;
	}
}

