#include <cstdio>
#include <algorithm>

long long read()
{
	char last = '+', ch = getchar();
	while (ch < '0' || ch > '9') last = ch, ch = getchar();
	long long tmp = 0;
	while (ch >= '0' && ch <= '9') tmp = tmp * 10 + ch - 48, ch = getchar();
	if (last == '-') tmp = -tmp;
	return tmp;
}

const int _n = 300000 + 10;
int T, n;
int edgenum;
int vet[2 * _n], nextx[2 * _n], head[_n];
int size[_n];
int knum, root[_n];
int ch[40 * _n][2], tree[40 * _n];
int sum[4 * _n];
long long ans;

void add(int u, int v)
{
	edgenum++;
	vet[edgenum] = v;
	nextx[edgenum] = head[u];
	head[u] = edgenum;
}

inline int lowbit(int x)
{
	return x & -x;
}

void nchange(int pos, int delta)
{
	for (int i = pos; i <= n; i += lowbit(i))
	{
		sum[i] += delta;
	}
}

int nquery(int pos)
{
	int ans = 0;
	for (int i = pos; i; i -= lowbit(i))
	{
		ans += sum[i];
	}
	return ans;
}

void change(int &u, int v, int l, int r, int pos)
{
	knum++;
	u = knum;
	ch[u][0] = ch[v][0];
	ch[u][1] = ch[v][1];
	tree[u] = tree[v];
	if (l == r)
	{
		tree[u]++;
		return;
	}
	int mid = (l + r) >> 1;
	if (pos <= mid)
	{
		change(ch[u][0], ch[v][0], l, mid, pos);
	}
	else
	{
		change(ch[u][1], ch[v][1], mid + 1, r, pos);
	}
	tree[u] = tree[ch[u][0]] + tree[ch[u][1]];
}

int query(int k, int l, int r, int L, int R)
{
	if (! k)
	{
		return 0;
	}
	if (L <= l && r <= R)
	{
		return tree[k];
	}
	int ans = 0;
	int mid = (l + r) >> 1;
	if (L <= mid)
	{
		ans += query(ch[k][0], l, mid, L, R);
	}
	if (R > mid)
	{
		ans += query(ch[k][1], mid + 1, r, L, R);
	}
	return ans;
}

void merge(int &x, int y)
{
	if (x == 0)
	{
		x = y;
		return;
	}
	if (y == 0)
	{
		return;
	}
	knum++;
	ch[knum][0] = ch[x][0];
	ch[knum][1] = ch[x][1];
	tree[knum] = tree[x];
	x = knum;
	tree[x] += tree[y];
	merge(ch[x][0], ch[y][0]);
	merge(ch[x][1], ch[y][1]);
}

void dfs(int u, int father)
{
	size[u] = 1;
	for (int i = head[u]; i; i = nextx[i])
	{
		int v = vet[i];
		if (v != father)
		{
			dfs(v, u);
			size[u] += size[v];
			merge(root[u], root[v]);
		}
	}
	change(root[u], root[u], 1, n, size[u]);
}

void dfs2(int u, int father)
{
	int maxv1 = 0, maxv2 = 0;
	for (int i = head[u]; i; i = nextx[i])
	{
		int v = vet[i];
		if (v != father)
		{
			if (size[v] > maxv1)
			{
				maxv2 = maxv1;
				maxv1 = size[v];
			}
			else
			{
				if (size[v] > maxv2)
				{
					maxv2 = size[v];
				}
			}
		}
	}
	if (father)
	{
		if (n - size[u] > maxv1)
		{
			maxv2 = maxv1;
			maxv1 = n - size[u];
		}
		else
		{
			if (n - size[u] > maxv2)
			{
				maxv2 = n - size[u];
			}
		}
	}
	for (int i = head[u]; i; i = nextx[i])
	{
		int v = vet[i];
		if (v != father)
		{
			int maxv = size[v] == maxv1 ? maxv2 : maxv1;
			int cnt = 0;
			int ll, rr;
			if (2 * size[v] - n <= n - 2 * maxv)
			{
				ll = std::max(2 * size[v] - n, 1);
				rr = std::min(n - 2 * maxv, n);
				if (ll <= rr)
				{
					cnt += query(root[v], 1, n, ll, rr);
				}
			}
			else
			{
				ll = std::max(size[v] - maxv, 1);
				rr = std::min(n - 2 * maxv, n);
				if (ll <= rr)
				{
					cnt += query(root[v], 1, n, ll, rr);
				}
				ll = std::max(2 * size[v] - n, 1);
				rr = std::min(size[v] - maxv - 1, n);
				if (ll <= rr)
				{
					cnt += query(root[v], 1, n, ll, rr);
				}
			}
//			printf("??%d %d %d %d\n", u, v, cnt, maxv);
			ans += (long long)cnt * u;
		}
	}
	if (father)
	{
		int sizev = n - size[u];
		int maxv = sizev == maxv1 ? maxv2 : maxv1;
		int cnt = 0;
		int ll, rr;
		if (2 * sizev - n <= n - 2 * maxv)
		{
			ll = std::max(2 * sizev - n, 1);
			rr = std::min(n - 2 * maxv, n);
			if (ll <= rr)
			{
				cnt += query(root[1], 1, n, ll, rr) - query(root[u], 1, n, ll, rr) + nquery(rr) - nquery(ll - 1);
//				cnt += query(root[1], 1, n, ll, rr) - query(root[u], 1, n, ll, rr) + nquery(1, 1, n, ll, rr);
			}
		}
		else
		{
			ll = std::max(sizev - maxv, 1);
			rr = std::min(n - 2 * maxv, n);
			if (ll <= rr)
			{
				cnt += query(root[1], 1, n, ll, rr) - query(root[u], 1, n, ll, rr) + nquery(rr) - nquery(ll - 1);
//				cnt += query(root[1], 1, n, ll, rr) - query(root[u], 1, n, ll, rr) + nquery(1, 1, n, ll, rr);
			}
			ll = std::max(2 * sizev - n, 1);
			rr = std::min(sizev - maxv - 1, n);
			if (ll <= rr)
			{
				cnt += query(root[1], 1, n, ll, rr) - query(root[u], 1, n, ll, rr) + nquery(rr) - nquery(ll - 1);
//				cnt += query(root[1], 1, n, ll, rr) - query(root[u], 1, n, ll, rr) + nquery(1, 1, n, ll, rr);
			}
		}
//		printf("??%d %d %d\n", u, father, cnt);
		ans += (long long)cnt * u;
	}
	nchange(size[u], -1);
//	nchange(1, 1, n, size[u], -1);
	for (int i = head[u]; i; i = nextx[i])
	{
		int v = vet[i];
		if (v != father)
		{
			nchange(n - size[v], 1);
//			nchange(1, 1, n, n - size[v], 1);
			dfs2(v, u);
			nchange(n - size[v], -1);
//			nchange(1, 1, n, n - size[v], -1);
		}
	}
	nchange(size[u], 1);
//	nchange(1, 1, n, size[u], 1);
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T--)
	{
		//init
		edgenum = 0;
		for (int i = 1; i <= n; i++)
		{
			head[i] = 0;
			root[i] = 0;
		}
		knum = 0;
		ans = 0;

		n = read();
		for (int i = 1; i < n; i++)
		{
			int u = read();
			int v = read();
			add(u, v);
			add(v, u);
		}
		dfs(1, 0);
		ans = 0;
		dfs2(1, 0);
		printf("%lld\n", ans);
	}
	return 0;
}
