#include <cstdio>
#include <iostream>
#include <algorithm>
#include <cstring>
#define For(i, l, r) for(int i = (int)(l); i <= (int)(r); ++i)
#define Rep(i, r, l) for(int i = (int)(r); i >= (int)(l); --i)
#define lowbit(x) (x & (-x))

using namespace std;
typedef long long LL;
const int MOD = 998244353, INF = 0x3f3f3f3f;
const int N = 300010;

struct Edge {
	int to, nxt;
}e[N << 1];

int siz[N], bgst[N], lst[N], cnt, n, ccf, cent[2][N], anc[N], all[N], tot, maxi, maxii, p[N], pp, tr[N];
LL ans;

inline LL read() {
	LL x = 0, f = 1;
	char ch = getchar();
	while(!isdigit(ch) && ch != '-') ch = getchar();
	if (ch == '-') {f = -1; ch = getchar();}
	while(isdigit(ch)) {
		x = (x << 1) + (x << 3) + (ch ^ 48);
		ch = getchar();
	}
	return x * f;
}

inline void link(int u, int v) {
	e[++cnt].to = v;
	e[cnt].nxt = lst[u];
	lst[u] = cnt;
}

inline void dfs(int x, int fa) {
	siz[x] = 1;
	int xx = 0;
	for(int i = lst[x]; i; i = e[i].nxt) {
		int son = e[i].to;
		if (son == fa) continue;
		dfs(son, x);
		siz[x] += siz[son];
		xx = max(xx, siz[son]);
	}
	xx = max(xx, n - siz[x]);
	if (xx * 2 <= n) ccf = x;
}

inline void dfss(int x, int fa, int o) {
	siz[x] = 1;
	anc[x] = o;
	bgst[x] = 0;
	for(int i = lst[x]; i; i = e[i].nxt) {
		int son = e[i].to;
		if (son == fa) continue;
		if (!o) {
			all[++tot] = son;
			dfss(son, x, son);
		}
		else dfss(son, x, o);
		siz[x] += siz[son];
		if (siz[son] > siz[bgst[x]]) bgst[x] = son;
	}
}

inline void dfs_ans(int x, int fa) {
	for(int i = lst[x]; i; i = e[i].nxt) {
		int son = e[i].to;
		if (son == fa) continue;
		if (anc[son] == maxi) ans += cent[0][siz[son]];
		else ans += cent[1][siz[son]];
		dfs_ans(son, x);
	}
}

inline void add(int x, int v) {
	for(; x <= n; x += lowbit(x)) {
		tr[x] += v;
	}
}

inline int query(int x) {
	if (x < 0) return 0;
	int ret = 0;
	for(; x; x -= lowbit(x)) {
		ret += tr[x];
	}
	return ret;
}

inline void get(int x, int fa) {
	if (x != ccf) {
		if (!lst[x]) ans += x;
		else if (siz[x] >= 2 * siz[bgst[x]]) ans += x;
		ans += 1LL * (query(2 * siz[x]) - query(2 * siz[bgst[x]] - 1)) * x;
	}
	for(int i = lst[x]; i; i = e[i].nxt) {
		int son = e[i].to;
		if (son == fa) continue;
		add(siz[x], 1);
		get(son, x);
		add(siz[x], -1);
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while(T--) {
		//initialize!
		n = read();
		memset(siz, 0, sizeof siz);
		memset(bgst, 0, sizeof bgst);
		memset(all, 0, sizeof all);
		memset(tr, 0, sizeof tr);
		memset(anc, 0, sizeof anc);
		memset(e, 0, sizeof e);
		memset(lst, 0, sizeof lst);
		ans = 0;
		cnt = 0;
		tot = 0;
		For(i, 2, n) {
			int x = read(), y = read();
			link(x, y);
			link(y, x);
		}
		dfs(1, 1);
		dfss(ccf, ccf, 0);
		get(ccf, ccf);
		maxi = all[1], maxii = all[2];
		if (siz[maxi] < siz[maxii]) swap(maxi, maxii);
		For(i, 3, n) {
			if (siz[all[i]] > siz[maxii]) {
				maxii = all[i];
				if (siz[maxi] < siz[maxii]) swap(maxi, maxii);
			}
		}
		int now = ccf;
		For(i, 1, siz[maxi]) {
			if (siz[maxii] * 2 < n - i) cent[0][i] = ccf;
			else if (siz[maxii] * 2 == n - i) cent[0][i] = ccf + maxii;
			else {
				if (now == ccf) now = maxii;
				while(siz[bgst[now]] * 2 > n - i) now = bgst[now];
				if (siz[bgst[now]] * 2 == n - i) cent[0][i] = now + bgst[now];
				else cent[0][i] = now;
			}
		}
		now = ccf;
		For(i, 1, n - siz[maxi] - 1) {
			if (siz[maxi] * 2 < n - i) cent[1][i] = ccf;
			else if (siz[maxi] * 2 == n - i) cent[1][i] = ccf + maxi;
			else {
				if (now == ccf) now = maxi;
				while(siz[bgst[now]] * 2 > n - i) now = bgst[now];
				if (siz[bgst[now]] * 2 == n - i) cent[1][i] = now + bgst[now];
				else cent[1][i] = now;
			}
		}
		dfs_ans(ccf, ccf);
		printf("%lld\n", ans);
	}
	fclose(stdin); fclose(stdout);
	return 0;
}
