#include "bits/stdc++.h"

template<typename T>
inline void read(T &x)
{
	x = 0;
	int neg = 0;
	char c = getchar();
	for(; !isdigit(c); c = getchar())
	{
		if(c == '-')
		{
			neg = 1;
		}
	}
	for(; isdigit(c); c = getchar())
	{
		x = x * 10 + c - '0';
	}
	if(neg)
	{
		x = -x;
	}
}

typedef long long ll;

const int N = 299995 + 5;
int n;
std::set<int> g[N];
typedef std::set<int>::iterator vit;
inline void add_edge(int u, int v)
{
	g[u].insert(v);
}

int siz[N];
void dfs(int u, int fa)
{
	siz[u] = 1;
	for(vit i = g[u].begin(); i != g[u].end(); i++)
	{
		int v = *i;
		if(v != fa)
		{
			dfs(v, u);
			siz[u] += siz[v];
		}
	}
}
int siz2[N];
void dfs2(int u, int fa)
{
	siz2[u] = 1;
	for(vit i = g[u].begin(); i != g[u].end(); i++)
	{
		int v = *i;
		if(v != fa)
		{
			dfs2(v, u);
			siz2[u] += siz2[v];
		}
	}
}
int node_cnt;
int get_gra(int u, int fa)
{
	if(node_cnt == 1)
	{
		return u;
	}
	int res = u;
	for(vit i = g[u].begin(); i != g[u].end(); i++)
	{
		int v = *i;
		if(v != fa)
		{
			if(node_cnt % 2 == 0)
			{
				if(siz[v] == node_cnt / 2 || (siz[v] == node_cnt / 2 - 1 && siz[u] == node_cnt / 2))
				{
					res += v;
					break;
				}
				else if(siz[v] > node_cnt / 2)
				{
					res = get_gra(v, u);
					break;
				}
			}
			else if(siz[v] > node_cnt / 2)
			{
				res = get_gra(v, u);
				break;
			}
		}
	}
	return res;
}
int get_gra2(int u, int fa)
{
	if(node_cnt == 1)
	{
		return u;
	}
	int res = u;
	for(vit i = g[u].begin(); i != g[u].end(); i++)
	{
		int v = *i;
		if(v != fa)
		{
			if(node_cnt % 2 == 0)
			{
				if(siz2[v] == node_cnt / 2 || (siz2[v] == node_cnt / 2 - 1 && siz2[u] == node_cnt / 2))
				{
					res += v;
					break;
				}
				else if(siz2[v] > node_cnt / 2)
				{
					res = get_gra2(v, u);
					break;
				}
			}
			else if(siz2[v] > node_cnt / 2)
			{
				res = get_gra2(v, u);
				break;
			}
		}
	}
	return res;
}
std::pair<int, int> a[N];
int cnt;
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);

	int T;
	read(T);
	while(T--)
	{
		read(n);
		for(int i = 1; i <= n; i++)
		{
			g[i].clear();
		}
		cnt = 0;
		for(int i = 1; i < n; i++)
		{
			int u, v;
			read(u), read(v);
			add_edge(u, v);
			add_edge(v, u);
			a[++cnt] = std::make_pair(u, v);
		}
		ll ans = 0;
		for(int i = 1; i <= cnt; i++)
		{
			g[a[i].first].erase(a[i].second);
			g[a[i].second].erase(a[i].first);
			dfs(a[i].first, 0);
			dfs2(a[i].second, 0);
			node_cnt = siz[a[i].first];
			ans += get_gra(a[i].first, 0);
			node_cnt = siz2[a[i].second];
			ans += get_gra2(a[i].second, 0);
			g[a[i].first].insert(a[i].second);
			g[a[i].second].insert(a[i].first);
		}
		printf("%lld\n", ans);
	}
}
