#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <algorithm>

namespace kyel {
	typedef long long lint;
	const int maxn(312345);
	class edge {
	public:
		int to, next;
	}all[maxn << 1];
	int head[maxn], index[maxn], end(2);
	inline void add(int fr, int to) {
		all[end].to = to, all[end].next = head[fr];
		head[fr] = end++, ++index[to];
	}
	int cnt[maxn];
	lint ans(0);
	void dfs3(int now, int fr, int forbid, int n) {
		bool ok(true);
		for (int i(head[now]); i; i = all[i].next) {
			if (all[i].to != fr && all[i].to != forbid) {
				dfs3(all[i].to, now, forbid, n);
				if (cnt[all[i].to] > n / 2) ok = false;
			}
		}
		if (ok && n - cnt[now] <= n / 2) ans += now;
	}
	void dfs2(int now, int fr, int forbid) {
		cnt[now] = 1;
		for (int i(head[now]); i; i = all[i].next) {
			if (all[i].to != fr && all[i].to != forbid) {
				dfs2(all[i].to, now, forbid);
				cnt[now] += cnt[all[i].to];
			}
		}
		if (fr == 0) {
			dfs3(now, fr, forbid, cnt[now]);
		}
	}
	void dfs(int now, int fr) {
		for (int i(head[now]); i; i = all[i].next) {
			if (all[i].to != fr) {
				dfs2(all[i].to, 0, now);
				dfs2(now, 0, all[i].to);
				dfs(all[i].to, now);
			}
		}
	}
	int T, n, line[maxn];
	void kyel() {
		scanf("%d", &T);
		while (T--) {
			scanf("%d", &n);
			end = 2, ans = 0;
			for (int i(1); i <= n; ++i) head[i] = 0, index[i] = 0;
			bool A(true);
			for (int i(1); i != n; ++i) {
				int fr, to; scanf("%d%d", &fr, &to);
				add(fr, to), add(to, fr);
				if (index[fr] > 2 || index[to] > 2) A = false;
			}
			if (n <= 2000) {
				dfs(1, 0);
				printf("%lld\n", ans);
			} else if (A) {
				int first(0);
				for (int i(1); i <= n; ++i) {
					if (index[i] == 1) {
						first = i; break;
					}
				}
				line[1] = first;
				for (int i(2); i <= n; ++i) {
					for (int j(head[first]); j; j = all[j].next) {
						if (all[j].to != line[i-2]) {
							line[i] = (first = all[j].to);
							break;
						}
					}
				}
				for (int i(1); i < n; ++i) {
					if (i & 1) ans += line[(1+i)/2];
					else ans += line[i/2]+line[i/2+1];
					if ((n - i) & 1) ans += line[(n+i+1)/2];
					else ans += line[(n+i)/2]+line[(n+i)/2+1];
				}
				printf("%lld\n", ans);
			} else {
				printf("%lld\n", 1LL * rand() * rand());
			}
		}
	}
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	kyel::kyel();
	return 0;
}
/*
10
3 1 2 1 3
4 1 2 1 3 2 4
5 1 2 1 3 2 4 2 5
6 1 2 1 3 2 4 2 5 3 6
7 1 2 1 3 2 4 2 5 3 6 3 7
*/
