#include <cstdio>
#include <cstdlib>
#include <cstring>

#include <algorithm>

namespace kyel {
	typedef long long lint;
	int n, t;
	lint f[5123], dp[5123][5123];
	inline lint sqr(lint x) {
		return x * x;
	}
	inline void getmin(lint& a, lint b) {
		if (b < 0) return;
		if (a > b || a < 0) a = b;
	}
	lint inf(11234567812345LL);
	void solve1() {
		for (int i(0); i <= n; ++i) for (int j(0); j <= n; ++j)
			dp[i][j] = -inf;
		dp[0][1] = sqr(f[1]);
		for (int i(2); i <= n; ++i) {
			for (int j(i-1); j >= 1; --j) {
				for (int k(j-1); k >= 0; --k) {
					if (f[i] - f[j] >= f[j] - f[k]) {
						if (dp[k][j] >= 0)
							getmin(dp[j][i], dp[k][j] + sqr(f[i]-f[j]));
					} else break;
				}
			}
			dp[0][i] = sqr(f[i]);
		}
		lint ans(-inf);
		for (int i(n-1); i >= 0; --i)
			getmin(ans, dp[i][n]);
		printf("%lld\n", ans);
	}
	void solve2() {
		for (int i(0); i <= n; ++i) for (int j(0); j <= n; ++j)
			dp[i][j] = -inf;
		dp[0][1] = sqr(f[1]);
		for (int i(2); i <= n; ++i) {
			int k(i-2);
			lint min(-inf);
			for (int j(i-1); j >= 1; --j) {
				getmin(dp[j][i], min + sqr(f[i] - f[j]));
				for (; k >= 0; --k) {
					if (f[i] - f[j] >= f[j] - f[k]) {
						if (dp[k][j] >= 0) {
							getmin(dp[j][i], dp[k][j] + sqr(f[i]-f[j]));
							getmin(min, dp[k][j]);
						}
					} else break;
				}
			}
			dp[0][i] = sqr(f[i]);
		}
		lint ans(-inf);
		for (int i(n-1); i >= 0; --i)
			getmin(ans, dp[i][n]);
		printf("%lld\n", ans);
	}
	void kyel() {
		scanf("%d%d", &n, &t);
		for (int i(1); i <= n; ++i) {
			scanf("%lld", &f[i]);
			f[i] += f[i-1];
		}
		if (n <= 400) solve1();
		else solve2();
	}
}
int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	kyel::kyel();
	return 0;
}

