#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <vector>
using namespace std;

namespace Solver
{
    const int maxn = 40000005;
    int a[maxn];
    int n;
    long long ans = -1;
    int prefix[maxn];
    int pars[maxn], pars_cnt;

    typedef long long LL;
    inline LL sum(int a, int b)
    {
        return prefix[b] - prefix[a - 1];
    }

    inline void make_prefix()
    {
        for (int i = 1; i <= n; i++)
            prefix[i] = prefix[i - 1] + a[i];
    }

    void dfs(int curr, long long currans)
    {
        int next = curr;
        if (ans != -1 && currans > ans)
            return;
        if (curr > n)
        {
            if (ans == -1)
            	ans = currans;
            else
                ans = min(ans, currans);
            return;
        }
        while (sum(curr, next) < pars[pars_cnt] && next <= n)
            next++;
        for (;next <= n; next++)
        {
            pars[++pars_cnt] = sum(curr, next);
            dfs(next + 1, currans + sum(curr, next) * sum(curr, next));
            pars_cnt--;
        }
    }
}

namespace Readers
{
    const int maxn = 40000005;
    typedef long long LL;
    LL b[maxn];
    LL p[maxn], l[maxn], r[maxn];

    inline void normal_read()
    {
        for (int i = 1; i <= Solver::n; i++)
            scanf("%d", &Solver::a[i]);
    }

    inline void generate_data()
    {
        LL x, y, z, m;
        using Solver::n;
        using Solver::a;
        scanf("%lld %lld %lld %lld %lld %lld", &x, &y, &z, &b[1], &b[2], &m);
        const LL mod = 1LL << 30;
        for (int i = 3; i <= n; i++)
            b[i] = (x * b[i - 1] + y * b[i - 2] + z) % mod;
        for (int i = 1; i <= m; i++)
            scanf("%lld %lld %lld", &p[i], &l[i], &r[i]); 
        p[0] = 0;
        for (int j = 1; j <= m; j++)
        {
            for (int i = p[j - 1] + 1; i <= p[j]; i++)
                a[i] = (b[i] % (r[j] - l[j] + 1)) + l[j];
        }
    }

    inline void read()
    {
        int type;
        scanf("%d %d", &Solver::n, &type);
        if (type == 0)
            normal_read();
        else
            generate_data();
    }
}

int main()
{
    freopen("partition.in", "r", stdin);
    freopen("partition.out", "w", stdout);
    Readers::read();
    Solver::make_prefix();
    Solver::dfs(1, 0LL);
    printf("%lld\n", Solver::ans);
    fclose(stdin);
    fclose(stdout);
    return 0;
}
