#include <bits/stdc++.h>
using namespace std;

#define ll long long

const int N = 6e5 + 9;

inline ll read() {
	ll x = 0, F = 1; 
	char op = getchar();
	while (op < '0' || op > '9') {
		if (op == '-') F = -1; 
		op = getchar();
	}
	while (op >= '0' && op <= '9') {
		x = (x << 1) + (x << 3) + (op & 15);
		op = getchar();
	}
	return x * F;
}

ll T, n, tot;
ll head[N];

struct Edge {
  ll to, nxt;
  bool del;
} e[N];

void addedge(ll u, ll v) {
	e[++ tot] = (Edge) {v, head[u], 0};
	head[u] = tot;
}


void init() {
	tot = 1;
	memset(head, 0, sizeof(head));
}

namespace Subtask1 {

ll ans, res;

ll f[N], sz[N];
bool flag[N];

void dfs(ll u, ll fa) {
	register ll i;
	
	sz[u] = 1, f[u] = 0;
	flag[u] = 1;
	for (i = head[u]; i; i = e[i].nxt) {
		ll v = e[i].to;
		if (v == fa) continue ;
		if (e[i].del) continue ;
		dfs(v, u);
		sz[u] += sz[v];
		f[u] = max(f[u], sz[v]);
	} 
	
}

ll FindMid(ll rt) {
	register ll i;
	
	for (i = 1; i <= n; i ++) flag[i] = 0;
	res = 0;
	dfs(rt, 0);
	
	for (i = 1; i <= n; i ++) {
		if (flag[i]) {
			f[i] = max(f[i], sz[rt] - sz[i]);
			if (f[i] <= (sz[rt] >> 1)) res += i;
		} 
	}
	
	return res;
}

void work() {
	register ll i;
	
	ans = 0;
	e[2].del = e[3].del = 1;
	for (i = 2; i <= tot; i += 2) {
		e[i].del = e[i ^ 1].del = 1;
		ans += FindMid(e[i].to) + FindMid(e[i ^ 1].to);
    e[i].del = e[i ^ 1].del = 0;
	}
	printf("%lld\n", ans);
	return ;
}

}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	
	register ll i;
	T = read();
	while (T --) {
		init();
		n = read();
		for (i = 1; i < n; i ++) {
			ll u = read(), v = read();
			addedge(u, v), addedge(v, u);
		}
		Subtask1 :: work();
	}
	return 0;
}
