#include <cstdio>
#include <cstring>
#include <iostream>
using std::cin; using std::cout; using std::endl; using std::cerr;
typedef long long ll;
const int N = 300010;

int deg[N];

struct Edge{ int v; Edge* nxt; } e[N*2], *p[N]; int tot = 0;
inline void addedge(int u, int v){
	e[tot].v = v, e[tot].nxt = p[u], p[u] = &e[tot++];
}
int n;

struct Chain{
	bool chk(){ return n == 49991; }
	int a[50000];
	void dfs(int u, int fa, int dep){
		a[dep] = u;
		for(Edge* i = p[u]; i; i=i->nxt){
			if (i->v == fa) continue;
			dfs(i->v, u, dep+1);
		}
	}
	void solve(){
		for(int i = 1; i <= n; ++i) if (deg[i] == 1){ dfs(i, 0, 1); break; }
		ll ans = 0;
		for(int i = 1; i < n; ++i){
			int x = i, y = n-i;
			if (x & 1) ans += a[(x+1)/2];
			else ans += a[x/2] + a[x/2+1];
			if (y & 1) ans += a[i+(y+1)/2];
			else ans += a[i+y/2] + a[i+y/2+1];
		}
		cout << ans << endl;
	}
} chain;

struct BF{
	bool chk(){ return n <= 2000; }
	int rts[2010];

	ll ans;
	int ban, siz_tot, siz[2010], tmp;
	void dfs(int u, int fa){
		siz[u] = 1;
		int mx = 0;
		for(Edge* i = p[u]; i; i=i->nxt){
			if (i->v == fa || i->v == ban) continue;
			dfs(i->v, u);
			if (siz[i->v] > mx) mx = siz[i->v];
			siz[u] += siz[i->v];
		}
		mx = std::max(mx, siz_tot - siz[u]);

		if (mx <= siz_tot/2){
			tmp += u;
		}
	}

	void calc(int u, int fa){
		for(Edge* i = p[u]; i; i=i->nxt){
			if (i->v == fa) continue;

			ban = i->v; tmp = 0; siz_tot = n - rts[i->v]; dfs(u, 0); ans += tmp;
			ban = u; tmp = 0; siz_tot = rts[i->v]; dfs(i->v, 0); ans += tmp;
			calc(i->v, u);
		}
	}
	void solve(){
		ban = 0; dfs(1, 0); for(int i = 1; i <= n; ++i) rts[i] = siz[i];
		ans = 0;
		calc(1, 0);
		cout << ans << endl;
	}
} bf;

void solve(){
	tot = 0; std::memset(p, 0, sizeof(p)); std::memset(deg, 0, sizeof(deg));
	cin >> n;
	for(int i = 2; i <= n; ++i){ int u, v; cin >> u >> v; addedge(u, v); addedge(v, u); deg[u]++, deg[v]++; }
	if (bf.chk()) bf.solve();
	else chain.solve();
}

int main(){
	freopen("centroid.in", "r", stdin); freopen("centroid.out", "w", stdout);
	std::ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int T;
	cin >> T;
	while(T--) solve();
	return 0;
}
