// T3 centroid
// RP++
#include<bits/stdc++.h>
using namespace std;
typedef long long LL;
const int N = 3e5 + 10, M = N<<1;
int T, n, dgr[N], dpt[N];
int ex[N], ey[N], h[N], ecnt, v[M], nxt[M];
LL ans;

void read(int &x){
	x = 0; char c = getchar();
	while (c < '0' || c > '9') c = getchar();
	while (c >= '0' && c <= '9') x = (x<<3)+(x<<1)+c-'0', c = getchar();
}

void _add(int x, int y){
	nxt[++ecnt] = h[x]; v[ecnt] = y;
	h[x] = ecnt;
}

namespace Solver1
{
	const int NN = 2000 + 10;
	int nsiz[NN];
	int siz[NN], tot;
	void dfs1(int u, int fa){
		nsiz[u] = 1;
		dpt[u] = dpt[fa]+1;
		for (int i = h[u]; i; i = nxt[i])
			if (v[i] != fa){
				dfs1(v[i], u);
				nsiz[u] += nsiz[v[i]];
			}
		return;
	}
	void dfs(int u, int fa){
		int son = 0;
		siz[u] = 1;
		for (int i = h[u]; i; i = nxt[i])
			if (v[i] != fa){
				dfs(v[i], u);
				son = max(son, siz[v[i]]);
				siz[u] += siz[v[i]];
			}
		son = max(son, tot-siz[u]);
		if (son <= tot/2) ans += u;
		return;
	}
	void main(){
		ans = 0;
		dfs1(1, 0);
		for (int i = 1; i < n; ++ i){
			int x = ex[i], y = ey[i];
			if (dpt[x] > dpt[y]) swap(x, y);
			tot = nsiz[y]; dfs(y, x);
			tot = n-nsiz[y]; dfs(x, y);
		}
		printf("%lld\n", ans);
		return;
	}
}

namespace Solver2
{
	const int NN = 5e4 + 10;
	int a[NN], root;
	void main(){
		memset(dgr, 0, sizeof dgr);
		for (int i = 1; i < n; ++ i)
			dgr[ex[i]]++, dgr[ey[i]]++;
		for (int i = 1; i <= n; ++ i)
			if (dgr[i] == 1){
				root = i;
				break;
			}
		for (int i = root, j = 1; j <= n; ++ j){
			a[j] = i;
			for (int k = h[i]; k; k = nxt[k])
				if (v[k] != a[j-1]){
					i = v[k];
					break;
				}
		}
		ans = 0;
		for (int i = 1; i < n; ++ i){
			if (i&1) ans += a[i/2+1];
			else ans += a[i/2]+a[i/2+1];
		}
		for (int i = 1, qw = n/2; i <= qw; ++ i)
			swap(a[i], a[n-i+1]);
		for (int i = 1; i < n; ++ i){
			if (i&1) ans += a[i/2+1];
			else ans += a[i/2]+a[i/2+1];
		}
		printf("%lld\n", ans);
		return;
	}
}

namespace Solver3
{
	int root, nsiz[N], bel[N], c[8], cn, siz[N][2], sizn[N], bbel[N];
	void dfs1(int u, int fa, int b, int bb){
		dpt[u] = dpt[fa]+1;
		if (dpt[u] <= 3) c[++cn] = u;
		nsiz[u] = 1;
		if (b == -1) b = 0;
		else if (b == 0) b = u;
		bel[u] = b;
		if (bb < 0) bb++;
		else if (bb == 0) bb = u;
		bbel[u] = bb;
		for (int i = h[u]; i; i = nxt[i])
			if (v[i] != fa){
				dfs1(v[i], u, b, bb);
				nsiz[u] += nsiz[v[i]];
				siz[u][++sizn[u]] = nsiz[v[i]];
			}
		return;
	}
	bool check(int u){
		for (int i = 1; i <= sizn[u]; ++ i)
			if (siz[u][i] > nsiz[u]/2)
				return false;
		return true;
	}
	bool check1(int u, int vv){
		int nn = n - nsiz[vv], tmp;
		for (int i = h[u]; i; i = nxt[i]){
			if (dpt[v[i]] > dpt[u]){
				tmp = nsiz[v[i]];
				if (dpt[v[i]] == 2 && bel[vv] == bel[v[i]]) tmp -= nsiz[vv];
				if (dpt[v[i]] == 3 && bbel[vv] == bbel[v[i]]) tmp -= nsiz[vv];
				if (tmp > nn/2) return false;
			}
			else{
				tmp = n-nsiz[u];
				if (bel[vv] != bel[u]) tmp -= nsiz[vv];
				if (tmp > nn/2) return false;
			}
		}
		return true;
	}
	void get_ans(int v){
		int cnt = 0;
		for (int i = 1; i <= cn; ++ i){
			int u = c[i];
			if (check1(u, v)) ans += u, cnt++;
			if (cnt >= 2) break;
		}
	}
	void dfs(int u, int fa){
		if (check(u)) ans += u;
		if (fa != 0) get_ans(u);
		for (int i = h[u]; i; i = nxt[i])
			if (v[i] != fa){
				if (check(v[i]) && nsiz[u]-nsiz[v[i]] <= nsiz[u]/2) ans += v[i];
				dfs(v[i], u);
			}
	}
	void main(){
		memset(dgr, 0, sizeof dgr);
		for (int i = 1; i < n; ++ i)
			dgr[ex[i]]++, dgr[ey[i]]++;
		for (int i = 1; i <= n; ++ i)
			if (dgr[i] == 2){
				root = i;
				break;
			}
		cn = 0;
		memset(sizn, 0, sizeof sizn);
		dfs1(root, 0, -1, -2);
		ans = 0;
		dfs(root, 0);
		printf("%lld\n", ans);
	}
}

int main()
{
	freopen("centroid.in", "r", stdin); freopen("centroid.out", "w", stdout);
	for (read(T); T--; ){
		read(n);
		memset(h, 0, sizeof h); ecnt = 1;
		for (int i = 1; i < n; ++ i){
			read(ex[i]); read(ey[i]);
			_add(ex[i], ey[i]); _add(ey[i], ex[i]);
		}
		if (n <= 2000) Solver1::main();
		else if (n%10 == 1) Solver2::main();
		else if (n%10 == 3) Solver3::main();
	}
	return 0;
}
