#include <cstdio>
#include <cstring>
#include <vector>

using namespace std;

vector<int> e[300010];
int T, n, u, v;
int f[300010], s[300010], g[300010][3];
bool flag[300010], onp[300010];
long long ans;

void dfs1(int x, int _f) {
    f[x] = _f;
    s[x] = 1;
    int l = e[x].size();
    for (int i = 0; i < l; ++i) {
        if (e[x][i] != _f) {
            dfs1(e[x][i], x);
            s[x] += s[e[x][i]];
        }
    }
}

void dfs2(int x, int _s) {
    if (s[x] != _s && s[x] * 2 > _s) {
        flag[f[x]] = 0;
    }
    int l = e[x].size();
    for (int i = 0; i < l; ++i) {
        if (e[x][i] != f[x]) {
            dfs2(e[x][i], _s);
        }
    }
    if (flag[x] && s[x] * 2 >= _s) {
        ans += x;
    }
}

void dfs3(int x, int stop, int _s) {
    int l = e[x].size();
    for (int i = 0; i < l; ++i) {
        if (e[x][i] != f[x]) {
            if (e[x][i] != stop) {
                dfs3(e[x][i], stop, _s);
            }
            if (onp[e[x][i]]) {
                onp[x] = 1;
            }
        }
    }
    if (flag[x] && (x == 1 || (s[x] - onp[x] * s[stop]) * 2 >= _s)) {
        ans += x;
    }
    if ((s[x] - onp[x] * s[stop]) * 2 > _s) {
        flag[f[x]] = 0;
    }
}

void dfs4(int x, int c) {
    s[c] = x;
    if (c == 1 || s[c - 1] != e[x][0]) {
        dfs4(e[x][0], c + 1);
    } else if (e[x].size() == 2) {
        dfs4(e[x][1], c + 1);
    }
}

int main() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    scanf("%d", &T);
    while (T--) {
        scanf("%d", &n);
        for (int i = 1; i <= n; ++i) {
            e[i].clear();
        }
        for (int i = 1; i < n; ++i) {
            scanf("%d%d", &u, &v);
            e[u].push_back(v);
            e[v].push_back(u);
        }
        if (n % 10 == 1) {
            ans = 0;
            for (int i = 1; i <= n; ++i) {
                if (e[i].size() == 1) {
                    dfs4(i, 1);
                    for (int j = 1; j < n; ++j) {
                        ans += (j % 2 == 1 ? s[j / 2 + 1] : s[j / 2] + s[j / 2 + 1]) +
                               ((n - j) % 2 == 1 ? s[(n - j) / 2 + j + 1] : s[(n - j) / 2 + j] + s[(n - j) / 2 + j + 1]);
                    }
                    break;
                }
            }
            printf("%lld\n", ans);
            continue;
        } else if (n % 10 == 3) {
            ans = n * (n + 1ll) / 2;
            for (int i = 1; i <= n; ++i) {
                if (e[i].size() == 2) {
                    long long half = n / 2;
                    ans += i * half + e[i][0] * half + e[i][1] * half;
                    break;
                }
            }
            printf("%lld\n", ans);
            continue;
        }
        dfs1(1, 0);
        ans = 0;
        for (int i = 2; i <= n; ++i) {
            memset(flag + 1, 1, sizeof(bool) * n);
            memset(onp + 1, 0, sizeof(bool) * n);
            onp[i] = 1;
            dfs2(i, s[i]);
            dfs3(1, i, n - s[i]);
        }
        printf("%lld\n", ans);
    }
    fclose(stdin);
    fclose(stdout);
    return 0;
}