#include <cstdio>
#include <cstring>
#include <algorithm>
using namespace std;
int ed_cnt;
struct Edge {
	int nxt, to;
} ed[2005];
int fir[2005];
struct Road {
	int u, v;
} rd[2005];
int siz[2005], mxs[2005];
bool flag[2005];
inline void clear_edge() {
	ed_cnt = 0, memset(fir, 0, sizeof fir);
}
inline void add_edge(int u, int v) {
	ed[++ed_cnt] = (Edge){ fir[u], v }, fir[u] = ed_cnt;
}
void dfs(int u, int fa) {
	siz[u] = 1, mxs[u] = 0;
	for (int e = fir[u]; e; e = ed[e].nxt) {
		int v = ed[e].to;
		if (v == fa)
			continue;
		dfs(v, u);
		siz[u] += siz[v];
		mxs[u] = max(mxs[u], siz[v]);
	}
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout); 
	int cas;
	scanf("%d", &cas);
	while (cas--) {
		int n;
		scanf("%d", &n);
		clear_edge();
		for (int e = 1; e < n; ++e) {
			int u, v;
			scanf("%d %d", &u, &v);
			add_edge(u, v), add_edge(v, u);
			rd[e] = (Road){ u, v };
		}
		int ans = 0;
		for (int e = 1; e < n; ++e) {
			memset(siz, 0, sizeof siz);
			int du = rd[e].u, dv = rd[e].v;
			dfs(du, dv);
			memset(flag, false, sizeof flag);
			int sum1 = 0, mn = n;
			for (int u = 1; u <= n; ++u) {
				if (!siz[u]) {
					flag[u] = true;
					continue;
				}
				mxs[u] = max(mxs[u], siz[du] - siz[u]);
				if (mxs[u] < mn)
					sum1 = u, mn = mxs[u];
				else if (mxs[u] == mn)
					sum1 += u;
			}
			dfs(dv, du);
			int sum2 = 0;
			mn = n;
			for (int u = 1; u <= n; ++u) {
				if (!flag[u])
					continue;
				mxs[u] = max(mxs[u], siz[dv] - siz[u]);
				if (mxs[u] < mn)
					sum2 = u, mn = mxs[u];
				else if (mxs[u] == mn)
					sum2 += u;
			}
			ans += sum1 + sum2;
		}
		printf("%d\n", ans);
	}
	return 0;
}
