/*
  zzf 和 wrq 在一起！
  （捂脸逃）
*/
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <utility>
const int MAXN = 3e5 + 10;
typedef long long LL;

struct Edge {
  int v, next;
}edge[MAXN << 1];
int head[MAXN], tail, n;
void insert(int u, int v) {
  edge[++tail] = (Edge) {v, head[u]}; head[u] = tail;
}

namespace solver1 {
  LL ans;
  int totsz;
  int sz[MAXN];
  int cnt[MAXN];
  void dfs1(int u, int fa) {
    sz[u] = 1;
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == fa) continue;
      dfs1(v, u);
      sz[u] += sz[v];
    }
  }

  void dfs2(int u, int fa) {
    int maxsz = totsz - sz[u];
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == fa) continue;
      dfs2(v, u);
      maxsz = std::max(maxsz, sz[v]);
    }
    if (maxsz <= totsz / 2) ans += u, cnt[u]++;
  }
  void main() {
    ans = 0;
    for (int i = 1; i < n; i++) {
      int u = edge[i << 1].v, v = edge[i << 1 | 1].v;
      dfs1(u, v);
      totsz = sz[u];
      dfs2(u, v);

      dfs1(v, u);
      totsz = sz[v];
      dfs2(v, u);
    }

    printf("%lld\n", ans);
    //for (int i = 1; i <= n; i++) fprintf(stderr, "%d ", cnt[i]);
    //fprintf(stderr, "\n");
  }
}
namespace solver2 {
  int deg[MAXN];
  int seq[MAXN], cnt;
  void dfs(int u, int fa) {
    seq[++cnt] = u;
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == fa) continue;
      dfs(v, u);
    }
  }
  void main() {
    memset(deg, 0, sizeof deg);
    for (int i = 1; i < n; i++) {
      deg[edge[i << 1].v]++;
      deg[edge[i << 1 | 1].v]++;
    }

    cnt = 0;
    LL ans = 0;
    for (int i = 1; i <= n; i++) {
      if (deg[i] == 1) {
        dfs(i, 0);
        break;
      }
    }

    for (int i = 1; i < n; i++) {
      if (i & 1) {
        ans += seq[(i + 1) >> 1];
      } else {
        ans += seq[i >> 1] + seq[(i >> 1) + 1];
      }
    }

    std::reverse(seq + 1, seq + n + 1);
    
    for (int i = 1; i < n; i++) {
      if (i & 1) {
        ans += seq[(i + 1) >> 1];
      } else {
        ans += seq[i >> 1] + seq[(i >> 1) + 1];
      }
    }

    printf("%lld\n", ans);
  }
}
namespace solver3 {
  int deg[MAXN];
  LL ans = 0;
  void dfs(int u, int fa, int dep) {
    ans += dep <= 2 ? 1ll * ((n + 1) / 2) * u : u;
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == fa) continue;
      dfs(v, u, dep + 1);
    }
  }
  void main() {
    memset(deg, 0, sizeof deg);
    for (int i = 1; i < n; i++) {
      deg[edge[i << 1].v]++;
      deg[edge[i << 1 | 1].v]++;
    }

    ans = 0;
    for (int i = 1; i <= n; i++) {
      if (deg[i] == 2) dfs(i, 0, 1);
    }
    printf("%lld\n", ans);
  }
}

namespace solver4 {
  namespace subtask {
    int totsz;
    int sz[MAXN];
    std::vector<int> ans;
    void dfs1(int u, int fa) {
      sz[u] = 1;
      for (int i = head[u]; i; i = edge[i].next) {
        int v = edge[i].v;
        if (v == fa) continue;
        dfs1(v, u);
        sz[u] += sz[v];
      }
    }
    
    void dfs2(int u, int fa) {
      int maxsz = totsz - sz[u];
      for (int i = head[u]; i; i = edge[i].next) {
        int v = edge[i].v;
        if (v == fa) continue;
        dfs2(v, u);
        maxsz = std::max(maxsz, sz[v]);
      }
      if (maxsz <= totsz / 2) ans.push_back(u);
    }
    std::vector<int> main(int u, int v) {
      ans.clear();
      dfs1(u, v);
      totsz = sz[u];
      dfs2(u, v);
      return ans;
    }    

  }
  
  int sz[MAXN];
  int maxsz[MAXN], smaxsz[MAXN];
  int maxp[MAXN], smaxp[MAXN];
  LL ans = 0;
  int fa[MAXN];
  int dfn[MAXN], en[MAXN];
  void dfs1(int u, int f) {
    static int clk = 0;
    dfn[u] = ++clk;
    sz[u] = 1; maxsz[u] = 0; maxp[u] = 0;
    smaxsz[u] = smaxp[u] = 0;
    fa[u] = f;
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == f) continue;
      dfs1(v, u);
      sz[u] += sz[v];
      if (sz[v] > maxsz[u]) {
        smaxsz[u] = maxsz[u];
        smaxp[u] = maxp[u];
        maxsz[u] = sz[v];
        maxp[u] = v;
      } else if (sz[v] > smaxsz[u]) {
        smaxsz[u] = sz[v];
        smaxp[u] = v;
      }
      //maxsz[u] = std::max(maxsz[u], sz[v]);
      //if (maxsz[u] == sz[v]) maxp[u] = v;
    }
    en[u] = clk;
  }


  std::vector<int> dfs2(int u, int f) {
    std::vector<int> res;
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == f) continue;
      std::vector<int> seq = dfs2(v, u);
      for (int i = 0; i < (int) seq.size(); i++) {
        int x = seq[i];
        if (maxsz[x] <= sz[u] / 2 &&
            sz[u] - sz[x] <= sz[u] / 2) {
          res.push_back(x);
        }
        for (x = fa[x]; x != u; x = fa[x]) {
          if (maxsz[x] > sz[u] / 2) break;
          if (maxsz[x] <= sz[u] / 2 &&
              sz[u] - sz[x] <= sz[u] / 2) {
            res.push_back(x);
          }
        }
      }
    }
    if (maxsz[u] <= sz[u] / 2) {
      res.push_back(u);
    }

    std::sort(res.begin(), res.end());
    res.erase(std::unique(res.begin(), res.end()), res.end());
    if (f) {
      for (int i = 0; i < (int) res.size(); i++) {
        //        fprintf(stderr, "%d %d\n", u, res[i]);
        ans += res[i];
      }
    }

    return res;
  }

  std::vector <int> dfs3(int u, int f) {
    bool flag = 0;

    int totsz = sz[1] - sz[u];

    std::vector<int> res;
    for (int i = head[u]; i; i = edge[i].next) {
      int v = edge[i].v;
      if (v == f) continue;
      std::vector <int> seq = dfs3(v, u);

      if (!flag && f) {
        for (int i = 0; i < (int) seq.size(); i++) {
          int x = seq[i];

          while(x) {
            if (dfn[u] <= dfn[x] && dfn[x] <= en[u]) break;
            if (totsz - sz[x] > totsz / 2) break;
            if (((dfn[x] <= dfn[u] && dfn[u] <= en[x]) ?
                 smaxsz[x] : maxsz[x]) <= totsz / 2 &&
                totsz - sz[x] <= totsz / 2) {
              res.push_back(x);
              flag = 1;
            }

            x = maxp[x];
          }
        }
      }
    }

    if (!flag && f) {
      res = subtask::main(f, u);
    }

    std::sort(res.begin(), res.end());
    res.erase(std::unique(res.begin(), res.end()), res.end());
    for (int i = 0; i < (int) res.size(); i++) {
      //fprintf(stderr, "%d %d %d\n", u, res[i], flag);
      ans += res[i];
    }

    return res;

  }


  void main() {
    ans = 0;
    dfs1(1, 0);

    dfs2(1, 0);
    //fprintf(stderr, "%lld\n", ans);
    dfs3(1, 0);

    printf("%lld\n", ans);
  }
}
int main() {
#ifndef LOCAL
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
#endif
  int t;
  scanf("%d", &t);
  while(t--) {
    tail = 1;
    memset(head, 0, sizeof head);
    scanf("%d", &n);
    for (int i = 1; i < n; i++) {
      int u, v;
      scanf("%d%d", &u, &v);
      insert(u, v);
      insert(v, u);
    }

    //solver4::main(); continue;
    if (n <= 2000) {
      solver1::main();
    } else if (n == 49991) {
      solver2::main();
    } else if (n == 262143) {
      solver3::main();
    } else {
      solver4::main();
    }
  }
}
