#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;
typedef long long LL;
const int N=1e6;
int t,n,tot=0;
struct data {
    int u,v;
}e[N+10];
struct edges {
    int next,num;
}edge[N+10];
int head[N+10];
LL ans;
void Add(int u,int v) {
    edge[++tot].next=head[u];
    edge[tot].num=v;
    head[u]=tot;
}

namespace r {
    int sz[N+10],d[N+10],hv[N+19],hv2[N+10];
    int nxt[N+10][21],fa[N+10];
    int beg[N+10],en[N+10];
    int dx;
    void Dfs(int x,int fat,int deep) {
        beg[x]=++dx;
        fa[x]=fat;
        d[x]=deep;
        sz[x]=1;
        hv[x]=-1;
        hv2[x]=-1;
        for (int i=head[x];i!=-1;i=edge[i].next) {
            int kx=edge[i].num;
            if (kx==fat) continue;
            Dfs(kx,x,deep+1);
            sz[x]+=sz[kx];
            if (hv[x]==-1) hv[x]=kx;
            else 
                if (sz[kx]>sz[hv[x]]) {
                    hv2[x]=hv[x];
                    hv[x]=kx;
                }
                else if (hv2[x]==-1||sz[kx]>sz[hv2[x]]) hv2[x]=kx;
        }
        nxt[x][0]=hv[x];
        en[x]=++dx;
    }
    void Find1(int x) {
        int SZ=sz[x];
        int px=x;
        for (int i=20;i>=0;i--) {
            if (nxt[px][i]==-1) continue;
            if (sz[nxt[px][i]]<(SZ+1)/2) continue;
            px=nxt[px][i];
        }
        ans+=px;
        if (sz[px]==SZ/2) ans+=fa[px];
    }
    bool Isfa(int x,int y) {
        if (beg[x]<=beg[y]&&en[x]>=en[y]) return 1;
        return 0;
    }
    void Find2(int x) {
        int SZ=n-sz[x];
        int px=1;
        for (int i=20;i>=0;i--) {
            if (nxt[px][i]==-1) continue;
            if (Isfa(x,nxt[px][i])) continue;
            bool ck=0;
            if (sz[nxt[px][i]]-sz[x]>=(SZ+1)/2) ck=1;
            if (sz[nxt[px][i]]>=(SZ+1)/2&&!Isfa(nxt[px][i],x)) ck=1;
            if (!ck) continue;
            px=nxt[px][i];
        }
        if (sz[hv2[px]]>=(SZ+1)/2) {
            px=hv2[px];
            for (int i=20;i>=0;i--) {
                if (nxt[px][i]==-1) continue;
                if (sz[nxt[px][i]]<(SZ+1)/2) continue;
                px=nxt[px][i];
            }
        }
        ans+=px;
        int tsz=sz[px];
        if (Isfa(px,x)) tsz-=sz[x];
        if (tsz==SZ/2) ans+=fa[px];
    }
    void Solve() {
        dx=0;
        Dfs(1,-1,1);
        for (int i=1;i<=20;i++)
            for (int j=1;j<=n;j++)
                nxt[j][i]=nxt[nxt[j][i-1]][i-1];
        ans=0;
        for (int i=1;i<n;i++) {
            int u=e[i].u,v=e[i].v;
            if (d[u]<d[v]) swap(u,v);
            Find1(u);
            Find2(u);
        }
        printf("%lld\n",ans);
    }
}
namespace brute {
    int sz[N+10],max0[N+10];
    void Dfs(int x,int fat) {
        sz[x]=1;
        max0[x]=0;
        for (int i=head[x];i!=-1;i=edge[i].next) {
            int kx=edge[i].num;
            if (kx==fat) continue;
            Dfs(kx,x);
            sz[x]+=sz[kx];
            max0[x]=max(max0[x],sz[kx]);
        }
    }
    void Dfs2(int x,int fat,int SZ) {
        for (int i=head[x];i!=-1;i=edge[i].next) {
            int kx=edge[i].num;
            if (kx==fat) continue;
            Dfs2(kx,x,SZ);
        }
        if (max(max0[x],SZ-sz[x])<=SZ/2) ans+=x;
    }
    void Solve() {
        ans=0;
        for (int i=1;i<n;i++) {
            Dfs(e[i].u,e[i].v);
            Dfs(e[i].v,e[i].u);
            Dfs2(e[i].u,e[i].v,sz[e[i].u]);
            Dfs2(e[i].v,e[i].u,sz[e[i].v]);
        }            
        printf("%lld\n",ans);
    }
}
namespace link {
    int deg[N+10],val[N+10];
    void Dfs(int x,int fat,int num) {
        val[num]=x;
        for (int i=head[x];i!=-1;i=edge[i].next) {
            int kx=edge[i].num;
            if (kx==fat) continue;
            Dfs(kx,x,num+1);
        }
    }
    void Solve() {
        memset(deg,0,sizeof(deg));
        for (int i=1;i<n;i++) {
            deg[e[i].u]++;
            deg[e[i].v]++;
        }
        for (int rt=1;rt<=n;rt++) {
            if (deg[rt]==2) continue;
            Dfs(rt,-1,1);
            break;
        }
        ans=0;
        for (int i=1;i<n;i++) {
            if (i%2==0) ans+=val[i/2]+val[i/2+1];
            else ans+=val[i/2+1];
            if ((n-i)%2==0) ans+=val[(n+i+1)/2]+val[(n+i+1)/2+1];
            else ans+=val[(n+i+1)/2];
        }
        printf("%lld\n",ans);
    }
}
namespace tree {
    int deg[N+10];
    void Solve() {
        memset(deg,0,sizeof(deg));
        for (int i=1;i<n;i++) {
            deg[e[i].u]++;
            deg[e[i].v]++;
        }
        ans=1+n;
        ans*=n;
        ans/=2;
        LL value=0;
        for (int rt=1;rt<=n;rt++) {
            if (deg[rt]!=2) continue;
            value+=rt;
            for (int i=head[rt];i!=-1;i=edge[i].next)
                value+=edge[i].num;
            break;
        }
        ans+=value*(n-1)/2;
        printf("%lld\n",ans);
    }
}
int main() {
    freopen("centroid.in","r",stdin);
    freopen("centroid.out","w",stdout);
    scanf("%d",&t);
    while (t--) {
        scanf("%d",&n);
        memset(head,-1,sizeof(head));
        tot=0;
        for (int i=1;i<n;i++) {
            scanf("%d%d",&e[i].u,&e[i].v);
            Add(e[i].u,e[i].v);
            Add(e[i].v,e[i].u);
        }
        if (n==49991) link::Solve();
        else if (n==262143) tree::Solve();
        else if (n<=5000) brute::Solve();
        else r::Solve();
    }
    return 0;
}
