#include <bits/stdc++.h>

#define coint const int

using namespace std;

bool bmm1;

// Start

typedef long long ll;

coint SIZE = 300000 + 5;

inline int getInt(void) {
    int x = 0, ch = getchar();
    for (; ch < '0' || ch > '9'; ch = getchar());
    for (; ch >= '0' && ch <= '9';
         x = (x << 1) + (x << 3) + (ch - '0'), ch = getchar());
    return x;
}

struct Edge { int v, head; };

int ecnt, head[SIZE];
Edge edge[SIZE << 1];

inline void addEdge(coint u, coint v) {
    edge[++ecnt] = (Edge){ v, head[u] }, head[u] = ecnt;
    return;
}

int n, ui[SIZE], vi[SIZE];

struct P40 {
    int sz[SIZE], totSz;
    ll ans;

    void dfs1(coint u, coint fa) {
        sz[u] = 1;
        for (int i = head[u]; ~i; i = edge[i].head) {
            coint v = edge[i].v;
            if (v == fa) continue;
            dfs1(v, u), sz[u] += sz[v];
        }
        return;
    }

    void dfs2(coint u, coint fa) {
        if (totSz - sz[u] > (totSz >> 1)) return;
        int flg = 1;
        for (int i = head[u]; ~i; i = edge[i].head) {
            coint v = edge[i].v;
            if (v == fa) continue;
            dfs2(v, u);
            if (sz[v] > (totSz >> 1)) flg = 0;
        }
        if (flg) ans += u;
        return;
    }

    ll solve(void) {
        ans = 0;
        for (int i = 1; i < n; ++i) {
            dfs1(ui[i], vi[i]), totSz = sz[ui[i]], dfs2(ui[i], vi[i]);
            dfs1(vi[i], ui[i]), totSz = sz[vi[i]], dfs2(vi[i], ui[i]);
        }
        return ans;
    }
} p40;

struct P55 {
    int li[SIZE], deg[SIZE];
    ll sumLe[SIZE], sumRi[SIZE];

    void dfs(coint u, coint fa, coint dep) {
        li[dep] = u;
        for (int i = head[u]; ~i; i = edge[i].head) {
            coint v = edge[i].v;
            if (v == fa) continue;
            dfs(v, u, dep + 1);
        }
        return;
    }

    ll solve(void) {
        for (int i = 1; i <= n; ++i) deg[i] = 0;
        for (int i = 1; i < n; ++i) ++deg[ui[i]], ++deg[vi[i]];
        for (int i = 1; i <= n; ++i) {
            if (deg[i] > 1) continue;
            dfs(i, 0, 1);
            break;
        }
        for (int i = 1; i <= n; ++i) {
            coint half = ((i + 1) >> 1);
            if (i & 1) sumLe[i] = li[half];
            else sumLe[i] = li[half] + li[half + 1];
        }
        for (int i = n; i; --i) {
            coint half = ((i + n) >> 1);
            coint len = (n - i + 1);
            if (len & 1) sumRi[i] = li[half];
            else sumRi[i] = li[half] + li[half + 1];
        }
        ll ans = 0;
        for (int i = 1; i < n; ++i)
            ans += sumLe[i] + sumRi[i + 1];
        return ans;
    }
} p55;

// End

bool bmm2;

/* Todo:
     * [x] 内存
     * [x] 文件 IO
     * [x] 下标未越界
     * [x] 输出语句
     * [x] 数据类型
     * [x] 取模
     * [x] 初始化
 */

int main(void) {
    //printf("%f\n", (&bmm2 - &bmm1) / 1024.0 / 1024.0);
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    int test = getInt();
    while (test--) {
        ecnt = 0, memset(head, -1, sizeof head);
        n = getInt();
        for (int i = 1; i < n; ++i) {
            ui[i] = getInt(), vi[i] = getInt();
            addEdge(ui[i], vi[i]), addEdge(vi[i], ui[i]);
        }
        if (n == 49991) printf("%lld\n", p55.solve());
        else printf("%lld\n", p40.solve());
    }
    return 0;
}

