#include <cstdio>
#include <cstring>
using namespace std;

int getint()
{
    char ch;
    while((ch=getchar())<'0' || ch>'9')
        ;
    int x = ch^'0';
    while((ch=getchar())>='0' && ch<='9')
        x = (x*10)+(ch^'0');
    return x;
}

int beg[300005];
int ed[600005];
int nxt[600005];
int cuted[600005];
int top = 1;

void addedge(int a,int b)
{
    ++top;
    ed[top] = b;
    nxt[top] = beg[a];
    beg[a] = top;
}

void init()
{
    memset(beg,0,sizeof(beg));
    top = 1;
}

namespace subtask1
{
    int fa[300005];
    int siz[300005];

    void dfs(int x)
    {
        siz[x] = 1;
        for(int p=beg[x]; p; p=nxt[p])
        {
            if(!cuted[p] && ed[p]!=fa[x])
            {
                fa[ed[p]] = x;
                dfs(ed[p]);
                siz[x] += siz[ed[p]];
            }
        }
    }

    int deal(int x,int s)
    {
        for(int p=beg[x]; p; p=nxt[p])
        {
            if(!cuted[p] && ed[p]!=fa[x])
            {
                if(siz[ed[p]] > s/2)
                {
                    return deal(ed[p],s);
                }
                if(siz[ed[p]]==s/2 && !(s&1))
                {
                    return ed[p]+x;
                }
            }
        }
        return x;
    }

    int calcz(int x)
    {
        fa[x] = 0;
        dfs(x);
        return deal(x,siz[x]);
    }

    int sfa[300005];

    long long ansdfs(int x)
    {
        long long res = 0;
        for(int p=beg[x]; p; p=nxt[p])
        {
            if(ed[p] != sfa[x])
            {
                sfa[ed[p]] = x;
                res += ansdfs(ed[p]);

                cuted[p] = cuted[p^1] = 1;
                res += calcz(ed[p]);
                res += calcz(x);
                cuted[p] = cuted[p^1] = 0;
            }
        }
        return res;
    }

    void run(int n)
    {
        for(int i=1; i<n; ++i)
        {
            int a = getint();
            int b = getint();
            addedge(a,b);
            addedge(b,a);
        }

        printf("%lld\n",ansdfs(1));
    }
}

namespace subtask2
{
    int left[300005];
    int deg[300005];

    void run(int n)
    {
        memset(deg,0,sizeof(deg));
        memset(left,0,sizeof(left));

        for(int i=1; i<n; ++i)
        {
            int a = getint();
            int b = getint();
            addedge(a,b);
            addedge(b,a);
            ++deg[a];
            ++deg[b];
        }
        
        int b = 0;
        for(int i=1; i<=n; ++i)
        {
            if(deg[i]==1)
            {
                b = i;
                break;
            }
        }

        left[b] = 0;
        for(int i=2; i<=n; ++i)
        {
            for(int p=beg[b]; p; p=nxt[p])
            {
                if(!left[ed[p]])
                {
                    left[ed[p]] = left[b]+1;
                    b = ed[p];
                    break;
                }
            }
        }
        
        long long ans = 0;
        for(int i=1; i<=n; ++i)
        {
            ans += i;
            if(left[i] != n-left[i]-1)
            {
                ans += i;
            }
            if(deg[i] != 1)
            {
                ans += i;
            }
        }

        printf("%lld\n",ans);
    }
}

namespace subtask3
{
    void run(int n)
    {
        for(int i=1; i<n; ++i)
        {
            getint();
            getint();
        }
        printf("0\n");
    }
}

int main()
{
    freopen("centroid.in","r",stdin);
    freopen("centroid.out","w",stdout);
    
    int t = getint();
    while(t--)
    {
        init();

        int n = getint();
        if(n==49991)
        {
            subtask2::run(n);
        }
        else if(n==262143)
        {
            subtask3::run(n);
        }
        else
        {
            subtask1::run(n);
        }
    }
}