﻿//爆枚菜的个数然后 nmdp
#include <cstdio>
using namespace std;

int getint()
{
    char ch;
    while((ch=getchar())<'0' || ch>'9')
        ;
    int x = ch^'0';
    while((ch=getchar())>='0' && ch<='9')
        x = (x*10)+(ch^'0');
    return x;
}

#define mod 998244353

int modadd(int a,int b)
{
    return a+b>=mod?a+b-mod:a+b;
}

void modaddq(int& a,int b)
{
    a = modadd(a,b);
}

int modmul(int a,int b)
{
    return 1LL*a*b%mod;
}

int modsub(int a,int b)
{
    return a-b<0?a-b+mod:a-b;
}

void modsubq(int& a,int b)
{
    a = modsub(a,b);
}


int ai[105][1005];

int f[105][105][1005];

void init(int n,int m)
{
    for(int k=1; k<=m; ++k)
    {
        f[n][0][k] = 1;
        f[n][1][k] = ai[n][k];
    }
    for(int i=n-1; i>=1; --i)
    {
        for(int k=1; k<=m; ++k)
        {
            f[i][0][k] = 1;
        }
        for(int j=1; j<=n-i+1; ++j)
        {
            for(int k=1; k<=m; ++k)
            {
                f[i][j][k] = modadd(f[i+1][j][k], modmul(f[i+1][j-1][k],ai[i][k]));
            }
        }
    }
}

int predp[105][1005][105]; // pre (i,j) with k deal is predp[i][j][k]
int sufdp[105][1005][105]; // suf (i,j) with k deal is sufdp[i][j][k]

// 1. no ij
//    predp[i][j][k] = predp[i][j-1][k]+predp[i-1][j][k]-predp[i-1][j-1][k]
// 2. have ij
//    predp[i][j][k] = ai[i][j]*(predp[i][j-1][k-1]+predp[i-1][j][k-1]-predp[i-1][j-1][k-1])

void prennmdp(int n,int m)
{
    for(int i=1; i<=n; ++i)
    {
        predp[i][0][0] = 1;
    }
    for(int j=1; j<=m; ++j)
    {
        predp[0][j][0] = 1;
    }
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=m; ++j)
        {
            predp[i][j][0] = 1;
        }
    }

    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=m; ++j)
        {
            for(int k=1; k<i; ++k)
            {
                predp[i][j][k] = modsub(modadd(predp[i-1][j][k],predp[i][j-1][k]),predp[i-1][j-1][k]);
            }
        }
    }

    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=m; ++j)
        {
            for(int k=i; k>=1; --k)
            {
                modaddq(predp[i][j][k], modmul(predp[i][j][k-1],ai[i][j]));
            }
        }
    }
}

void sufnnmdp(int n,int m)
{
    for(int i=1; i<=n; ++i)
    {
        sufdp[i][m+1][0] = 1;
    }
    for(int j=1; j<=m; ++j)
    {
        sufdp[n+1][j][0] = 1;
    }
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=m; ++j)
        {
            sufdp[i][j][0] = 1;
        }
    }

    for(int i=n; i>=1; --i)
    {
        for(int j=m; j>=1; --j)
        {
            for(int k=1; k<n-i+1; ++k)
            {
                sufdp[i][j][k] = modsub(modadd(sufdp[i+1][j][k],sufdp[i][j+1][k]),sufdp[i+1][j+1][k]);
            }
        }
    }

    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=m; ++j)
        {
            for(int k=n-i+1; k>=1; --k)
            {
                modaddq(sufdp[i][j][k], modmul(sufdp[i][j][k-1],ai[i][j]));
            }
        }
    }
}

int dp[1005][105];

void nnmdp(int n,int m)
{
    for(int i=1; i<=m; ++i)
    {
        for(int j=1; j<=n; ++j)
        {
            for(int k=0; k<=j; ++k)
            {
                modaddq(dp[i][j],modmul(predp[i-1][m][k],sufdp[i+1][0][j-k]));
            }
        }
    }
}

int main()
{
    freopen("meal.in","r",stdin);
    freopen("meal.out","w",stdout);

    int n = getint();
    int m = getint();
    for(int i=1; i<=n; ++i)
    {
        for(int j=1; j<=m; ++j)
        {
            ai[i][j] = getint();
        }
    }

    init(n,m);
    sufnnmdp(n,m);
    prennmdp(n,m);

    nnmdp(n,m);

    int ans = 0;
    for(int k=2; k<=n; ++k)
    {
        modaddq(ans,predp[n][m][k]);
        for(int i=1; i<=m; ++i)
        {
            for(int j=k/2; j<=k; ++j)
            {
                modsubq(ans, modmul(f[1][j][i],dp[n][m-j]));
            }
        }
    }

    printf("%d\n",ans);
}