#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <iostream>
#include <algorithm>
using namespace std;
typedef long long ll;

template <typename Tp> inline void getint(Tp &num){
	register int ch, neg = 0;
	while(!isdigit(ch = getchar())) if(ch == '-') neg = 1;
	num = ch & 15;
	while(isdigit(ch = getchar())) num = num * 10 + (ch & 15);
	if(neg) num = -num;
}

int T, n, fa[300005], dep[300005], siz[300005], deg[300005], id[300005], tope = 0;
struct edge {int u, v, id1, id2;} ed[300005];
struct Edge {int np, del; Edge *nxt;} E[600005], *V[300005];

inline void addedge(edge &e){
	E[e.id1 = ++tope].np = e.v, E[tope].nxt = V[e.u], V[e.u] = E + tope;
	E[e.id2 = ++tope].np = e.u, E[tope].nxt = V[e.v], V[e.v] = E + tope;
}

int dfs(const int &u, const int &f, const int &d){
	fa[u] = f, dep[u] = d, siz[u] = 1; int mx = u;
	for(register Edge *ne = V[u]; ne; ne = ne->nxt)
		if(!ne->del && ne->np != f){
			const int cur = dfs(ne->np, u, d + 1);
			if(dep[cur] > dep[mx]) mx = cur;
			siz[u] += siz[ne->np];
		}
	return mx;
}

int calc(const int &rt, const int &u){
	int res = 0;
	for(register Edge *ne = V[u]; ne; ne = ne->nxt)
		if(!ne->del && ne->np != fa[u]) res += calc(rt, ne->np);
	if(siz[rt] - siz[u] > (siz[rt] >> 1)) return res;
	for(register Edge *ne = V[u]; ne; ne = ne->nxt)
		if(!ne->del && ne->np != fa[u]) if(siz[ne->np] > (siz[rt] >> 1)) return res;
	return res + u;
}

inline int solve2000(const int &rt1, const int &rt2){
//	printf("(%d, %d):\n", rt1, rt2);
//	register int ans = 0, u = dfs(rt1, 0, 0), v = dfs(u, 0, 0), d = dep[v];
////	printf("--- %d %d ", u, v);
//	for(register int i = d >> 1; i > 0; i--) v = fa[v];
//	if(d & 1) ans += check(u, v) + check(u, fa[v]), printf("  %d %d\n", v, fa[v]);
//	else ans += check(u, v), printf("  %d\n", v);
//	u = dfs(rt2, 0, 0), v = dfs(u, 0, 0), d = dep[v];
//	printf("=== %d %d ", u, v);
//	for(register int i = d >> 1; i > 0; i--) v = fa[v];
//	if(d & 1) ans += check(u, v) + check(u, fa[v]), printf("  %d %d\n", v, fa[v]);
//	else ans += check(u, v), printf("  %d\n", v);
	dfs(rt1, 0, 0), dfs(rt2, 0, 0);
	return calc(rt1, rt1) + calc(rt2, rt2);
}

int main(){
	freopen("centroid.in", "r", stdin), freopen("centroid.out", "w", stdout);
	getint(T);
	while(T--){
		getint(n), memset(V, 0, sizeof(V)), tope = 0;
		for(register int i = 1; i < n; i++)
			getint(ed[i].u), getint(ed[i].v), addedge(ed[i]);
		if(n <= 2000){
			ll ans = 0;
			for(register int i = 1; i < n; i++){
				E[ed[i].id1].del = E[ed[i].id2].del = 1;
				ans += solve2000(ed[i].u, ed[i].v);
				E[ed[i].id1].del = E[ed[i].id2].del = 0;
			}
			printf("%lld\n", ans);
		}
		else if(n == 49991){
			ll ans = 0;
			for(register int i = 1; i < n; i++) deg[ed[i].u]++, deg[ed[i].v]++;
			int p = 1; for(; deg[p] > 1; p++); id[1] = p;
			for(register int i = 2, pre = 0; i <= n; i++){
				for(register Edge *ne = V[p]; ne; ne = ne->nxt)
					if(ne->np != pre) {pre = p, p = ne->np; break;}
				id[i] = p;
			}
//			for(register int i = 1; i <= n; i++) printf("%d ", id[i]); puts("");
			for(register int i = 2; i <= n; i++){
				int g = i >> 1;
				if(i & 1) ans += id[g] + id[g + 1]; else ans += id[g];
				g = (n - i) >> 1;
				if((n - i) & 1) ans += id[i + g] + id[i + g + 1]; else ans += id[i + g];
			}
			printf("%lld\n", ans);
		}
	}
	return 0;
}
