#include <cstdio>
#include <cstring>

struct Edge{
	int to, next;
} edges[600005];
int head[300005], edge_num;

inline void addEdge(int u, int v){
	edges[++edge_num] = (Edge){v, head[u]};
	head[u] = edge_num;
}

int read(){
	int x = 0; char ch = ' ';
	while (ch < '0' || ch > '9') ch = getchar();
	while (ch >= '0' && ch <= '9') x = x * 10 + ch - '0', ch = getchar(); return x;
}

int fat[300005];
int size[300005];
int vis[300005];
int rd[300005];
int dep[300005];
int dy[300005];
long long res;

void preDFS(int u, int fa){
	fat[u] = fa; dep[u] = dep[fa] + 1;
	dy[dep[u]] = u;
	for (int c_e = head[u]; c_e; c_e = edges[c_e].next){
		int v = edges[c_e].to;
		if (v != fa)
			preDFS(v, u);
	}
}

void DFS(int u, int op){
	size[u] = 1; vis[u] = op;
	for (int c_e = head[u]; c_e; c_e = edges[c_e].next){
		int v = edges[c_e].to;
		if (!vis[v]){
			DFS(v, op);
			size[u] += size[v];
		}
	}
}

inline int _max(int a, int b){
	return (a > b ? a : b);
}

int main(){
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T = read();
	while (T--){
		memset(head, 0, sizeof(head));
		memset(rd, 0, sizeof(rd));
		memset(dep, 0, sizeof(dep));
		edge_num = 0;
		int n = read(), flg = 1;
		for (int i = 1; i < n; ++i){
			int u = read(), v = read();
			addEdge(u, v), addEdge(v, u);
			++rd[u], ++rd[v];
			if (rd[u] > 2 || rd[v] > 2) flg = 0;
		}
		if (n <= 2000){
			res = 0; preDFS(1, 1);
			for (int I = 2; I <= n; ++I){
				memset(vis, 0, sizeof(vis));
				memset(size, 0, sizeof(size));
				vis[I] = 2;
				DFS(1, 1);
				int pos[2] = {0, 0}, ccnt = 0;
				for (int i = 1; i <= n; ++i){
					if (vis[i] == 1){
						if (size[1] - size[i] > size[1] / 2) continue;
						int c_e = 0;
						for (c_e = head[i]; c_e; c_e = edges[c_e].next){
							int v = edges[c_e].to;
							if (fat[i] != v){
								if (size[v] > size[1] / 2)
									break;
							}
						}
						if (!c_e) pos[ccnt++] = i;
					}
				}
				res += pos[0] + pos[1];
				DFS(I, 2); pos[0] = 0, pos[1] = 0, ccnt = 0;
				for (int i = 1; i <= n; ++i){
					if (vis[i] == 2){
						if (size[I] - size[i] > size[I] / 2) continue;
						int c_e = 0;
						for (c_e = head[i]; c_e; c_e = edges[c_e].next){
							int v = edges[c_e].to;
							if (fat[i] != v){
								if (size[v] > size[I] / 2)
									break;
							}
						}
						if (!c_e) pos[ccnt++] = i;
					}
				}
				res += pos[0] + pos[1];
			}
			printf("%lld\n", res);
		}
		else if (flg){
			preDFS(1, 1);
			long long ans = 0;
			for (int i = 1; i < n; ++i){
				ans += dy[(1 + i) / 2];
				if ((1 + i) % 2 == 1) ans += dy[(i + 2) / 2];
				ans += dy[(i + 1 + n) / 2];
				if ((i + 1 + n) % 2 == 1) ans += dy[(i + 2 + n) / 2];
			}
			printf("%lld\n", ans);
		}
	}
	return 0;
}
