#include<cstdio>
#include<cstring>
#include<algorithm>
#include<queue>

const int N=300005;

int n,head[N],fa[N],size[N],max_size[N],deg[N];

struct Edge
{
	int next,to;
	bool invalid;
};
Edge E[N<<1];
int tot;

void add(int u,int v)
{
	E[++tot].next=head[u];
	E[tot].to=v;
	E[tot].invalid=0;
	head[u]=tot;
	++deg[u];
}

void init()
{
	tot=1;
	memset(head,0x00,sizeof(head));
	memset(fa,0x00,sizeof(fa));
	memset(deg,0x00,sizeof(deg));
}

void dfs1(int u)
{
	size[u]=1;
	max_size[u]=0;
	for(int i=head[u];i;i=E[i].next)
	{
		if(E[i].invalid)continue;
		int v=E[i].to;
		if(v==fa[u])continue;
		fa[v]=u;
		dfs1(v);
		size[u]+=size[v];
		max_size[u]=std::max(max_size[u],size[v]);
	}
}

void dfs2(int u,int tree_size)
{
	max_size[u]=std::max(max_size[u],tree_size-size[u]);
	size[u]=tree_size;
	for(int i=head[u];i;i=E[i].next)
	{
		if(E[i].invalid)continue;
		int v=E[i].to;
		if(v==fa[u])continue;
		dfs2(v,tree_size);
	}
}

namespace sub4
{
	
int rt[2];

bool check()
{
	int s1=0;
	for(int i=1;i<=n;++i)
	{
		if(deg[i]==1)
		{
			++s1;
			if(s1==3)return 0;
			rt[s1-1]=i;
		}
		if(deg[i]>2)return 0;
	}
	return 1;
}

int a[N],_tot;

void bfs(int s)
{
	std::queue<int> q;
	q.push(s);
	while(!q.empty())
	{
		int u=q.front();
		a[++_tot]=u;
		q.pop();
		for(int i=head[u];i;i=E[i].next)
		{
			int v=E[i].to;
			if(v==fa[u])continue;
			fa[v]=u;
			q.push(v);
		}
	}
}

int calc(int l,int r)
{
	int len=(r-l+1),res;
	if(len&1)res=a[(l+r)/2];
	else res=a[(l+r)/2]+a[(l+r)/2+1];
	return res;
}

void main()
{
	_tot=0;
	bfs(rt[0]);
	long long ans=0;
	for(int i=1;i<n;++i)
	{
		ans+=calc(1,i)+calc(i+1,n);
	}
	printf("%lld\n",ans);
}

}

int main()
{
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%d",&T);
	while(T--)
	{
		scanf("%d",&n);
		init();
		for(int i=1;i<n;++i)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			add(u,v);
			add(v,u);
		}
		if(sub4::check())
		{
			sub4::main();
			continue;
		}
		long long ans=0;
		for(int i=2;i<2*n;i+=2)
		{
			E[i].invalid=E[i+1].invalid=1;
			int u=E[i].to,v=E[i+1].to;
			fa[u]=fa[v]=0;
			dfs1(u);
			dfs2(u,size[u]);
			dfs1(v);
			dfs2(v,size[v]);
			E[i].invalid=E[i+1].invalid=0;
//			printf("cut %d %d:\n",u,v);
			for(int i=1;i<=n;++i)
			{
				if(max_size[i]<=size[i]/2)
				{
					ans+=i;
//					printf("%d ",i);
				}
			}
//			puts("");
		}
		printf("%lld\n",ans);
	}
}
/*
2
5
1 2
2 3
2 4
3 5
7
1 2
1 3
1 4
3 5
3 6
6 7
*/
/*
184
2497
362076
37361659
3748637134
*/
