#include <iostream>
#include <climits>
#include <cstring>
#include <algorithm>

using namespace std;

const int N = 300010;
int T, n, head[N], nxt[N], ver[N], idx = 0, local1, local2, vis[N], size[N], max_part[N], ans = 0;
int all;

inline void add(int a, int b)
{
	nxt[++idx] = head[a];
	head[a] = idx;
	ver[idx] = b;
}

void dfs(int x)
{
	max_part[x] = 0;
	size[x] = 1;
	for (int i = head[x]; i; i = nxt[i])
		if (i != local1 && i != local2)
		{
			int y = ver[i];
			if (!vis[y])
			{
				vis[y] = 1;
				dfs(y);
				max_part[x] = max(max_part[x], size[y]);
				size[x] += size[y];
			}
		}
	max_part[x] = max(max_part[x], all - size[x]);
}

void calc(int x)
{
	for (int i = head[x]; i; i = nxt[i])
		if (i != local1 && i != local2)
		{
			int y = ver[i];
			if (!vis[y])
			{
				vis[y] = 1;
				all++;
				calc(y);
			}
		}
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	cin >> T;
	while (T--)
	{
		memset(head, 0, sizeof head);
		idx = 0;
		memset(nxt, 0, sizeof  nxt);
		memset(ver, 0, sizeof ver);
		cin >> n;
		for (int i = 1; i < n; i++)
		{
			int u, v; cin >> u >> v;
			add(u, v); add(v, u);
		}
		ans = 0;
		for (int i = 1; i <= idx; i += 2)
		{
			local1 = i; local2 = i + 1;
			int j = ver[local1];
			memset(vis, 0, sizeof vis);
			vis[j] = all = 1;
			memset(max_part, 0, sizeof max_part);
			memset(size, 0, sizeof size);
			calc(j);
			memset(vis, 0, sizeof vis);
			vis[j] = 1;
			dfs(j);
			int Min = INT_MAX;
			for (int k = 1; k <= n; k++)
				if (vis[k])
					Min = min(Min, max_part[k]);
			for (int k = 1; k <= n; k++)
				if (vis[k] && Min == max_part[k]) ans += k;
			j = ver[local2];
			vis[j] = all = 1;
			memset(max_part, 0, sizeof max_part);
			memset(size, 0, sizeof size);
			memset(vis, 0, sizeof vis);
			vis[j] = all = 1;
			calc(j);
			memset(vis, 0, sizeof vis);
			vis[j] = 1;
			dfs(j);
			Min = INT_MAX;
			for (int k = 1; k <= n; k++)
				if (vis[k])
					Min = min(Min, max_part[k]);
			for (int k = 1; k <= n; k++)
				if (vis[k] && Min == max_part[k]) ans += k;
		}
		cout << ans << '\n';
	}
	
	return 0;
}
