#define setIO(s) freopen(s".in","r",stdin),freopen(s".out","w",stdout);
#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>
double A;
using namespace std;
template <class T> bool checkmin(T &a,T b){return (b<a ? a=b,1 : 0);}
template <class T> bool checkmax(T &a,T b){return (b>a ? a=b,1 : 0);}
const int N=300005;
int n,deg[N];
int e=0,first[N],nxt[N<<1],point[N<<1];
void add_edge(int x,int y)
{
	++e;
	nxt[e]=first[x];
	first[x]=e;
	point[e]=y;
}

void dfs(int x,int f)
{
	for (int i=first[x];i!=-1;i=nxt[i])
	{
		int to=point[i];
		if (to==f) continue;
		dfs(to,x);
	}
}

void init()
{
    scanf("%d",&n);
    e=0;
    memset(first,-1,sizeof first);
    memset(point,-1,sizeof point);
    memset(nxt,-1,sizeof nxt);
    memset(deg,0,sizeof deg);
    for (int i=1,u,v;i<n;++i)
    {
        scanf("%d%d",&u,&v);
        add_edge(u,v);
        add_edge(v,u);
        ++deg[u]; ++deg[v];
    }
    dfs(1,0);
}

namespace solver1
{
int x,y,cnt=0,top=0;
int vis[N],sz[N],tmp[N];
void dfs(int now,int f)
{
    //cout<<now<<" "<<f<<endl;
    sz[now]=1;
    ++cnt;
    vis[now]=1;
	for (int i=first[now];i!=-1;i=nxt[i])
	{
		int to=point[i];
		if (to==f||(now==x&&to==y)||(now==y&&to==x)) continue;
		dfs(to,now);
		sz[now]+=sz[to];
		checkmax(tmp[now],sz[to]);
	}
}

void dfs3(int now,int f)
{
    //cout<<now<<" "<<f<<endl;
    sz[now]=1;
	for (int i=first[now];i!=-1;i=nxt[i])
	{
		int to=point[i];
		if (to==f) continue;
		dfs3(to,now);
		sz[now]+=sz[to];
		checkmax(tmp[now],sz[to]);
	}
}

void dfs2(int now,int f)
{
    tmp[++cnt]=now;
	for (int i=first[now];i!=-1;i=nxt[i])
	{
		int to=point[i];
		if (to==f) continue;
		dfs2(to,now);
	}
}

void main()
{
    long long res=0;
    for (int i=1;i<=n;++i)
    {
        for (int j=first[i];j!=-1;j=nxt[j])
        {
            if ((clock()-A)*1.0/CLOCKS_PER_SEC>2960)
            {
                printf("%lld\n",res);
                return;
            }
            for (int p=1;p<=n;++p)
            {
                tmp[p]=vis[p]=0;
            }
            cnt=0;
            y=point[j]; x=i;
            if (x>y) continue;
            dfs(x,0);
            int mx=n+1,ans=0;
            for (int p=1;p<=n;++p)
            {
                if (!vis[p]) continue;
                checkmax(tmp[p],cnt-sz[p]);
                if (checkmin(mx,tmp[p])) ans=p;
                else if (mx==tmp[p]) ans+=p;
            } res+=ans,cnt=0;
            //if (x==4&&y==8) for (int p=1;p<=n;++p) cout<<tmp[p]<<" ";cout<<endl;
            //cout<<x<<" "<<y<<" "<<ans<<endl;
            for (int p=1;p<=n;++p)
            {
                tmp[p]=vis[p]=0;
            }
            dfs(y,0);
            mx=n+1,ans=0;
            for (int p=1;p<=n;++p)
            {
                if (!vis[p]) continue;
                checkmax(tmp[p],cnt-sz[p]);
                if (checkmin(mx,tmp[p])) ans=p;
                else if (mx==tmp[p]) ans+=p;
            } res+=ans;
            //cout<<x<<" "<<y<<" "<<ans<<endl;
        }
    }
    printf("%lld\n",res);
}

void main2()
{
    cnt=top=0; int pos=0;
    for (int i=1;i<=n;++i) tmp[i]=0;
    for (int i=1;i<=n;++i) if (deg[i]==1) pos=i;
    dfs2(pos,0);
    long long ans=0;
    for (int i=1;i<n;++i)
    {
        if (i%2==1) ans+=tmp[(i+1)/2];
        else ans+=tmp[i/2]+tmp[i/2+1];
        if ((n-i)%2==1) ans+=tmp[(n-i+1)/2+i];
        else ans+=tmp[i+(n-i)/2]+tmp[i+(n-i)/2+1];
    }
    printf("%lld\n",ans);
}

void main3()
{
    for (int i=1;i<=n;++i) tmp[i]=0;
    x=0,y=0; dfs3(1,0);
    int ans=0,mx=n+1;
    //for (int i=1;i<=n;++i) cout<<tmp[i]<<" ";cout<<endl;
    //for (int i=1;i<=n;++i) cout<<sz[i]<<" ";cout<<endl;
    for (int p=1;p<=n;++p)
    {
        checkmax(tmp[p],n-sz[p]);
        if (checkmin(mx,tmp[p])) ans=p;
    }
    //for (int i=1;i<=n;++i) cout<<tmp[i]<<" ";cout<<endl;
    //cout<<ans<<endl;
    int p[2]={0},cnt=0;
    for (int i=first[ans];i!=-1;i=nxt[i])
    {
        int to=point[i];
        p[cnt]=to; ++cnt;
    }
    //cout<<ans<<" "<<p[0]<<" "<<p[1]<<endl;
    long long res=1LL*n*(n+1)/2+1LL*(n-1)/2*(p[0]+p[1]+ans);
    printf("%lld\n",res);
}
}

namespace solver2
{

void main()
{
	
}
}

bool check_chain()
{
    int cnt=0,cnt2=0;
    for (int i=1;i<=n;++i)
    {
        if (deg[i]==1) ++cnt;
        if (deg[i]==2) ++cnt2;
    }
    if (cnt==2&&cnt2==n-2) return 1;
    return 0;
}

bool check_perfect()
{
    int tot=0;
    for (int i=1;i<=18;++i)
        if ((1<<i)-1==n) tot=i;
    if (!tot) return 0;
    tot=(1<<tot);
    int cnt=0,cnt2=0,cnt3=0;
    for (int i=1;i<=n;++i)
    {
        if (deg[i]==1) ++cnt;
        if (deg[i]==2) ++cnt2;
        if (deg[i]==3) ++cnt3;
    }
    if (cnt==(n+1)/2&&cnt2==1&&cnt3==n-(n+1)/2-1) return 1;
    return 0;
}

void solve()
{
    if (n<=2000) solver1::main();
    else if (check_chain()) solver1::main2();
    else if (check_perfect()) solver1::main3();
    else solver1::main();
}

#undef int
int main()
{
    A=clock();
	setIO("centroid");
	int t; scanf("%d",&t);
	while (t--)
	{
	init();
	solve();	
	}
	fclose(stdin),fclose(stdout);
	return 0;
}
