#include <bits/stdc++.h>

const int MAXN = 300010;
typedef long long LL;
int n;
int head[MAXN], nxt[MAXN << 1], to[MAXN << 1], tot;
void addedge(int b, int e) {
	nxt[++tot] = head[b]; to[head[b] = tot] = e;
	nxt[++tot] = head[e]; to[head[e] = tot] = b;
}
const int MAXNODE = MAXN * 20 * 2;
int ls[MAXNODE], rs[MAXNODE], val[MAXNODE], idx;
void modify(int & x, int l, int r, int tar, int v) {
	if (!x) { x = ++idx, ls[x] = rs[x] = val[x] = 0; }
	val[x] += v;
	if (l == r) return ;
	int mid = l + r >> 1;
	if (tar <= mid) modify(ls[x], l, mid, tar, v);
	else modify(rs[x], mid + 1, r, tar, v);
}
void safe_modify(int x, int l, int r, int tar, int v) {
	while (true) {
		val[x] += v;
		if (l == r) return ;
		int mid = l + r >> 1;
		if (tar <= mid) x = ls[x], r = mid;
		else x = rs[x], l = mid + 1;
	}
}
int query(int u, int l, int r, int L, int R) {
	if (!u) return 0;
	if (L <= l && r <= R) return val[u];
	int mid = l + r >> 1; int res = 0;
	if (L <= mid) res += query(ls[u], l, mid, L, R);
	if (mid < R) res += query(rs[u], mid + 1, r, L, R);
	return res;
}
int merge(int x, int y) {
	if (!x || !y) return x | y;
	val[x] += val[y];
	ls[x] = merge(ls[x], ls[y]);
	rs[x] = merge(rs[x], rs[y]);
	return x;
}
int allrt, toroot, sz[MAXN];
void dfs1(int u, int fa = 0) {
	sz[u] = 1;
	for (int i = head[u]; i; i = nxt[i])
		if (to[i] != fa) {
			dfs1(to[i], u);
			sz[u] += sz[to[i]];
		}
}
int rts[MAXN];
LL ans = 0;
int query(int u, int l, int r) {
	l = std::max(l, 1); r = std::min(r, n);
	if (l > r) return 0;
	return query(u, 1, n, l, r);
}
void dfs2(int u, int fa = 0) {
	int & rt = rts[u] = 0;
	if (u != 1) {
		safe_modify(allrt, 1, n, sz[u], -1);
		safe_modify(toroot, 1, n, sz[u], 1);
	}
	int tv = 0;

	int fir = 0, sec = 0, sonmax = 0;
	for (int i = head[u]; i; i = nxt[i])
		if (to[i] != fa) {
			if (sz[to[i]] > fir) sec = fir, fir = sz[to[i]];
			else sec = std::max(sec, sz[to[i]]);
		}
	sonmax = fir;
	if (n - sz[u] > fir) sec = fir, fir = n - sz[u];
	else sec = std::max(sec, n - sz[u]);

	for (int i = head[u]; i; i = nxt[i])
		if (to[i] != fa) {
			dfs2(to[i], u);
			int maxv = sz[to[i]] == fir ? sec : fir;
			tv += query(rts[to[i]], 2 * sz[to[i]] - n, n - 2 * maxv);
			rt = merge(rt, rts[to[i]]);
		}
	tv += query(toroot, 2 * sonmax, 2 * sz[u]);
	tv += query(allrt, n - 2 * sz[u], n - 2 * sonmax);
	tv -= query(rt, n - 2 * sz[u], n - 2 * sonmax);
	ans += (LL) tv * u;
	if (u != 1) {
		modify(rt, 1, n, sz[u], 1);
		safe_modify(allrt, 1, n, sz[u], 1);
		safe_modify(toroot, 1, n, sz[u], -1);
	}
}
int hav[MAXN];
void build(int & u, int l, int r) {
	u = ++idx; ls[u] = rs[u] = val[u] = 0;
	if (l == r) return (void) (val[u] = hav[l]);
	int mid = l + r >> 1;
	build(ls[u], l, mid); build(rs[u], mid + 1, r);
	val[u] = val[ls[u]] + val[rs[u]];
}
void solve() {
	std::cin >> n;
	for (int i = 1, t1, t2; i < n; ++i)
		std::cin >> t1 >> t2, addedge(t1, t2);
	dfs1(1);
	for (int i = 2; i <= n; ++i) ++hav[sz[i]];
	build(allrt, 1, n);
	memset(hav, 0, n + 1 << 2);
	build(toroot, 1, n);
	dfs2(1);
	std::cout << ans << std::endl;
	memset(head, 0, n + 1 << 2);
	ans = tot = idx = 0;
	allrt = toroot = 0;
}
int main() {
#define FILENAME "centroid"
#ifdef FILENAME
	freopen(FILENAME ".in", "r", stdin);
	freopen(FILENAME ".out", "w", stdout);
#endif
	std::ios_base::sync_with_stdio(false), std::cin.tie(0);
	int T; std::cin >> T;
	while (T --> 0) solve();
	return 0;
}
