#include <bits/stdc++.h>
using namespace std;

int cas, n;

namespace solver1 {
  const int N = 2e3 + 5;

  int x[N], y[N], u1, v1, sz[N], fsz[N];
  long long ans;
  vector<int> g[N], f1, f2;

  inline bool check(int u, int v) {
    return (u == u1 && v == v1) || (u == v1 && v == u1);
  }
  void dfs(int u, int fa, vector<int> &f) {
    sz[u] = 1;
    fsz[u] = 0;
    f.push_back(u);
    for(int i = 0, v; i < (int) g[u].size(); ++i) {
      v = g[u][i];
      if(v == fa || check(u, v))
	continue;
      dfs(v, u, f);
      fsz[u] = max(fsz[u], sz[v]);
      sz[u] += sz[v];
    }
  }
  inline void doit(vector<int> &f) {
    int Size = (int) f.size();
    vector<int> tmp; tmp.clear();
    int kk = 1e9;
    for(int i = 0; i < (int) f.size(); ++i) {
      int u = f[i];
      int cur = max(fsz[u], Size - sz[u]);
      if(cur < kk) {
	tmp.clear();
	tmp.push_back(u);
	kk = cur;
      } else if(cur == kk) {
	tmp.push_back(u);
      }
    }
    for(int i = 0; i < (int) tmp.size(); ++i)
      ans += tmp[i];
  }
  
  void main() {
    ans = 0;
    for(int i = 1; i <= n; ++i) 
      g[i].clear();
    for(int i = 1; i < n; ++i) {
      scanf("%d%d", x + i, y + i);
      g[x[i]].push_back(y[i]);
      g[y[i]].push_back(x[i]);
    }
    for(int i = 1; i < n; ++i) {
      u1 = x[i], v1 = y[i];
      f1.clear(), f2.clear();
      dfs(u1, 0, f1);
      dfs(v1, 0, f2);
      doit(f1), doit(f2);
    }
    printf("%lld\n", ans);
  }
}

namespace solver2 {
  const int N = 1e5 + 5;

  int root, cnt, a[N], x[N], y[N], deg[N], id[N];
  long long ans;
  vector<int> g[N];
  
  void dfs(int u, int fa) {
    a[++cnt] = u;
    for(int i = 0, v; i < (int) g[u].size(); ++i) {
      v = g[u][i];
      if(v == fa) continue;
      dfs(v, u);
    }
  }
  void main() {
    ans = 0;
    cnt = 0;
    for(int i = 1; i <= n; ++i)
      deg[i] = 0, g[i].clear();
    for(int i = 1; i < n; ++i) {
      scanf("%d%d", x + i, y + i);
      g[x[i]].push_back(y[i]);
      g[y[i]].push_back(x[i]);
      ++deg[x[i]], ++deg[y[i]];
    }
    for(int i = 1; i <= n; ++i)
      if(deg[i] == 1) root = i;
    dfs(root, 0);
    for(int i = 1; i <= n; ++i)
      id[a[i]] = i;
    for(int i = 1; i < n; ++i) {
      int u = x[i];
      int v = y[i];
      int iu = id[u];
      int iv = id[v];
      if(iu > iv) {
	swap(iu, iv);
	swap(u, v);
      }
      if(iu & 1) {
	ans += a[(iu + 1) / 2];
	//cout << a[(iu + 1) / 2] << '\n';
      } else {
	ans += a[iu / 2];
	ans += a[iu / 2 + 1];
	//cout << a[iu / 2] << ' ' << a[iu / 2 + 1] << '\n';
      }
      if((n - iv + 1) & 1) {
	ans += a[iv + (n - iv + 1) / 2];
	// cout << a[iv + (n - iv + 1) / 2] << '\n';
      } else {
	ans += a[iv + (n - iv + 1) / 2];
	ans += a[iv + (n - iv + 1) / 2 - 1];
	// cout << a[iv + (n - iv + 1) / 2] << ' ' << a[iv + (n - iv + 1) / 2 - 1] << '\n';
      }
    }
    
    printf("%lld\n", ans);
  }
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
  for(cin >> cas; cas--; ) {
    scanf("%d", &n);
    if(n <= 2000)
      solver1 :: main();
    else solver2 :: main();
  }
  return 0;
}

