#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <algorithm>
#define vit vector<int>::iterator
using namespace std;

const int N=300000;
const int M=600000;

struct edge {
	int u;
	int v;
};

struct tree {
	int head[N+100],nxt[M+100],pnt[M+100],fa[N+100],sum[N+100];
	vector<int> son[N+100];
	int E,n;
	void init() {
		memset(head,-1,sizeof(head));
		memset(sum,0,sizeof(sum));
		E=n=0;
	}
	void add_edge(int u,int v) {
		pnt[E]=v;
		nxt[E]=head[u];
		head[u]=E++;
	}
	void find_son(int u,int f) {
		fa[u]=f;
		for (int i=head[u];i!=-1;i=nxt[i]) {
			int v=pnt[i];
			if (f==v) continue;
			find_son(v,u);
			son[u].push_back(sum[v]);
			sum[u]+=sum[v];
		}
		sum[u]++;
		son[u].push_back(n-sum[u]);
	}
	int cent() {
		int ret=0;
		for (int i=1;i<=n;i++) {
			bool ok=true;
			for (vit it=son[i].begin();it!=son[i].end();it++) {
				if (*it>n/2) {
					ok=false;
					break;
				}
			}
			if (ok) ret+=i;
		}
		return ret;
	}
};

tree a,b,c;
edge e[M+100];

void create_b(int root,int u,int f) {
	if (u!=root) {
		b.add_edge(u,f);
		b.add_edge(f,u);
	}
	b.n++;
	for (int i=a.head[u];i!=-1;i=a.nxt[i]) {
		int v=a.pnt[i];
		if (f==v) continue;
		create_b(root,v,u);
	}
}

void create_c(int root,int u,int f) {
	if (u!=root) {
		c.add_edge(u,f);
		c.add_edge(f,u);
	}
	c.n++;
	for (int i=a.head[u];i!=-1;i=a.nxt[i]) {
		int v=a.pnt[i];
		if (f==v) continue;
		create_c(root,v,u);
	}
}

int main() {
	#ifndef OFFLINE_JUDGE
		freopen("centroid.in","r",stdin);
		freopen("centroid.out","w",stdout);
	#endif
	int t,n,i;
	scanf("%d",&t);
	while (t--) {
		scanf("%d",&n);
		a.init();
		int cur=0,ans=0;
		for (i=1;i<=n-1;i++) {
			int u,v;
			scanf("%d%d",&u,&v);
			e[++cur].u=u; e[cur].v=v;
			a.add_edge(u,v);
			a.add_edge(v,u);
		}
		for (i=1;i<=cur;i++) {
			printf("i=%d\n",i);
			b.init(); create_b(e[i].u,e[i].u,e[i].v);
			c.init(); create_c(e[i].v,e[i].v,e[i].u);
			b.find_son(e[i].u,0);
			c.find_son(e[i].v,0);
			ans+=b.cent()+c.cent();
		}
		printf("%d\n",ans);
	}
	return 0;
}

