#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
const int maxn = 3e5 + 10;

int Tim, n, deg[maxn];
long long ans;
bool can = true;

int head[maxn], cnt = 1;
struct Edge { int to, nxt, used; } e[maxn << 1];
void addedge(int a, int b) {
	e[++cnt] = (Edge) { b, head[a], 1 }; head[a] =cnt;
	e[++cnt] = (Edge) { a, head[b], 1 }; head[b] =cnt;
	++deg[a], ++deg[b];
	if (deg[a] > 2 || deg[b] > 2) can = false;
}

namespace Work1 {
	int rt, dep[maxn], ret[maxn];
	void dfs(int u, int fa = 0) {
		for (int i = head[u], v; i; i = e[i].nxt) {
			v = e[i].to;
			if (v != fa) dep[v] = dep[u] + 1, dfs(v, u);
		}
	}
	int main() {
		for (int i = 1; i <= n; ++i) if (deg[i] == 1) rt = i;
		dep[rt] = 1, dfs(rt);
		for (int i = 1; i <= n; ++i) ret[dep[i]] = i;
		for (int i = 1; i < n; ++i) {
			if (i & 1) ans += ret[i + 1 >> 1];
			else ans += ret[i >> 1] + ret[(i >> 1) + 1];
			if (n - i & 1) ans += ret[i + (n - i + 1 >> 1)];
			else ans += ret[i + (n - i >> 1)] + ret[i + 1 + (n - i >> 1)];
		}
		return 0;
	}
}
namespace Work2 {
	int sz[maxn], m;
	void dfs0(int u, int fa) {
		sz[u] = 1;
		for (int i = head[u], v; i; i = e[i].nxt) {
			v = e[i].to;
			if (v != fa) dfs0(v, u), sz[u] += sz[v];
		}
	}
	void dfs(int u, int fa) {
		int Max = m - sz[u];
		for (int i = head[u], v; i; i = e[i].nxt) {
			v = e[i].to;
			if (v != fa) Max = std::max(Max, sz[v]), dfs(v, u);
		}
		if (Max <= m >> 1) ans += u;
	}
	int main() {
		for (int i = 2, u, v; i <= cnt; i += 2) {
			e[i].used = 0, e[i ^ 1].used = 0;
			u = e[i ^ 1].to, v = e[i].to;
			dfs0(u, v), m = sz[u], dfs(u, v);
			dfs0(v, u), m = sz[v], dfs(v, u);
		}
		return 0;
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	std::ios::sync_with_stdio(false), std::cin.tie(0), std::cout.tie(0);
	std::cin >> Tim;
	while (Tim --> 0) {
		std::cin >> n;
		for (int i = 1, a, b; i < n; ++i)
			std::cin >> a >> b, addedge(a, b);
		ans = 0;
		if (can) Work1::main();
		else Work2::main();
		std::cout << ans << '\n';
		if (Tim) {
			memset(head, 0, sizeof head), cnt = 1;
			memset(deg, 0, sizeof deg), can = true;
		}
	}
	return 0;
}
