#include <cstdio>

#define PROGRAM_ID "meal"
#define N_MAX 100
#define M_MAX 2000
#define MODULO_NUMBER 998244353

unsigned n;
unsigned m;
unsigned mat[N_MAX][M_MAX];
unsigned sums[N_MAX];
// unsigned long long results[N_MAX + 1][N_MAX + 1];
unsigned counts[M_MAX];

unsigned long long search(unsigned i, unsigned k) {
  if (i == n) {
    k >>= 1;
    if (!k) return 0;
    for (unsigned i = 0; i < m; i++)
      if (counts[i] > k) return 0;
    return 1;
  }
  unsigned* row = mat[i++];
  unsigned long long result = search(i, k);
  for (unsigned j = 0; j < m; j++) {
    if (!row[j]) continue;
    counts[j]++;
    result += search(i, k + 1) * row[j];
    result %= MODULO_NUMBER;
    counts[j]--;
  }
  return result;
}

int main() {
  freopen(PROGRAM_ID".in", "r", stdin);
  freopen(PROGRAM_ID".out", "w", stdout);
  scanf("%u%u", &n, &m);
  for (unsigned i = 0; i < n; i++) {
    unsigned sum = 0;
    for (unsigned j = 0; j < m; j++) {
      scanf("%u", &mat[i][j]);
      sum += mat[i][j];
      if (sum >= MODULO_NUMBER) sum -= MODULO_NUMBER;
    }
    sums[i] = sum;
  }
  printf("%llu\n", search(0, 0)); 
  // results[0][0] = 1;
  // for (unsigned i = 1; i <= n; i++)
  //   for (unsigned k = 1; k <= n; k++)
  //     results[i][k] = (results[i - 1][k - 1] * sums[i - 1] + results[i - 1][k]) % MODULO_NUMBER;
  // unsigned long long result = 0;
  // for (unsigned k = 2; k <= n; k++) {
  //   result += results[n][k];
  //   // result -= count(sum(column) > k / 2);
  //   if (result >= MODULO_NUMBER) result -= MODULO_NUMBER;
  // }
  // printf("%llu\n", result);
  return 0;
}
