#include <cstdio>

#define PROGRAM_ID "partition"
#define N_MAX 40000000
#define GEN_MASK ((1U << 30) - 1)
#define ULL_MAX (-1ULL)

unsigned n;
unsigned arr[N_MAX];
unsigned long long sums[N_MAX + 1];

unsigned long long search(unsigned index, unsigned long long last, unsigned long long cur) {
  if (index > n) return cur;
  unsigned begin = index - 1;
  while (sums[index] - sums[begin] < last)
    if (++index > n) return ULL_MAX;
  unsigned long long result = ULL_MAX;
  while (index <= n) {
    unsigned long long a = sums[index] - sums[begin];
    unsigned long long newResult = search(++index, a, cur + a * a);
    if (newResult < result) result = newResult;
  }
  return result;
}

int main() {
  freopen(PROGRAM_ID".in", "r", stdin);
  freopen(PROGRAM_ID".out", "w", stdout);
  unsigned type;
  scanf("%u%u", &n, &type);
  if (type) {
    unsigned x, y, z, b, bn, m;
    scanf("%u%u%u%u%u%u", &x, &y, &z, &b, &bn, &m);
    unsigned p[m], l[m], r[m];
    for (unsigned i = 0; i < m; i++) {
      scanf("%u%u%u", p + i, l + i, r + i);
      r[i]++;
    }
    unsigned j = 0;
    for (unsigned i = 0; i < n; i++) {
      if (i >= p[j]) j++;
      arr[i] = b % (r[j] - l[j]) + l[j];
      unsigned tmp = bn;
      bn = (x * bn + y * b + z) & GEN_MASK;
      b = tmp;
    }
  } else {
    for (unsigned i = 0; i < n; i++)
      scanf("%u", arr + i);
  }
  for (unsigned i = 0; i < n; i++)
    sums[i + 1] = sums[i] + arr[i];
  printf("%llu\n", search(1, 0, 0));
  return 0;
}
