#include <cctype>
#include <cstdio>
#include <cstring>
#include <algorithm>

void openFile() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
}

inline int read() {
	char c; for (c = getchar(); !isdigit(c); c = getchar());
	int x; for (x = 0; isdigit(c); c = getchar()) { x = x * 10 + c - '0'; } return x;
}

const int N = 1e6 + 5;

int n, rt, cr, vol, stc[N], deg[N], siz[N], ss[N];
long long ans, now;

struct List {
	int tot, fst[N], nxt[N], to[N];
	
	void reset(int n) {
		memset(fst, -1, sizeof(int) * n); tot = 0;
	}
	inline void insert(int u, int v) {
		nxt[tot] = fst[u]; to[tot] = v; fst[u] = tot++;
	}
	inline void link(int u, int v) {
		insert(u, v); insert(v, u);
	}
} e;

void dfs1(int u, int fa) {
	siz[u] = 1;
	for (int i = e.fst[u]; ~i; i = e.nxt[i]) {
		int v = e.to[i];
		if (v != fa) { dfs1(v, u); siz[u] += siz[v]; }
	}
}
void dfs2(int u, int fa) {
	ss[u] = siz[rt] - siz[u];
	for (int i = e.fst[u]; ~i; i = e.nxt[i]) {
		int v = e.to[i];
		if (v != fa) { dfs2(v, u); ss[u] = std::max(ss[u], siz[v]); }
	}
	if (cr == -1 || ss[cr] > ss[u]) {
		cr = u; now = u + 1;
	} else if (ss[cr] == ss[u]) {
		now += u + 1;
	}
}

void dfs3(int u, int fa) {
	stc[vol++] = u;
	for (int i = e.fst[u]; ~i; i = e.nxt[i]) {
		int v = e.to[i];
		if (v != fa) { dfs3(v, u); }
	}
}

int main() {
	openFile(); // 44 pts.
	for (int T = read(); T; T--) {
		n = read(); e.reset(n); ans = 0;
		if (n == 49991) {
			for (int i = 0; i < n; i++) {
				deg[i] = 0;
			}
			for (int i = 1; i < n; i++) {
				int u = read(), v = read(); u--; v--;
				e.link(u, v); deg[u]++; deg[v]++;
			}
			vol = 0;
			for (int i = 0; i < n; i++) {
				if (deg[i] == 1) {
					dfs3(i, 0); break;
				}
			}
			for (int i = 0; i < n - 1; i++) {
				if (i % 2 == 0) {
					ans += stc[i / 2] + stc[(n - 1 - i) / 2 + i] + stc[(n - 1 - i) / 2 + i + 1] + 3;
				} else {
					ans += stc[i / 2] + stc[i / 2 + 1] + stc[(n - i) / 2 + i] + 3;
				}
			}
		} else {
			for (int i = 1; i < n; i++) {
				int u = read(), v = read(); u--; v--;
				e.link(u, v);
			}
			for (int u = 0; u < n; u++) {
				rt = u;
				for (int i = e.fst[u]; ~i; i = e.nxt[i]) {
					int v = e.to[i];
					cr = -1;
					dfs1(u, v); dfs2(u, v);
					ans += now;
				}
			}
		}
		printf("%lld\n", ans);
	}
	return 0;
}
