#include <cctype>
#include <cstdio>
#include <algorithm>

void openFile() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
}

inline int read() {
	char c; for (c = getchar(); !isdigit(c); c = getchar());
	int x; for (x = 0; isdigit(c); c = getchar()) { x = x * 10 + c - '0'; } return x;
}

const int N = 4e7 + 5, M = 2e5 + 5, lim = 1e9;

int n, m, l, r, T, a[N], b[N], pre[N], que[N];
int seedx, seedy, seedz, p[M], pl[M], pr[M];
long long ans[4], tmp[4], res[4];
long long sum[N];

inline long long get(int i) {
	return sum[i] - sum[pre[i]];
}

void update(long long ar[], int i) {
	if (ar[i] > lim) {
		ar[i + 1] += ar[i] / lim;
		ar[i] %= lim;
		update(ar, i + 1);
	}
}

int main() {
	openFile(); // 100 pts.
	n = read(); T = read();
	if (T == 0) {
		for (int i = 1; i <= n; i++) {
			a[i] = read();
			sum[i] = sum[i - 1] + a[i];
		}
	} else {
		seedx = read(); seedy = read(); seedz = read();
		b[1] = read(); b[2] = read(); m = read();
		for (int i = 3; i <= n; i++) {
			b[i] = (1ll * seedx * b[i - 1] + 1ll * seedy * b[i - 2] + seedz) % 1073741824;
		}
		for (int i = 1; i <= m; i++) {
			p[i] = read(); pl[i] = read(); pr[i] = read();
			int len = pr[i] - pl[i] + 1;
			for (int j = p[i - 1] + 1; j <= p[i]; j++) {
				a[j] = b[j] % len + pl[i];
			}
		}
		for (int i = 1; i <= n; i++) {
			sum[i] = sum[i - 1] + a[i];
		}
	}
	l = 1; r = 1; que[1] = 0;
	for (int i = 1; i <= n; i++) {
		for (; l < r && get(que[l + 1]) + sum[que[l + 1]] <= sum[i]; l++);
		pre[i] = que[l];
		for (; l <= r && get(que[r]) + sum[que[r]] >= get(i) + sum[i]; r--);
		que[++r] = i;
	}
	l = n - 1; r = n;
	while (true) {
		if (r == 0) { break; }
		if (sum[r] - sum[l] >= get(l)) {
			tmp[0] = (sum[r] - sum[l]) % lim;
			tmp[1] = (sum[r] - sum[l]) / lim;
			update(tmp, 3);
			res[0] = res[1] = res[2] = res[3] = 0;
			res[0] += 1ll * tmp[0] * tmp[0]; update(res, 0);
			res[1] += 1ll * tmp[0] * tmp[1]; update(res, 1);
			res[1] += 1ll * tmp[1] * tmp[0]; update(res, 1);
			res[2] += 1ll * tmp[1] * tmp[1]; update(res, 2);
			ans[0] += res[0]; update(ans, 0);
			ans[1] += res[1]; update(ans, 1);
			ans[2] += res[2]; update(ans, 2);
			ans[3] += res[3]; update(ans, 3);
			r = l; l--;
		} else {
			l--;
		}
	}
	int flag = -1;
	for (int i = 3; i >= 0; i--) {
		if (flag == -1) {
			if (ans[i] > 0) {
				flag = 1;
				printf("%lld", ans[i]);
			}
		} else {
			printf("%09lld", ans[i]);
		}
	}
	return 0;
}
