#include <bits/stdc++.h>
using namespace std;
const int maxn = 50500;
struct Edge {
	int v, nxt;
	Edge() {}
	Edge (int _v, int _nxt) { v = _v; nxt = _nxt; }
} edge[maxn<<1];
int g[maxn], n, T, nume;
long long ans;
int size[maxn], vis[maxn], top[maxn], fa[maxn];
int d[maxn];
void init() {
	memset(g+1, -1, sizeof(int)*n);
	memset(vis+1, -1, sizeof(int)*n);
	memset(d+1, 0, sizeof(int)*n);
	nume = 0;
}
void addedge(int u, int v) {
	edge[nume] = Edge(v, g[u]); g[u] = nume ++;
	edge[nume] = Edge(u, g[v]); g[v] = nume ++;
	d[u] ++;
	d[v] ++;
}
void dfs(int u, int p, int rt, int eid) {
	fa[u] = p;
	top[u] = rt;
	vis[u] = eid;
	size[u] = 1;
	for (int i = g[u]; i != -1; i = edge[i].nxt) {
		int v = edge[i].v;
		if (i/2 == eid || v == p) continue;
		dfs(v, u, rt, eid);
		size[u] += size[v];
	}
}
bool solve_point(int u, int eid) {
	int topsz = size[ top[u] ];
	int tmpsz = 1;
	for (int i = g[u]; i != -1; i = edge[i].nxt) {
		int v = edge[i].v;
		if (i/2 == eid || v == fa[u]) continue;
		tmpsz += size[v];
		if (size[v] > topsz/2) return false;
	}
	if (topsz - tmpsz > topsz/2) return false;
	return true;
}
void handle_eid(int eid) {
	int rt1 = -1, rt2 = -1;
	for (int i = 1; i <= n; i ++) {
		if (vis[i] < eid) {
			dfs(i, -1, i, eid);
		}
	}
	for (int i = 1; i <= n; i ++) {
		if (solve_point(i, eid)) ans += i;
	}
}
void handle() {
	for (int eid = 0; eid < nume/2; eid ++) {
		handle_eid(eid);
	}
	printf("%lld\n", ans);
}
bool check_chain() {
	for (int i = 1; i <= n; i ++) if (d[i] > 2) return false;
	return true;
}
int rev[maxn], dep[maxn];
void dfs_chain(int u, int p) {
	for (int i = g[u]; i != -1; i = edge[i].nxt) {
		int v = edge[i].v;
		if (v == p) continue;
		dep[v] = dep[u] + 1;
		rev[ dep[v] ] = v;
		dfs_chain(v, u);
	}
}
bool solve_chain() {
	int rt;
	for (int i = 1; i <= n; i ++) if (d[i] == 1) {
		rt = i;
		break;
	}
	dep[rt] = 1;
	rev[1] = rt;
	dfs_chain(rt, -1);
	for (int i = 1; i < n; i ++) {
		int s1 = 1, t1 = i, s2 = i+1, t2 = n;
		if (s1%2 == t1%2) {
			int id = rev[ (s1+t1)/2 ];
			ans += id;
		}
		else {
			int id1 = rev[ (s1+t1)/2 ];
			int id2 = rev[ (s1+t1+1)/2 ];
			ans += id1 + id2;
		}
		if (s2%2 == t2%2) {
			int id = rev[ (s2+t2)/2 ];
			ans += id;
		}
		else {
			int id1 = rev[ (s2+t2)/2 ];
			int id2 = rev[ (s2+t2+1)/2 ];
			ans += id1 + id2;
		}
	}
	printf("%lld\n", ans);
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &T);
	while (T --) {
		scanf("%d", &n);
		init();
		ans = 0;
		for (int i = 1; i < n; i ++) {
			int x, y;
			scanf("%d%d", &x, &y);
			addedge(x, y);
		}
		if (check_chain()) {
			solve_chain();
			continue;
		}
		handle();
	}
	return 0;
}
/**
5
1

*/
