#include <algorithm>
#include <cstdio>
#include <cstring>

const int N = 20000;

int n;
struct Edge {
  int u, v, nxt;

  Edge() : u(0), v(0), nxt(0) {}
  Edge(int _u, int _v, int _nxt) : u(_u), v(_v), nxt(_nxt) {}
} e[N << 1];
int head[N], edge_cnt;
int pos1, pos2;

void AddEdge(int u, int v) {
  e[++edge_cnt] = Edge(u, v, head[u]);
  head[u] = edge_cnt;
}

int sze[N], f[N];

void Dfs(int u, int fa) {
  sze[u] = 1;
  f[u] = 0;
  for (int i = head[u]; i; i = e[i].nxt) {
    int v = e[i].v;
    if (v == fa)
      continue;
    Dfs(v, u);
    sze[u] += sze[v];
    f[u] = std::max(f[u], sze[v]);
  }
  f[u] = std::max(f[u], sze[u] - f[u] - 1);
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  int T;
  scanf("%d", &T);
  while (T--) {
    scanf("%d", &n);
    memset(head, 0, sizeof(head));
    edge_cnt = 0;
    for (int i = 2, u, v; i <= n; ++i) {
      scanf("%d%d", &u, &v);
      AddEdge(u, v);
      AddEdge(v, u);
    }
    int ans = 0;
    for (int i = 1; i <= edge_cnt; i += 2) {
      int pos1 = i, pos2 = i + 1;
      // printf("%d %d: \n", e[i].u, e[i].v);
      memset(f, 0x3f, sizeof(f));
      memset(sze, 0, sizeof(sze));
      Dfs(e[i].u, e[i].v);
      int maxn = 1e9;
      for (int j = 1; j <= n; ++j)
        maxn = std::min(maxn, f[j]);
      for (int j = 1; j <= n; ++j)
        if (maxn == f[j])
          ans += j;
      memset(f, 0x3f, sizeof(f));
      memset(sze, 0, sizeof(sze));
      Dfs(e[i].v, e[i].u);
      maxn = 1e9;
      for (int j = 1; j <= n; ++j)
        maxn = std::min(maxn, f[j]);
      for (int j = 1; j <= n; ++j)
        if (maxn == f[j])
          ans += j;
    }
    printf("%d\n", ans);
  }
  return 0;
}
