#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

ifstream fin("centroid.in");
ofstream fout("centroid.out");

int T, n;

namespace SubTask1 {
const int kMaxN = 2005;
int head[kMaxN], ecnt = -1, sz[kMaxN], origsz[kMaxN], nodes;
ll ans;
struct Edge {
	int to, nxt, iscut;
} e[kMaxN << 1];
void addEdge(int u, int v) {
	e[++ecnt].nxt = head[u];
	e[ecnt].to = v;
	e[ecnt].iscut = 0;
	head[u] = ecnt; 
}
void resolve(int x, int fa) {
	sz[x] = 1;
	for (int i = head[x]; ~i; i = e[i].nxt) {
		if (e[i].to == fa || e[i].iscut) {
			continue;
		}
		resolve(e[i].to, x);
		sz[x] = sz[x] + sz[e[i].to];
	}
//	cerr << x << " - " << sz[x] << endl;
}
void findG(int x, int fa) {
	int sum = 0, isg = 1;
	for (int i = head[x]; ~i; i = e[i].nxt) {
		if (e[i].to == fa || e[i].iscut) {
			continue;
		}
		if (sz[e[i].to] > nodes / 2) {
			isg = 0;
		}
		sum = sum + sz[e[i].to];
		findG(e[i].to, x);
	}
	if (nodes - sum - 1 > nodes / 2) {
		isg = 0;
	}
	if (isg) {
		ans = ans + x;
//		cerr << x << endl;
	}
}
void dfs1(int x, int fa) {
	for (int i = head[x]; ~i; i = e[i].nxt) {
		if (e[i].to == fa) {
			continue;
		}
		e[i].iscut = e[i ^ 1].iscut = 1;
//		cerr << x << " " << e[i].to << endl;
		nodes = n - origsz[e[i].to];
		memset(sz, 0x00, sizeof sz);
		resolve(x, 0);
		findG(x, 0);
//		cerr << x << " " << e[i].to << endl;
		nodes = origsz[e[i].to];
		memset(sz, 0x00, sizeof sz);
		resolve(e[i].to, 0);
		findG(e[i].to, 0);
		e[i].iscut = e[i ^ 1].iscut = 0;
		dfs1(e[i].to, x);
	}
}
void dfs0(int x, int fa) {
	origsz[x] = 1;
	for (int i = head[x]; ~i; i = e[i].nxt) {
		if (e[i].to == fa) {
			continue;
		}
		dfs0(e[i].to, x);
		origsz[x] = origsz[x] + origsz[e[i].to];
	}
}
int exec() {
	memset(head, 0xff, sizeof head);
	ecnt = -1;
	ans = 0;
	memset(origsz, 0x00, sizeof origsz);
	for (int i = 1; i < n; ++i) {
		int x, y;
		fin >> x >> y;
		addEdge(x, y);
		addEdge(y, x);
	}
	dfs0(1, 0);
	dfs1(1, 0);
	fout << ans << endl;
	return 0;
}
}

namespace SubTask2 {
const int kMaxN = 50005;
vector<int> G[kMaxN];
int cnt, seq[kMaxN];
void dfs(int x, int fa) {
	seq[++cnt] = x;
	for (int i = 0; i < G[x].size(); ++i) {
		if (G[x][i] == fa) {
			continue;
		}
		dfs(G[x][i], x);
	}
}
int exec() {
	cnt = 0;
	for (int i = 1; i <= n; ++i) {
		G[i].clear();
	}
	memset(seq, 0x00, sizeof seq);
	for (int i = 1; i < n; ++i) {
		int x, y;
		fin >> x >> y;
		G[x].push_back(y);
		G[y].push_back(x);
	}
	int deg1cnt = 0, deg2cnt = 0, startpoint = 0;
	for (int i = 1; i <= n; ++i) {
		deg1cnt += (G[i].size() == 1);
		deg2cnt += (G[i].size() == 2);
		if (G[i].size() == 1) {
			startpoint = i;
		}
	}
	ll ans = 0;
	if (deg1cnt == 2 && deg2cnt == n - 2) {
		// list
		dfs(startpoint, 0);
		for (int i = 1; i < n; ++i) {
			// break (seq[i], seq[i + 1]) then [1..i] [i+1..n]
			if (i & 1) {
				// i is odd
				ans = ans + seq[(i + 1) / 2];
			} else {
				ans = ans + seq[i / 2] + seq[i / 2 + 1];
			}
			if ((n - i) & 1) {
				ans = ans + seq[(n + i + 2) / 2];
			} else {
				ans = ans + seq[(n + i + 1) / 2] + seq[(n + i + 1) / 2 + 1];
			}
		}
	}
	fout << ans << endl;
	return 0;
}
}

int main() {
	fin >> T;
	while (T--) {
		fin >> n;
		if (n <= 2000) {
			SubTask1::exec(); // 40pts
			continue;
		} else {
			SubTask2::exec(); // 15pts
			continue;
		}
	}
	return 0;
}
