// Developed by Nekroz
#include <cstdio>
#include <cstring>
#include <iostream>
#include <algorithm>
#define N 300005
#define mp std::make_pair
const int BUF = 1 << 21;
char buf[BUF], *p1 = buf, *p2 = buf;
#define gc() (p1 == p2 && (p2 = (p1 = buf) + fread(buf, 1, BUF, stdin)), p1 == p2 ? EOF : *p1++)
//#define gc() getchar()
class Scanner {
public:
	inline int nextInt() {
		int num = 0, sign = 1; char ch = gc();
		while (ch < '0' || ch > '9') sign = ch == '-' ? -1 : 1, ch = gc();
		while (ch >= '0' && ch <= '9') num = (num << 3) + (num << 1) + (ch ^ '0'), ch = gc();
		return num * sign;
	}
} cin;
struct edgeType {
	int to, next; bool ban;
} edge[N << 1];
int head[N], cnt;
inline void addEdge(int from, int to) {
	edge[++cnt] = (edgeType){to, head[from], false};
	head[from] = cnt;
}
int size[N];
typedef std::pair< int, int > pii;
inline long long unpack(pii ret) {
	return 1ll * ret.first + 1ll * ret.second;
}
inline void merge(pii &a, pii b) {
	if (b.first == 0) return;
	if (a.first == 0) a = b;
	else a = mp(a.first, b.first);
}
inline void count(int u, int p) {
	size[u] = 1;
	for (int i = head[u]; i; i = edge[i].next) {
		int v = edge[i].to;
		if (v == p || edge[i].ban) continue;
		count(v, u);
		size[u] += size[v];
	}
}
pii solve(int u, int p, int l) {
	bool flag = true; pii ret = mp(0, 0);
	for (int i = head[u]; i; i = edge[i].next) {
		int v = edge[i].to;
		if (v == p || edge[i].ban) continue;
		merge(ret, solve(v, u, l));
		if (2 * size[v] > l) flag = false;
	}
	if (l - size[u] > l / 2) flag = false;
	if (flag) (ret.first == 0) ? ret.first = u : ret.second = u;
	return ret;
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	for (int T = cin.nextInt(); T--; ) {
		int n = cin.nextInt(); long long ans = 0;
		memset(head, 0, sizeof head); cnt = 1;
		for (int i = 1; i < n; i++) {
			int u = cin.nextInt(), v = cin.nextInt();
			addEdge(u, v), addEdge(v, u);
		}
		for (int i = 2; i <= cnt; i += 2) {
			edge[i].ban = true, edge[i ^ 1].ban = true; 
			count(edge[i].to, 0), count(edge[i ^ 1].to, 0);
			ans += unpack(solve(edge[i].to, 0, size[edge[i].to])) + unpack(solve(edge[i ^ 1].to, 0, size[edge[i ^ 1].to]));
			edge[i].ban = false, edge[i ^ 1].ban = false;
		}
		printf("%lld\n", ans);
	}
	return 0;
}
