#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

template <typename T>
inline void read(T &f) {
	f = 0; T fu = 1; char c = getchar();
	while(c < '0' || c > '9') { if(c == '-') { fu = -1; } c = getchar(); }
	while(c >= '0' && c <= '9') { f = (f * 10) + c - '0'; c = getchar(); }
	f *= fu;
}

const int N = 3e5 + 5;

int lc[N * 25], rc[N * 25], sum[N * 25], rt[N];
int tot;

void change(int &u, int l, int r, int x, int y) {
	if(!u) u = ++tot;
	if(l == r) {
		sum[u] += y;
		return;
	}
	int mid = (l + r) >> 1;
	if(mid >= x) change(lc[u], l, mid, x, y);
	else change(rc[u], mid + 1, r, x, y);
	sum[u] = sum[lc[u]] + sum[rc[u]];
}

int query(int u, int L, int R, int l, int r) {
	if(!u) return 0;
	if(l <= L && R <= r) return sum[u];
	int mid = (L + R) >> 1, ans = 0;
	if(mid >= l) ans += query(lc[u], L, mid, l, r);
	if(mid + 1 <= r) ans += query(rc[u], mid + 1, R, l, r);
	return ans;
}

int merge(int u, int v, int l, int r) {
	if(!u || !v) return u | v;
	if(l == r) { sum[u] += sum[v]; return u; }
	int mid = (l + r) >> 1;
	lc[u] = merge(lc[u], lc[v], l, mid);
	rc[u] = merge(rc[u], rc[v], mid + 1, r);
	sum[u] = sum[lc[u]] + sum[rc[u]];
	return u;
}

struct edge_t {
	int u, v, nxt;
	edge_t (int a = 0, int b = 0, int c = 0) : u(a), v(b), nxt(c) {}
} G[N << 1];

int hd[N], siz[N], maxn[N][2], ans[N];
int T, n, cnt;

inline void addedge(int u, int v) {
	G[++cnt] = edge_t(u, v, hd[u]), hd[u] = cnt;
	G[++cnt] = edge_t(v, u, hd[v]), hd[v] = cnt;
}

void ins(int u, int x) {
	if(x > maxn[u][0]) {
		maxn[u][1] = maxn[u][0];
		maxn[u][0] = x;
	} else if(x > maxn[u][1]) maxn[u][1] = x;
}

void dfs1(int u, int fa) {
	siz[u] = 1;
	for(register int i = hd[u]; i; i = G[i].nxt) {
		int v = G[i].v;
		if(v == fa) continue;
		dfs1(v, u);
		siz[u] += siz[v];
		ins(u, siz[v]);
	}
	ins(u, n - siz[u]);
}

void dfs2(int u, int fa) {
	for(register int i = hd[u]; i; i = G[i].nxt) {
		int v = G[i].v;
		if(v == fa) continue;
		dfs2(v, u);
		change(rt[v], 1, n, siz[v], 1);
		if(siz[v] == maxn[u][0]) {
			int l = max(1, 2 * maxn[u][0] - n), r = min(n - 1, maxn[u][0] - maxn[u][1]);
			if(l <= r) ans[u] += query(rt[v], 1, n, l, r);
			l = max(1, maxn[u][0] - maxn[u][1] + 1), r = min(n - 1, n - 2 * maxn[u][1]);
			if(l <= r) ans[u] += query(rt[v], 1, n, l, r);
		} else {
			int l = 1, r = n - 2 * maxn[u][0];
			if(l <= r) ans[u] += query(rt[v], 1, n, l, r);
		}
		rt[u] = merge(rt[u], rt[v], 1, n);
	}
	if(n - siz[u] == maxn[u][0]) {
		int l = max(1, 2 * maxn[u][0] - n), r = min(n - 1, maxn[u][0] - maxn[u][1]);
		if(l <= r) ans[u] -= query(rt[u], 1, n, l, r);
		l = max(1, maxn[u][0] - maxn[u][1] + 1), r = min(n - 1, n - 2 * maxn[u][1]);
		if(l <= r) ans[u] -= query(rt[u], 1, n, l, r);
	} else {
		int l = 1, r = n - 2 * maxn[u][0];
		if(l <= r) ans[u] -= query(rt[u], 1, n, l, r);
	}
}

int f[N];

inline int lowbit(int x) { return x & -x; }

inline void add(int x, int y) {
	while(x <= n) {
		f[x] += y;
		x += lowbit(x);
	}
}

inline int query(int x) {
	int ans = 0;
	while(x) {
		ans += f[x];
		x ^= lowbit(x);
	}
	return ans;
}

inline int query(int l, int r) {
	return query(r) - query(l - 1);
}

void dfs3(int u, int fa) {
	if(n - siz[u] == maxn[u][0]) {
		int l = max(1, 2 * maxn[u][0] - n), r = min(n - 1, maxn[u][0] - maxn[u][1]);
//		if(u == 3) fprintf(stderr, "l = %d, r = %d, val = %d\n", l, r, query(rt[1], 1, n, l, r));
		if(l <= r) ans[u] += query(l, r);
		l = max(1, maxn[u][0] - maxn[u][1] + 1), r = min(n - 1, n - 2 * maxn[u][1]);
		if(l <= r) ans[u] += query(l, r);
	} else {
		int l = 1, r = n - 2 * maxn[u][0];
		if(l <= r) ans[u] += query(l, r);
	}
	for(register int i = hd[u]; i; i = G[i].nxt) {
		int v = G[i].v;
		if(v == fa) continue;
		add(siz[v], -1);
		add(n - siz[v], 1);
		dfs3(v, u);
		add(siz[v], 1);
		add(n - siz[v], -1);
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	read(T);
	while(T--) {
		memset(hd, 0, sizeof(hd));
		memset(lc, 0, sizeof(lc));
		memset(rc, 0, sizeof(rc));
		memset(sum, 0, sizeof(sum));
		memset(ans, 0, sizeof(ans));
		memset(maxn, 0, sizeof(maxn));
		memset(rt, 0, sizeof(rt));
		memset(f, 0, sizeof(f));
		cnt = tot = 0;
		read(n);
		for(register int i = 1; i < n; i++) {
			int u, v;
			read(u); read(v);
			addedge(u, v);
		}
		dfs1(1, 0); dfs2(1, 0);
		for(register int i = 2; i <= n; i++) add(siz[i], 1);
		dfs3(1, 0);
		ll s = 0;
		for(register int i = 1; i <= n; i++) {
//			fprintf(stderr, "ans[%d] = %d\n", i, ans[i]);
			s += 1ll * i * ans[i];
		}
		cout << s << endl;
	}
	return 0;
}

// ˲Ҫҳ QAQ 
