#include <cstdio>
#include <cstring>
#include <set>
using namespace std;
typedef long long LL;
const int MAXN=3e5+10;
int T,N;
set<int> Adj[MAXN];
struct Edge{
	int u,v;
	Edge(){}
	Edge(int _u,int _v){
		u=_u;
		v=_v;
	}
}E[MAXN];
int ENum;
LL ans;
int sz[MAXN],father[MAXN];
int dfs1(int u,int fa){
	sz[u]=1;
	father[u]=fa;	
	for(set<int>::iterator it=Adj[u].begin();it!=Adj[u].end();it++){
		int v=*it;
		if(v!=fa){
			sz[u]+=dfs1(v,u);
		}
	}
	return sz[u];
}
int dfs2(int u,int fa,int tn){
	for(set<int>::iterator it=Adj[u].begin();it!=Adj[u].end();it++){
		int v=*it;
		if(v!=fa){
			if(sz[u]>tn/2){
				return dfs2(v,u,tn);
			}
		}
	}
	return u;
}
bool judge(int u,int fa,int tn){
	for(set<int>::iterator it=Adj[u].begin();it!=Adj[u].end();it++){
		int v=*it;
		if(v!=fa){
			if(sz[u]>tn/2){
				return false;
			}
		}
	}
	return true;
}
int findg(int u){
	dfs1(u,0);
	return dfs2(u,0,sz[u]);
}
int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	
	scanf("%d",&T);
	while(T--){
		for(int i=0;i<MAXN;i++){
			Adj[i].clear();
		}
		ENum=0;
		ans=0;
		scanf("%d",&N);
		for(int i=0;i<N-1;i++){
			int u,v;
			scanf("%d%d",&u,&v);
			Adj[u].insert(v);
			Adj[v].insert(u);
			if(u>v){
				swap(u,v);
			}
			E[++ENum]=Edge(u,v);
		}
		for(int t1=1;t1<=ENum;t1++){
			int u=E[t1].u,v=E[t1].v;
			Adj[u].erase(v);
			Adj[v].erase(u);
			memset(sz,0,sizeof(sz));
			memset(father,0,sizeof(father));
			int g1=findg(u);
			ans=ans+g1;
			for(set<int>::iterator it=Adj[g1].begin();it!=Adj[g1].end();it++){
				int g11=*it;
				if(judge(g11,father[g11],sz[u])){
					ans=ans+g11;
				}
			}
			memset(sz,0,sizeof(sz));
			memset(father,0,sizeof(father));
			int g2=findg(v);
			ans=ans+g2;
			for(set<int>::iterator it=Adj[g2].begin();it!=Adj[g2].end();it++){
				int g21=*it;
				if(judge(g21,father[g21],sz[v])){
					ans=ans+g21;
				}
			}
			Adj[u].insert(v);
			Adj[v].insert(u);
		}
		printf("%lld\n",ans);
	}
	
	fclose(stdin);
	fclose(stdout);
	return 0;
}
