#include <iostream>
#include <algorithm>
#include <cstdio>
#include <cstring>

template <typename Tp>
inline void read(Tp &x) {
    x = 0;
    bool f = true; char ch = getchar();
    for ( ; ch < '0' || ch > '9'; ch = getchar()) f ^= ch == '-';
    for ( ; ch >= '0' && ch <= '9'; ch = getchar()) x = x * 10 + (ch ^ 48);
    x = f ? x : -x;
}

const int N = 3e5 + 7;

int Head[N], Cnt;

struct Edge {
    int to, nxt;
};
Edge e[N << 1];

inline void Add_edge(int x, int y) {
    e[++Cnt] = (Edge) {y, Head[x]}, Head[x] = Cnt;
}

int Siz[N], Tot1, Tot2, Ansx, Ansy, Max;

inline void Dfs(int x, int last, int f, int k) {
    if (f) ++Tot1;
    else ++Tot2;
    for (int i = Head[x]; i; i = e[i].nxt) {
        int v = e[i].to;
        if (v == last || i == k || i == (k ^ 1)) continue;
        Dfs(v, x, f, k);
    }
}

inline void Dfs1(int x, int last, int f, int k) {
    Siz[x] = 1;
    int Mson = 0;
    for (int i = Head[x]; i; i = e[i].nxt) {
        int v = e[i].to;
        if (v == last || i == k || i == (k ^ 1)) continue;
        Dfs1(v, x, f, k);
        Siz[x] += Siz[v];
        Mson = std::max(Siz[v], Mson); 
    }
    Mson = std::max(Mson, (f ? Tot1 : Tot2) - Siz[x]);
    if (Mson < Max) {
        Max = Mson;
        if (f) Ansx = x;
        else Ansy = x;
    }
    else if (Mson == Max) {
        if (f) Ansx += x;
        else Ansy += x;
    }
}

int Deg[N], Anss, l, r, Top, t[N], Pos;

inline void Dfs2(int x, int last) {
    Pos = x;
    for (int i = Head[x]; i; i = e[i].nxt) {
        int v = e[i].to;
        if (v == last) continue;
        t[++Top] = v;
        if (l == r) {
            Anss += t[l];
            ++r;
        }
        else {
            Anss += t[l] + t[r];
            ++l;
        }
        Dfs2(v, x);
    }
}

int main() {
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    int T;
    read(T);
    while (T--) {
        memset(Head, 0, sizeof(Head));
        memset(Deg, 0, sizeof(Deg));
        Cnt = 1;
        int n;
        read(n);
        for (int i = 1; i < n; ++i) {
            int u, v;
            read(u), read(v);
            Add_edge(u, v), Add_edge(v, u);
            ++Deg[u], ++Deg[v];
        }
        int Tot = 0;
        Pos = 0;
        for (int i = 1; i <= n; ++i) if (Deg[i] == 1) ++Tot, Pos = i;
        if (Tot == 2) {
            Anss = 0, l = r = Top = 1, t[r] = Pos;
            Dfs2(Pos, 0);
            l = r = Top = 1, t[r] = Pos;
            Dfs2(Pos, 0);
            printf("%d\n", Anss);
            continue;
        } 
        int Ans = 0;
        for (int i = 1; i < n; ++i) {
            Tot1 = Tot2 = 0;
            Dfs(e[i * 2].to, 0, 0, i * 2), Dfs(e[i * 2 + 1].to, 0, 1, i * 2);
            Max = n, Ansx = Ansy = 0;
            Dfs1(e[i * 2].to, 0, 0, i * 2);
            Max = n;
            Dfs1(e[i * 2 + 1].to, 0, 1, i * 2);
            Ans += Ansx + Ansy;
        }
        printf("%d\n", Ans);
    }
    return 0;
}