#include <algorithm>
#include <cstdio>

#define FORTO(e, v, _) for (int e = back[_], v = E[e].to; e; v = E[e = E[e].next].to)

const int kMaxn = 3e5 + 5;

typedef long long LL;
typedef int Arr[kMaxn];

struct Edge { int to, next; } E[kMaxn << 1];

int n, cnte;
Arr back, sz, D;
LL ans;

inline void AddE(int u, int v) { E[++cnte] = (Edge){v, back[u]}, back[u] = cnte, E[++cnte] = (Edge){u, back[v]}, back[v] = cnte; ++D[u], ++D[v]; }
void Solve();

int main() {
#ifndef LOCAL
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
#endif
	int t; scanf("%d", &t);
	while (t--) Solve();
	return 0;
}

namespace solver1 {
	void Dfs(int u, int fa) {
		sz[u] = 1;
		FORTO(e, v, u) if (v != fa) { Dfs(v, u); sz[u] += sz[v]; }
	}
	int Dfs(int u, int fa, int all) {
		int szu = 1, mxsz = 0, szv;
		FORTO(e, v, u) if (v != fa) { szv = Dfs(v, u, all); szu += szv, mxsz = std::max(mxsz, szv); }
		if ((mxsz = std::max(mxsz, all - szu)) * 2 <= all) ans += u;
		return szu;
	}
	void Solve() {
		Dfs(1, 0);
		for (int e = 2, u, v; e <= cnte; e += 2) {
			u = E[e].to, v = E[e ^ 1].to;
			if (sz[u] < sz[v]) std::swap(u, v);
			Dfs(u, v, n - sz[v]); Dfs(v, u, sz[v]);
		}
	}
}

namespace solver2 {
	const int kMaxn = 5e4 + 5;
	int dfsc, seq[kMaxn];

	void Dfs(int u, int fa) {
		seq[++dfsc] = u;
		FORTO(e, v, u) if (v != fa) Dfs(v, u);
	}
	void Solve() {
		dfsc = 0;
		for (int i = 1; i <= n; ++i) if (D[i] == 1) { Dfs(i, 0); break; }
		for (int t, i = 1; i < n; ++i) {
			ans += seq[i / 2 + 1], t = n - i;
			if (i & 1 ^ 1) ans += seq[i / 2];
			ans += seq[i + 1 + t / 2];
			if (t & 1 ^ 1) ans += seq[i + t / 2];
		}
	}
}

bool CheckLink() {
	for (int i = 1; i <= n; ++i) if (D[i] > 2) return false;
	return true;
}

void Solve() {
	// Don't forget init!
	scanf("%d", &n);
	ans = 0, cnte = 1; std::fill(back, back + n + 1, 0); std::fill(D, D + n + 1, 0);
	for (int i = 1, x, y; i < n; ++i) { scanf("%d%d", &x, &y); AddE(x, y); }
	if (n <= 2000) solver1::Solve();
	else if (CheckLink()) solver2::Solve();
	printf("%lld\n", ans);
}
