#include <algorithm>
#include <cstdio>

const int kMaxn = 105, kMaxm = 2005, kMod = 998244353;

inline int Add(int a, int b) { return (a += b) >= kMod ? a - kMod : a; }
inline int Sub(int a, int b) { return (a -= b) < 0 ? a + kMod : a; }
inline int Mul(int a, int b) { return 1ll * a * b % kMod; }
inline void Upa(int & a, int b) { a = Add(a, b); }
inline void Ups(int & a, int b) { a = Sub(a, b); }
inline void Upm(int & a, int b) { a = Mul(a, b); }
int FPow(int bs, int ex = kMod - 2) {
	int res = 1;
	for (; ex; Upm(bs, bs), ex >>= 1) if (ex & 1) Upm(res, bs);
	return res;
}

int n, m, ans;
int A[kMaxn][kMaxm];

inline int LowBit(int x) { return x & -x; }
inline int Cnt(int x) {
	int r = 0;
	for (; x; x ^= LowBit(x)) ++r;
	return r;
}
// namespace solver1 { void Solve(); }
namespace solver2 { void Solve(); }

int main() {
#ifndef LOCAL
	freopen("meal.in", "r", stdin);
	freopen("meal.out", "w", stdout);
#endif	
	scanf("%d%d", &n, &m);
	for (int i = 1; i <= n; ++i) for (int j = 0; j < m; ++j) scanf("%d", A[i] + j);
//	if (n <= 10) solver1::Solve();
//	else solver2::Solve();
	solver2::Solve();
	return 0;
}

/* namespace solver1 {
	const int kU = 1 << 10, kMaxm = 4;
	int way[kMaxm][kU], dp[kU], nxt[kU];

	void Solve() {
		int u = (1 << n) - 1;
		for (int i = 0; i < m; ++i) {
			way[i][0] = 1;
			for (int s = 1; s <= u; ++s) for (int k = 0; k < n; ++k) if (s >> k & 1) {
				way[i][s] = Mul(way[i][s ^ 1 << k], A[k][i]); break;
			//	printf(" way[%d][%d] %d\n", i, s, way[i][s]);
			}
		}
		for (int i = 2; i <= n; ++i) {
			dp[0] = 1;
			for (int s = 1; s <= u; ++s) dp[s] = 0;
			for (int j = 0; j < m; ++j) {
				for (int s = 0; s <= u; ++s) nxt[s] = 0;
				for (int s = 0; s <= u; ++s) {
					int is = u ^ s, t = is;
					do {
						if (Cnt(t) <= i / 2) {
							Upa(nxt[s | t], Mul(dp[s], way[j][t]));
						} t = t - 1 & is;
					} while (t != is);
				}
				for (int s = 0; s <= u; ++s) dp[s] = nxt[s];
			}
			for (int s = 0; s <= u; ++s) if (Cnt(s) == i) Upa(ans, dp[s]);
		} printf("%d\n", ans);
	}
} */

namespace solver2 {
	int dp[2][kMaxn][kMaxn], F[kMaxm][kMaxn][kMaxn], sum[kMaxn];

	void Solve() {
		int (*prv)[kMaxn] = dp[0], (*nxt)[kMaxn] = dp[1];
		for (int i = 1; i <= n; ++i) {
			sum[i] = 0;
			for (int j = 0; j < m; ++j) Upa(sum[i], A[i][j]);
		}
		for (int i = 0; i < m; ++i) {
			for (int j = 0; j <= n; ++j) for (int k = 0; k <= n; ++k) prv[j][k] = 0;
			prv[0][0] = 1;
//			printf("%d over!!!\n", i);
			for (int tmp, j = 1; j <= n; ++j) {
				tmp = Sub(sum[j], A[j][i]);
				for (int k = 0; k <= j + 1; k++) nxt[j + 1][k] = 0;
				for (int k = 0; k <= j; ++k) {
					for (int t = 0; t <= k; ++t) {
						nxt[k][t] = prv[k][t];
						if (k) Upa(nxt[k][t], Mul(prv[k - 1][t], tmp));
						if (k && t) {
//							printf("  j %d, (%d, %d)=%d -* %d-> (%d, %d)=%d\n", j, k - 1, t - 1, prv[k - 1][t - 1], A[j][i], k, t, nxt[k][t]);
							Upa(nxt[k][t], Mul(prv[k - 1][t - 1], A[j][i]));
						}
					}
					nxt[k][k + 1] = 0;
				} std::swap(prv, nxt);
			}
			for (int j = 0; j <= n; ++j) for (int k = 0; k <= j; ++k) {
				F[i][j][k] = prv[j][k];
			}
		}
		for (int i = 1; i <= n; ++i) prv[0][i] = 0;
		prv[0][0] = 1;
		for (int i = 1; i <= n; ++i) {
			for (int j = 0; j <= i; ++j) {
				prv[i][j] = prv[i - 1][j];
				if (j) {
//					printf("  (%d, %d)=%d * %d-> %d\n", i - 1, j - 1, prv[i - 1][j - 1], sum[i], prv[i][j]);
					Upa(prv[i][j], Mul(prv[i - 1][j - 1], sum[i]));
				}
			}
		}
		for (int i = 2; i <= n; ++i) {
			Upa(ans, prv[n][i]);
//			printf(" choose %d %d\n", i, prv[n][i]);
			for (int j = 0; j < m; ++j) {
				for (int k = i / 2 + 1; k <= i; ++k) {
					Ups(ans, F[j][i][k]);
//					printf("   %d over choose %d way %d\n", j, k, F[j][i][k]);
				}
			}
		}
		printf("%d\n", ans);
	}
}
