#include <algorithm>
#include <cstdio>
#include <cstring>
#include <vector>

#define fi first
#define se second
#define pb push_back
#define SZ(_) (int)_.size()

typedef long long LL;
typedef std::pair<LL, LL> Pll;

const int kMaxn = 4e7 + 5;
const LL kInf64 = 0x3f3f3f3f3f3f3f3f;

int n, tp;
LL A[kMaxn];

namespace solver1 { void Solve(); }
// namespace solver2 { void Solve(); }
inline LL Sqr(LL x) { return x * x; }

int main() {
#ifndef LOCAL
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
#endif
	scanf("%d%d", &n, &tp);
	if (!tp) {
		for (int i = 1; i <= n; ++i) scanf("%lld", A + i);
	//	if (n <= 400) solver1::Solve();
		solver1::Solve();
	//	solver2::Solve();
	} else {
	}
	return 0;
}

namespace solver1 {
	const int kMaxn = 405;
	LL dp[kMaxn][kMaxn];

	void Solve() {
		for (int i = 1; i <= n; ++i) A[i] += A[i - 1];
		memset(dp, 0x3f, sizeof dp);
		dp[0][0] = 0;
		for (int r = 1; r <= n; ++r) {
			dp[1][r] = Sqr(A[r]);
			for (int l = 2; l <= r; ++l) {
				LL curs = A[r] - A[l - 1];
				for (int i = 0; i < l - 1; ++i) if (A[l - 1] - A[i] <= curs) dp[l][r] = std::min(dp[l][r], dp[i + 1][l - 1]);
				dp[l][r] += Sqr(A[r] - A[l - 1]);
//				printf(" dp[%d][%d] = %lld\n", l, r, dp[l][r]);
			}
		}
		LL ans = kInf64;
		for (int i = 1; i <= n; ++i) ans = std::min(ans, dp[i][n]);
		printf("%lld\n", ans);
	}
}

/* namespace solver2 {
	const int kMaxn = 5005;
	LL dp[kMaxn][kMaxn];
	std::vector<Pll> vec[kMaxn];

	void Solve() {
		for (int i = 1; i <= n; ++i) A[i] += A[i - 1];
		memset(dp, 0x3f, sizeof dp);
		dp[0][0] = 0;
		vec[0].pb(Pll(0, 0));
		for (int r = 1; r <= n; ++r) {
			dp[1][r] = Sqr(A[r]);
			vec[r].pb(Pll(A[r], dp[1][r]));
			int cur = 0;

			for (int l = r; l >= 2; --l) {
				LL curs = A[r] - A[l - 1];
//				for (int i = 0; i < l - 1; ++i) if (A[l - 1] - A[i] <= curs) dp[l][r] = std::min(dp[l][r], dp[i + 1][l - 1]);
				while (cur < SZ(vec[l - 1]) && vec[l - 1][cur].fi <= curs) ++cur;
				dp[l][r] = vec[l - 1][cur - 1].se + Sqr(A[r] - A[l - 1]);
				vec[r].pb(Pll(A[r] - A[l - 1], dp[l][r]));
			}
			std::sort(vec[r].begin(), vec[r].end());
			for (int i = 1; i < SZ(vec[r]); ++i) vec[r][i].se = std::min(vec[r][i].se, vec[r][i - 1].se);
		}
		LL ans = kInf64;
		for (int i = 1; i <= n; ++i) ans = std::min(ans, dp[i][n]);
		printf("%lld\n", ans);
	}
} */
