#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long LL;

inline LL in()
{
    LL x = 0, flag = 1;char ch = getchar();
    while (!isdigit(ch)) { if (ch == '-') flag = -1;ch =  getchar(); }
    while (isdigit(ch)) x = (x << 3) + (x << 1) + (ch ^ 48), ch = getchar();
    return x * flag;
}

int n;

const int MAXN = 3e5 +10;

int head[MAXN], nume;
struct Adj { int nex, to; } adj[MAXN << 1];
void addedge(int from, int to)
{
    adj[nume] = (Adj) { head[from], to };
    head[from] = nume ++;
}
void link(int u, int v)
{
    addedge(u, v);
    addedge(v, u);
}

LL ans;
int dgr[MAXN];
void init(int n)
{
    ans = 0;
    nume = 0;
    for (int i =1 ; i <= n; ++ i) head[i] = -1;
    for (int i = 1; i <=n; ++ i) dgr[i] = 0;
}



bool mark[MAXN << 1];
int vis[MAXN], idx;
int siz[MAXN], mxsz[MAXN];
void DFS2(int u, int fa)
{
    siz[u] = 1; vis[u] = idx;
    mxsz[u] = 0;
    for (int i = head[u]; i != -1; i = adj[i].nex)
    {
	int v = adj[i].to;
	if (v == fa || mark[i]) continue;
	DFS2(v, u);
	siz[u] += siz[v];
	mxsz[u] = max(mxsz[u], siz[v]);
    }
}
void solve()
{
    for (int i =1; i <= n; ++ i) vis[i] = 0;
    int tot1 = 0, tot2 = 0;
    idx = 0;
    for (int i = 1; i <= n; ++ i)
    {
	if (vis[i]) continue;
	++ idx;
	DFS2(i, 0); 
	if (idx == 1) tot1 = siz[i];
	else tot2 = siz[i];
    }
    int now = 0;
    for (int i = 1; i <= n; ++ i) 
    {
	if (vis[i] == 1)
	{
	    mxsz[i] = max(mxsz[i], tot1 - siz[i]);
	    if (mxsz[i] <= tot1 / 2) now += i;
	}
	else 
	{
	    mxsz[i] = max(mxsz[i], tot2 - siz[i]);
	    if (mxsz[i] <= tot2 / 2) now += i;
	}
    }
    ans += 1ll * now;
}
void DFS(int u, int fa)
{
    for (int i = head[u]; i != -1; i = adj[i].nex)
    {
	int v = adj[i].to;
	if (v == fa) continue;
	mark[i] = mark[i ^ 1] = true;
	solve();
	mark[i] = mark[i ^ 1] = false;
	DFS(v, u);
    }
}

bool case1()
{
    for (int i = 1; i <= n; ++ i) 
	if (dgr[i] > 2) return false;
    return true;
}
int rec[MAXN], top;
void DFS3(int u, int fa)
{
    rec[++ top] = u;
    for (int i = head[u]; i != -1; i = adj[i].nex)
    {
	int v = adj[i].to;
	if (v == fa) continue;
	DFS3(v, u);
    }
}
void solve1()
{
    int root = 0;
    for (int i = 1; i <= n; ++ i)
	if (dgr[i] == 1) root = i;
    top = 0;
    DFS3(root, 0);
    ans = 0;
//    for (int i = 1; i <= n; ++ i) printf("%d ", rec[i]); puts("");
    for (int i = 1; i < n; ++ i)
    {
// i & i + 1
	if (i % 2 == 0) ans += rec[i / 2] + rec[i / 2 + 1];
	else ans += rec[i / 2 +1];
	if ((n - i) % 2 == 0)  ans += rec[n - (n - i) / 2] + rec[n - (n - i) / 2 + 1];
	else ans += rec[n - (n - i) / 2];
    }
    printf("%lld\n", ans);
}

void solve2()
{
    int root = 0;
    DFS2(1, 0);
    for (int i = 1; i <= n; ++ i)
    {
	mxsz[i] = max(mxsz[i], n - siz[i]);
	if (mxsz[i] <= n / 2) root = i;
    }
    int son1 = 0, son2 = 0;
    for (int i = head[root]; i != -1; i = adj[i].nex)
    {
	int v = adj[i].to;
	if (son1 == 0) son1 = v;
	else son2 = v;
    }
//    printf("%d %d %d\n", root, son1, son2);
    ans = 0;
    ans += 1ll * son1 * (n / 2) + 1ll * son2 * (n / 2);
    ans += 1ll * (n + 1) / 2 * root;
    for (int i = 1; i <= n; ++ i)
	if (i != root) ans += 1ll * i;
    printf("%lld\n",ans);
}

int main()
{
    freopen("centroid.in", "r", stdin);
    freopen("centroid.out", "w", stdout);
    int T = in();
    while (T --)
    {
	n = in();
	init(n);
	for (int i = 1; i < n; ++ i) 
	{
	    int u = in(), v = in();
	    link(u, v);
	    dgr[u] ++ ; dgr[v] ++;
	}
	if (case1()) solve1();
	else if (n <= 1999) 
	{
	    DFS(1, 0);
	    printf("%lld\n", ans);
	}
	else solve2();
    }
    return 0;
}
