#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cstring>
#include <queue>
using namespace std;
struct edge
{
	int to, nxt;
	edge(int to = 0, int nxt = -1) : to(to), nxt(nxt) {}
} e[600001];
int t, n, E, head[300001], size[300001], fa[300001], cant1, cant2, ind[300001];
long long ans;
bool vis[300001];
queue<int> q;
void add(int f, int t)
{
	e[E].to = t;
	e[E].nxt = head[f];
	head[f] = E++;
}
void dfs(int u, int father)
{
	size[u] = 1;
	fa[u] = father;
	for (int i = head[u]; i != -1; i = e[i].nxt)
	{
		int v = e[i].to;
		if (v == father || i == cant1 || i == cant2)
		{
			continue;
		}
		dfs(v, u);
		size[u] += size[v];
	}
}
void find(int u, int root)
{
	if (!u || vis[u])
	{
		return;
	}
	vis[u] = 1;
	if (size[root] - size[u] > size[root] / 2)
	{
		find(fa[u], root);
		vis[u] = 0;
		return;
	}
	for (int i = head[u]; i != -1; i = e[i].nxt)
	{
		int v = e[i].to;
		if (v == fa[u] || i == cant1 || i == cant2)
		{
			continue;
		}
		if (size[v] > size[root] / 2)
		{
			find(v, root);
			vis[u] = 0;
			return;
		}
	}
	ans += u;
	if (!vis[fa[u]])
	{
		find(fa[u], root);
	}
	for (int i = head[u]; i != -1; i = e[i].nxt)
	{
		int v = e[i].to;
		if (v == fa[u] || i == cant1 || i == cant2)
		{
			continue;
		}
		if (!vis[v])
		{
			find(v, root);
		}
	}
	vis[u] = 0;
}
void subtask1()
{
	for (int i = 0; i < n - 1; i++)
	{
		cant1 = 2 * i;
		cant2 = 2 * i + 1;
		dfs(e[cant1].to, 0);
		dfs(e[cant2].to, 0);
		find(e[cant1].to, e[cant1].to);
		find(e[cant2].to, e[cant2].to);
	}
	printf("%lld\n", ans);
}
void subtask2()
{
	for (int i = 1; i <= n; i++)
	{
		if (ind[i] == 1)
		{
			int u = i, fa = 0;
			for (int j = 1; j <= n; j++)
			{
				size[j] = u;
				for (int k = head[u]; k != -1; k = e[k].nxt)
				{
					int v = e[k].to;
					if (v == fa)
					{
						continue;
					}
					fa = u;
					u = v;
				}
			}
			break;
		}
	}
	for (int i = 1; i <= n; i++)
	{
		ans += 3LL * size[i];
	}
	if (n & 1)
	{
		ans -= (size[1] + size[(n + 1) / 2] + size[n]);
	}
	else
	{
		ans -= (size[1] + size[n / 2] + size[n / 2 + 1] + size[n]);
	}
	printf("%lld\n", ans);
}
void subtask3()
{
	for (int i = 1; i <= n; i++)
	{
		if (ind[i] == 1)
		{
			vis[i] = 1;
			q.push(i);
		}
	}
	while (!q.empty())
	{
		int tmp = q.front();
		q.pop();
		if ((int)q.size() < 2)
		{
			ans += 1LL * tmp * (n + 1) >> 1;
			if (!q.empty())
			{
				for (int i = head[tmp]; i != -1; i = e[i].nxt)
				{
					int v = e[i].to;
					if (vis[v])
					{
						continue;
					}
					vis[v] = 1;
					q.push(v);
				}
			}
		}
		else
		{
			ans += 1LL * tmp;
			for (int i = head[tmp]; i != -1; i = e[i].nxt)
			{
				int v = e[i].to;
				if (vis[v])
				{
					continue;
				}
				vis[v] = 1;
				q.push(v);
			}
		}
	}
	printf("%lld\n", ans);
}
int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	scanf("%d", &t);
	while (t--)
	{
		memset(head, -1, sizeof(head));
		memset(size, 0, sizeof(size));
		memset(ind, 0, sizeof(ind));
		memset(vis, 0, sizeof(vis));
		E = 0;
		ans = 0;
		bool f = 1;
		scanf("%d", &n);
		for (int i = 1; i < n; i++)
		{
			int u, v;
			scanf("%d%d", &u, &v);
			add(u, v);
			add(v, u);
			ind[u]++;
			ind[v]++;
			if (ind[u] > 2 || ind[v] > 2)
			{
				f = 0;
			}
		}
		if (n < 2000)
		{
			subtask1();
			continue;
		}
		if (f)
		{
			subtask2();
			continue;
		}
		f = 1;
		for (int i = 0; (1 << i) < n; i++)
		{
			if (!(n >> i))
			{
				f = 0;
				break;
			}
		}
		if (f)
		{
			subtask3();
			continue;
		}
		printf("%lld\n", 2147483648LL);
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}
