#include<cstdio>
#include<cstring>
using namespace std;

const int maxn = 3e5 + 5;
int t, n, x[maxn], y[maxn], fa[maxn], size[maxn], ans, pr[maxn];
int nxt[maxn << 1], hed[maxn << 1], to[maxn << 1], cnt;

int read(void) {
	char c; while (c = getchar(), c < '0' || c > '9'); int x = c - '0';
	while (c = getchar(), c >= '0' && c <= '9') x = x * 10 + c - '0'; return x;
}

int getf(int x) {
	if (fa[x] != x) return fa[x] = getf(fa[x]); 
	return x;
}

void add(int x, int y) {
	nxt[++ cnt] = hed[x]; hed[x] = cnt; to[cnt] = y;
}

void init(void) {
	memset(hed, 0, sizeof(hed)); cnt = 0;
	for (int i = 1; i <= n; ++ i) fa[i] = i;
}

void dfs(int u, int pre) {
	size[u] = 1;
	for (int i = hed[u]; i ; i = nxt[i]) {
	  int v = to[i];
	    if (v == pre) continue;
	  pr[v] = u;
	  dfs(v, u);
	  size[u] += size[v];
	}
}

void solve(int r) {
	for (int i = 1; i <= n; ++ i) pr[i] = 0;
	dfs(r, 0); 
	int k = 0;
	for (int i = 1; i <= n; ++ i) if (getf(i) == r) k ++;
	k /= 2;
	for (int i = 1; i <= n; ++ i) if (getf(i) == r) {
	  int flag = 0;
	  for (int j = hed[i]; j ; j = nxt[j]) {
	  	int v = to[j];
	  	if (v == pr[i]) continue;
	  	if (size[v] > k) flag = 1;
	  }
	  if (size[r] - size[i] > k) flag = 1;
	  if (!flag) ans += i;
	}
}

int main() {
	freopen("centroid.in", "r", stdin); freopen("centroid.out", "w", stdout);
	t = read();
	  while (t --) {
	  	n = read(); ans = 0;
	  	  for (int i = 1; i < n; ++ i) x[i] = read(), y[i] = read();
	  	  for (int i = 1; i < n; ++ i) {
	  	  	  init();
	  	  	  for (int j = 1; j <= n; ++ j) if (j != i) add(x[j], y[j]), add(y[j], x[j]);
	  	  	  for (int j = 1; j <= n; ++ j) if (j != i) {
	  	  	  	    int fax = getf(x[j]), fay = getf(y[j]);
	  	  	  	    if (fax != fay) fa[fax] = fay;
				  }
			  int r1 = getf(1), r2 = 0;
		      for (int i = 1; i <= n; ++ i) if (getf(i) != r1) r2 = getf(i);
		      solve(r1);
		      solve(r2);
			}
		printf("%d\n", ans);
	  }
	return 0;
}
