#include <bits/stdc++.h>
using namespace std;

const int N = 3e5;
int n, num, head[N + 5];

struct Edge {
	int nxt, v;
	Edge() {}
	Edge(int _nxt, int _v) : nxt(_nxt), v(_v) {}
} E[N + N + 5];

inline void Add_Edge(int u, int v) {
	E[++num] = Edge(head[u], v), head[u] = num;
	E[++num] = Edge(head[v], u), head[v] = num;
}

namespace Sub1 {
	const int maxn = 2000;
	int U[maxn + 5], V[maxn + 5], siz[maxn + 5];
	int Dfs(int u, int fa) {
		siz[u] = 1;
		for (int i = head[u]; i; i = E[i].nxt) {
			int v = E[i].v;
			if (v == fa) continue;
			siz[u] += Dfs(v, u);
		}
		return siz[u];
	}
	long long ans;
	void Dfs1(int u, int fa, int all) {
		bool flag = false;
		for (int i = head[u]; i; i = E[i].nxt) {
			int v = E[i].v;
			if (v == fa) continue;
			if (siz[v] > all / 2) flag = true;
			Dfs1(v, u, all);
		}
		if (all - siz[u] > all / 2) flag = true;
		if (!flag) ans += u;
	}
	inline void Solve() {
		num = 0;
		for (int i = 1; i <= n; ++i) head[i] = 0;
		for (int i = 1; i < n; ++i) {
			scanf("%d%d", &U[i], &V[i]);
			Add_Edge(U[i], V[i]);
		}
		ans = 0;
		for (int i = 1; i < n; ++i) {
			int xx = Dfs(U[i], V[i]);
			int yy = Dfs(V[i], U[i]);
			Dfs1(U[i], V[i], xx);
			Dfs1(V[i], U[i], yy);
		}
		printf("%lld\n", ans);
	}
}

int dis[N + 5], pre[N + 5], a[N + 5];

inline int Bfs(int s) {
	queue<int> q;
	for (int i = 1; i <= n; ++i) dis[i] = 0;
	q.push(s), dis[s] = 1, pre[s] = 0;
	int res = 1;
	while (!q.empty()) {
		int u = q.front();
		q.pop();
		for (int i = head[u]; i; i = E[i].nxt) {
			int v = E[i].v;
			if (!dis[v]) {
				dis[v] = dis[u] + 1;
				pre[v] = u;
				q.push(v);
			}
		}
	}
	for (int i = 1; i <= n; ++i)
		if (dis[i] > dis[res]) res = i;
	return res;
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	scanf("%d", &T);
	while (T--) {
		scanf("%d", &n);
		if (n <= 2000) {
			Sub1::Solve();
			continue;
		}
		num = 0;
		for (int i = 1; i <= n; ++i) head[i] = 0;
		for (int i = 1, u, v; i < n; ++i) {
			scanf("%d%d", &u, &v);
			Add_Edge(u, v);
		}
		int p = Bfs(1);
		int q = Bfs(p);
		for (int now = q, x = 0; now; now = pre[now]) a[++x] = now;
		long long ans = 0;
		for (int i = 1; i < n; ++i) {
			ans += a[(i + 1) / 2];
			if (!(i & 1)) ans += a[i / 2 + 1];
		}
		reverse(a + 1, a + 1 + n);
		for (int i = 1; i < n; ++i) {
			ans += a[(i + 1) / 2];
			if (!(i & 1)) ans += a[i / 2 + 1];
		}
		printf("%lld\n", ans);
	}
	return 0;
}
/*
1
5
1 3 2 3 2 5 4 5
*/
