#include<fstream>
#include<algorithm>

using namespace std;

ifstream cin("centroid.in");
ofstream cout("centroid.out");

int cnt, head[299996], nxt[299996], to[299996], cantpass, counted[299996], father[299996], root[299996];

inline void add(int x, int y)
{
	nxt[++cnt] = head[x];
	head[x] = cnt;
	to[cnt] = y;
}

struct node
{
	int i;
	bool used;
	
	inline node() : used(false)
	{
	}
	
	inline node(int otheri) : i(otheri), used(false)
	{
	}
	
	inline node(const node& other) : i(other.i), used(other.used)
	{
	}
} stack[299996];

int stack_size = -1;

inline void Count(int i, int n)
{
	father[i] = 0;
	stack[++stack_size] = i;
	
	while (stack_size != -1)
	{
		if (stack[stack_size].used)
		{
			node now = stack[stack_size];
			counted[now.i] += 1;
			
			if (father[now.i])
			{
				counted[father[now.i]] += counted[now.i];
			}
			
			root[now.i] = i;
			--stack_size;
			continue;
		}
		
		node now = stack[stack_size];
		stack[stack_size].used = true;
		
		for (int e = head[now.i]; e; e = nxt[e])
		{			
			if (e != cantpass && e != cantpass + 1 && to[e] != father[now.i])
			{
				father[to[e]] = now.i;
				stack[++stack_size] = node(to[e]);
			}
		}
	}
}

int main()
{
	int T;
	cin >> T;
	
	while (T--)
	{
		int n;
		cin >> n;
		fill(head + 1, head + n + 1, 0);
		cnt = 0;
		
		for (int i = 1; i < n; ++i)
		{
			int x, y;
			cin >> x >> y;
			add(x, y);
			add(y, x);
		}
		
		long long ans = 0;
		
		for (cantpass = 1; cantpass <= cnt; cantpass += 2)
		{
			fill(counted + 1, counted + n + 1, 0);
			
			for (int i = 1; i <= n; ++i)
			{
				if (!counted[i])
				{
					Count(i, n);
				}
			}
			
			for (int i = 1; i <= n; ++i)
			{
				if (counted[root[i]] - counted[i] <= (counted[root[i]] >> 1))
				{
					bool flag = true;
					
					for (int e = head[i]; e; e = nxt[e])
					{
						if (e != cantpass && e != cantpass + 1 && to[e] != father[i])
						{
							if (counted[to[e]] > (counted[root[i]] >> 1))
							{
								flag = false;
								break;
							}
						}
					}
					
					if (flag)
					{
						ans += i;
					}
				}
			}
		}
		
		cout << ans << "\n";
	}
	
	return 0;
}
