#include <cstdio>
#include <cstring>
#include <algorithm>

#define maxn 300005
#define maxe (maxn << 1)

using namespace std;

int T, n, deg[maxn], siz[maxn];
int lnk[maxn], son[maxe], nxt[maxe], tot = 1;
long long ans;

class Edges
{
public:
	int x, y;
} e[maxn];

inline int read()
{
	char ch = getchar();
	int ret = 0, f = 1;
	while (ch > '9' || ch < '0')
	{
		if (ch == '-')
			f = -f;
		ch = getchar();
	}
	while (ch >= '0' && ch <= '9')
		ret = ret * 10 + ch - '0', ch = getchar();
	return ret * f;
}

namespace Sub1
{
int full;
int Count(int now, int pre)
{
	int s = 1;
	for (int j = lnk[now]; j; j = nxt[j])
	{
		if (son[j] != pre)
			s += Count(son[j], now);
	}
	return s;
}
void Solve(int now, int pre)
{
	int maxi = 0;
	siz[now] = 1;
	for (int j = lnk[now]; j; j = nxt[j])
	{
		if (son[j] == pre)
			continue;
		Solve(son[j], now);
		siz[now] += siz[son[j]];
		maxi = max(maxi, siz[son[j]]);
	}
	maxi = max(maxi, full - siz[now]);
	if (maxi <= (full >> 1))
		ans += now;
}
void main()
{
	for (int i = 1; i < n; ++i)
	{
		full = Count(e[i].x, e[i].y);
		Solve(e[i].x, e[i].y);
		full = Count(e[i].y, e[i].x);
		Solve(e[i].y, e[i].x);
	}
}
}

namespace Sub2
{
int p[maxn];
void DFS(int now, int pre, int dp)
{
	p[dp] = now;
	for (int j = lnk[now]; j; j = nxt[j])
	{
		if (son[j] == pre)
			continue;
		DFS(son[j], now, dp + 1);
	}
}
void main()
{
	for (int i = 1; i <= n; ++i)
	{
		if (deg[i] == 1)
			DFS(i, 0, 1);
	}
//	for (int i = 1; i <= n; ++i)
//		printf("%d ", p[i]);
//	puts("");
	for (int i = 1; i < n; ++i)
	{
		ans += p[i / 2 + 1];
		if ((i & 1) == 0)
			ans += p[i >> 1];
	}
	for (int i = 1; i < n - i + 1; ++i)
		swap(p[i], p[n - i + 1]);
//	for (int i = 1; i <= n; ++i)
//		printf("%d ", p[i]);
//	puts("");
	for (int i = 1; i < n; ++i)
	{
		ans += p[i / 2 + 1];
		if ((i & 1) == 0)
			ans += p[i >> 1];
	}
}
}

namespace Sub3
{
int s[maxn][2], rot, fa[maxn], full;
int DFS(int now, int pre)
{
	int cnt = 0;
	siz[now] = 1, fa[now] = pre;
	for (int j = lnk[now]; j; j = nxt[j])
	{
		if (son[j] == pre)
			continue;
		siz[now] += DFS(son[j], now);
		s[now][cnt++] = son[j];
	}
	return siz[now];
}
void Solve(int now)
{
	if (siz[now] == 0)
		return;
	int maxi = max(full - siz[now], siz[s[now][0]]);
	maxi = max(maxi, siz[s[now][1]]);
	if (maxi <= siz[rot] / 2)
	{
		ans += now;
//		printf("%d ", now);
	}
	if (full - siz[now] < max(siz[s[now][0]], siz[s[now][1]]))
	{
		Solve(s[now][0]);
		Solve(s[now][1]);
	}
}
void main()
{
	memset(fa, 0, sizeof(fa));
	memset(s, 0, sizeof(s));
	for (int i = 1; i <= n; ++i)
	{
		if (deg[i] == 2)
		{
			rot = i;
			DFS(i, 0);
			break;
		}
	}
	for (int i = 1; i <= n; ++i)
	{
		ans += i;
		if (i == rot)
			continue;
//		printf("DEL : %d > ", i);
		full = n - siz[i];
		int x = fa[i];
		while (x)
		{
			siz[x] -= siz[i];
			x = fa[x];
		}
		siz[i] = 0;
		Solve(rot);
		x = fa[i];
		siz[i] = siz[s[i][0]] + siz[s[i][1]] + 1;
		while (x)
		{
			siz[x] += siz[i];
			x = fa[x];
		}
//		printf("\n");
	}
	ans -= rot;
}
}

inline void adde(int x, int y)
{
	son[++tot] = y, nxt[tot] = lnk[x], lnk[x] = tot;
}

int main()
{
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	T = read();
	while (T--)
	{
		tot = 1, ans = 0;
		memset(lnk, 0, sizeof(lnk));
		memset(son, 0, sizeof(son));
		memset(nxt, 0, sizeof(nxt));
		memset(siz, 0, sizeof(siz));
		memset(deg, 0, sizeof(deg));
		n = read();
		for (int i = 1; i < n; ++i)
		{
			e[i].x = read(), e[i].y = read();
			adde(e[i].x, e[i].y), adde(e[i].y, e[i].x);
			++deg[e[i].x], ++deg[e[i].y];
		}
		int m_deg = 0;
		for (int i = 1; i <= n; ++i)
			m_deg = max(m_deg, deg[i]);
		if (n <= 2000)
		{
			Sub1::main();
		}
		else if (m_deg <= 2)
		{
			Sub2::main();
		}
		else if (m_deg == 3)
		{
			Sub3::main();
		}
		printf("%lld\n", ans);
//		ans = 0;
//		Sub1::main();
//		printf("%lld\n", ans);
	}
	return 0;
}
