#include <cstdio>
#include <cstring>
#include <algorithm>

#define maxn 40000007

using namespace std;

int n, f[maxn], stk[maxn], top, typ;
long long a[maxn], w[maxn], ans;

#define MOD ((1 << 30))
#define maxm 100005
int x, y, z, m, p[maxm], l[maxm], r[maxm];
long long b[maxn];

class Bigint
{
public:
	#define LEN 10000
	int a[31], len;
	Bigint()
	{
		memset(a, 0, sizeof(a));
		len = 0;
	}
	Bigint(long long x)
	{
		memset(a, 0, sizeof(a));
		len = 0;
		while (x)
		{
			a[++len] = x % LEN;
			x /= LEN;
		}
	}
	Bigint operator + (const Bigint b)
	{
		Bigint c;
		c.len = max(len, b.len);
		for (int i = 1; i <= max(len, b.len); ++i)
		{
			c.a[i] += (a[i] + b.a[i]) % LEN;
			c.a[i + 1] += (a[i] + b.a[i]) / LEN;
		}
		if (c.a[c.len + 1])
			++c.len;
		return c;
	}
	Bigint operator * (const Bigint b)
	{
		Bigint c;
		c.len = len * b.len;
		for (int i = 1; i <= len; ++i)
		{
			for (int j = 1; j <= b.len; ++j)
			{
				c.a[i + j - 1] += a[i] * b.a[j];
				c.a[i + j] += c.a[i + j - 1] / LEN;
				c.a[i + j - 1] %= LEN;
			}
		}
		while (c.a[c.len] == 0 && c.len)
			--c.len;
		return c;
	}
	void Write()
	{
		printf("%d", a[len]);
		for (int i = len - 1; i > 0; --i)
			printf("%04d", a[i]);
	}
} ANS;

inline int read()
{
	char ch = getchar();
	int ret = 0, f = 1;
	while (ch > '9' || ch < '0')
	{
		if (ch == '-')
			f = -f;
		ch = getchar();
	}
	while (ch >= '0' && ch <= '9')
		ret = ret * 10 + ch - '0', ch = getchar();
	return ret * f;
}

void Solve(int now)
{
	if (now < 1)
		return;
	Bigint mid = (w[now] - a[now]);
	ANS = ANS + (mid * mid);
	Solve(f[now]);
}

int main()
{
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	n = read(), typ = read();
	if (typ)
	{
		x = read(), y = read(), z = read();
		b[1] = read(), b[2] = read(), m = read();
		for (int i = 1; i <= m; ++i)
			p[i] = read(), l[i] = read(), r[i] = read();
		for (int i = 3; i <= n; ++i)
		{
			b[i] = 1ll * x * b[i - 1] % MOD;
			b[i] = (b[i] + 1ll * y * b[i - 2] + z) % MOD;
		}
		for (int i = 1, j = 0; i <= n; ++i)
		{
			while (i > p[j])
				++j;
			a[i] = (b[i] % (r[j] - l[j] + 1)) + l[j];
		}
		for (int i = 2; i <= n; ++i)
			a[i] += a[i - 1];
	}
	else
	{
		for (int i = 1; i <= n; ++i)
			a[i] = a[i - 1] + read();
	}
	int t = 0;
	for (int i = 1; i <= n; ++i)
	{
		while (t < top && a[i] >= w[stk[t + 1]])
			++t;
		f[i] = stk[t];
		w[i] = a[i] + a[i] - a[f[i]];
//		printf("%lld\n", w[i]);
		while (top > 0 && w[i] <= w[stk[top]])
			--top;
		stk[++top] = i;
//		printf("%d\n", a[i]);
	}
	Solve(n);
	ANS.Write();
	return 0;
}
