#include<cstdio>
#include<cctype>
#include<vector>
#include<cstring>
inline int getint() {
	register char ch;
	while(!isdigit(ch=getchar()));
	register int x=ch^'0';
	while(isdigit(ch=getchar())) x=(((x<<2)+x)<<1)+(ch^'0');
	return x;
}
typedef long long int64;
const int N=3e5+1;
struct Edge {
	int u,v;
};
Edge edge[N];
std::vector<int> e[N];
inline void add_edge(const int &u,const int &v) {
	e[u].push_back(v);
	e[v].push_back(u);
}
int n;
namespace subtask_brute_force {
	int size[N],root[N],par[N];
	void dfs(const int &x,const int &p,const int &r) {
		size[x]=1;
		root[x]=r;
		par[x]=p;
		for(unsigned i=0;i<e[x].size();i++) {
			const int &y=e[x][i];
			if(y==p) continue;
			dfs(y,x,r);
			size[x]+=size[y];
		}
	}
	void solve() {
		int64 ans=0;
		for(register int i=1;i<n;i++) {
			const int &u=edge[i].u;
			const int &v=edge[i].v;
			dfs(u,v,u);
			dfs(v,u,v);
			for(register int x=1;x<=n;x++) {
				bool flag=size[root[x]]-size[x]<=size[root[x]]/2;
				for(unsigned i=0;i<e[x].size()&&flag;i++) {
					const int &y=e[x][i];
					if(y==par[x]) continue;
					flag&=size[y]<=size[root[x]]/2;
				}
				if(flag) ans+=x;
			}
		}
		printf("%lld\n",ans);
	}
};
namespace subtask_chain {
	int deg[N],dep[N],node[N];
	bool is_chain() {
		memset(deg,0,sizeof deg);
		for(register int i=1;i<n;i++) {
			deg[edge[i].u]++;
			deg[edge[i].v]++;
		}
		int cnt1=0,cnt2=0;
		for(register int i=1;i<=n;i++) {
			if(deg[i]==1) cnt1++;
			if(deg[i]==2) cnt2++;
		}
		return cnt1==2&&cnt2==n-2;
	}
	void dfs(const int &x,const int &par) {
		dep[x]=dep[par]+1;
		for(unsigned i=0;i<e[x].size();i++) {
			const int &y=e[x][i];
			if(y==par) continue;
			dfs(y,x);
		}
	}
	void solve() {
		int top;
		for(register int i=1;i<=n;i++) {
			if(deg[i]==1) top=i;
		}
		dfs(top,0);
		for(register int i=1;i<=n;i++) {
			node[dep[i]]=i;
		}
		int64 ans=0;
		for(register int i=1;i<n;i++) {
			{//Left Segment
				const int l=1,r=i;
				if((r-l+1)&1) {
					ans+=node[(l+r)/2];
				} else {
					ans+=node[(l+r)/2];
					ans+=node[(l+r)/2+1];
				}
			}
			{//Right Segment
				const int l=i+1,r=n;
				if((r-l+1)&1) {
					ans+=node[(l+r)/2];
				} else {
					ans+=node[(l+r)/2];
					ans+=node[(l+r)/2+1];
				}
			}
		}
		printf("%lld\n",ans);
	}
};
namespace subtask_perfect_binary_tree {
	bool is_perfect_binary_tree() {
		return true;
	}
	int size[N],dep[N];
	void dfs(const int &x,const int &par) {
		size[x]=1;
		for(unsigned i=0;i<e[x].size();i++) {
			const int &y=e[x][i];
			if(y==par) continue;
			dfs(y,x);
			size[x]+=size[y];
		}
	}
	void build(const int &x,const int &par) {
		dep[x]=dep[par]+1;
		for(unsigned i=0;i<e[x].size();i++) {
			const int &y=e[x][i];
			if(y==par) continue;
			build(y,x);
		}
	}
	void solve() {
		dfs(1,0);
		int root=1;
		for(register int i=1;i<=n;i++) {
			if(size[i]-1==n-size[i]) root=i;
		}
		build(root,0);
		int height=0;
		for(register int i=1;i<=n;i++) {
			height=std::max(height,dep[i]);
		}
		int64 ans=0;
		for(register int i=1;i<=n;i++) {
			if(dep[i]<=2) {
				ans+=i*(1ll<<(height-1));
			} else {
				ans+=i;
			}
		}
		printf("%lld\n",ans);
	}
};
int main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	for(register int T=getint();T;T--) {
		n=getint();
		for(register int i=1;i<n;i++) {
			edge[i].u=getint();
			edge[i].v=getint();
			add_edge(edge[i].u,edge[i].v);
		}
		if(n<=2000) {
			subtask_brute_force::solve();
		} else if(subtask_chain::is_chain()) {
			subtask_chain::solve();
		} else if(subtask_perfect_binary_tree::is_perfect_binary_tree()) {
			subtask_perfect_binary_tree::solve();
		}
		//clear
		for(register int i=1;i<=n;i++) {
			e[i].clear();
		}
	}
	return 0;
}
