#include <iostream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <cstring>
using namespace std;

int x; char c;
int read() {
	x = 0; c = getchar();
	for (; c < '0' || '9' < c; c = getchar());
	for (; '0' <= c && c <= '9'; c = getchar()) x = (x << 3) + (x << 1) + (c ^ '0');
	return x;
}
void write(int x) {
	if (x >= 10) write(x / 10);
	putchar(x % 10 ^ '0');
}

#define MAXN 300300
struct edge {
	int point, next;
	bool del;
} e[MAXN << 1];
int edgecnt, list[MAXN];
inline void add(int u, int v) {
	e[++edgecnt].point = v;
	e[edgecnt].next = list[u];
	list[u] = edgecnt;
	e[edgecnt].del = false;
}
#define l (i << 1) - 1
#define r (i << 1)

int n, u, v, C;
int size[MAXN];
int dfs(int x, int f) {
	size[x] = 1;
	for (register int i = list[x]; i; i = e[i].next) {
		if (e[i].del == false) {
			if (e[i].point != f) {
				size[x] += dfs(e[i].point, x);
			}
		}
	}
	return size[x];
}
void centroid(int t, int x) {
	for (register int i = list[x]; i; i = e[i].next) {
		if (size[e[i].point] > 0 && size[e[i].point] > (size[e[t].point] >> 1)) return;
	}
	C += x;
}

#define fre(f) freopen(#f".in", "r", stdin), freopen(#f".out", "w", stdout)
int main() {
	fre(centroid);
	int T = read();
	while (T--) {
		edgecnt = 0;
		n = read();
		for (register int i = 1; i < n; i++) {
			u = read(); v = read();
			add(u, v);
			add(v, u);
		}

		C = 0;
		for (register int i = 1; i < n; i++) {
			e[l].del = true;
			e[r].del = true;
			memset(size, 0, sizeof (size));
			dfs(e[l].point, 0);
			for (register int c = 1; c <= n; c++) {
				centroid(l, c);
			}
			memset(size, 0, sizeof (size));
			dfs(e[r].point, 0);
			for (register int c = 1; c <= n; c++) {
				centroid(r, c);
			}
			e[l].del = false;
			e[r].del = false;
		}
		write(C);
		putchar('\n');
	}
	return 0;
}
