#include<bits/stdc++.h>
using namespace std;

typedef long long ll;
#define int ll

const int MAXN = 299995;

int n;
struct Edge {
	int to,nxt;
}e[MAXN<<1];
int adj[MAXN];
int deg[MAXN];
int fid = 0;
void _add(int u,int v) {
	e[++fid] = (Edge){v,adj[u]};
	adj[u] = fid;
}
void add(int u,int v) {
	_add(u,v);
	_add(v,u);
	deg[u]++;
	deg[v]++;
}

namespace BruteForce {
	int df1;
	int df2;
	int sz[MAXN];
	int st[MAXN];
	
	void dfs1(int u,int f) {
		sz[u] = 1;
		for(int id = adj[u]; id; id = e[id].nxt) {
			int v = e[id].to;
			if(id == df1 || id == df2 || v == f) continue;
			dfs1(v,u);
			sz[u] += sz[v];
		}
	}
	
	void dfs2(int u,int f,int ssz,int &ret) {
		bool flag = true;
		for(int id = adj[u]; id; id = e[id].nxt) {
			int v = e[id].to;
			if(id == df1 || id == df2 || v == f) continue;
			dfs2(v,u,ssz,ret);
			if(sz[v] > ssz/2) flag = false;
		}
		if((ssz - sz[u]) > ssz/2) flag = false;
		if(flag) {
			ret += u;
			st[u] ++;
		}
	}
	
	void solve() {
		int ans = 0;
		for(int i=1;i<=n;i++) {
			st[i] = 0;
		}
		for(int i=1;i<=fid;i+=2) {
			df1 = i;
			df2 = i+1;
			int u = e[df1].to;
			int v = e[df2].to;
//			cerr<<"Adj "<<u<<' '<<v<<endl;
			dfs1(u,0);
			dfs1(v,0);
//			cerr<<"Size "<<sz[u]<<' '<<sz[v]<<endl;
			int a1 = 0;
			int a2 = 0;
			dfs2(u,0,sz[u],a1);
			dfs2(v,0,sz[v],a2);
			ans += a1 + a2;
		}
		
//		for(int i=1;i<=n;i++) {
//			cerr<<i<<": "<<st[i]<<endl;
//		}
		
		printf("%lld\n",ans);
	}
};

namespace Linear {
	int id[MAXN];
	
	void dfs3(int u,int f,int d) {
		id[d] = u;
		for(int id = adj[u]; id; id = e[id].nxt) {
			int v = e[id].to;
			if(v == f) continue;
			dfs3(v,u,d+1);
		}
	}
	
	void solve() {
		int sp = 0;
		for(int i=1;i<=n;i++) {
			if(deg[i] == 1) {
				sp = i;
				break;
			}
		}
		dfs3(sp,0,1);
		
		int ans = 0;
		if(n == 1) ans = 0;
		else if(n == 2) {
			ans = 3;
		}
		else if(n % 2 == 1) {
			for(int i=1;i<=n/2+1;i++) {
				int p = 0;
				if(i == 1) p = 2;
				else if(i == n/2+1) p = 1;
				else p = 3;
				ans += p * id[i] + p * id[n-i+1];
			}
		}
		else {
			for(int i=1;i<=n/2;i++) {
				int p = 0;
				if(i == 1 || i == n/2) p = 2;
				else p = 3;
				ans += p * id[i] + p * id[n-i+1];
			}
		}
		
		printf("%lld\n",ans);
	}
};

signed main() {
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	int T;
	scanf("%lld",&T);
	while(T--) {
		fid = 0;
		
		scanf("%lld",&n);
		
		for(int i=1;i<=n;i++) {
			adj[i] = 0;
			deg[i] = 0;
		}
		
		for(int i=1;i<n;i++) {
			int u,v;
			scanf("%lld%lld",&u,&v);
			add(u,v);
		}
		
		bool flag1 = true;
		int p1 = 0;
		for(int i=1;i<n;i++) {
			if(deg[i] > 2) flag1 = false;
			if(deg[i] == 1) p1++;
		}
		
		if(n <= 2019) BruteForce::solve();
		else if(flag1 && p1 == 2) Linear::solve();
		else puts("0");
	}
}

