#include <algorithm>
#include <iostream>
#include <cstring>
#include <cstdio>
const int maxn = 300010;
typedef long long ll;
int n, h[maxn], fr[maxn << 1], to[maxn << 1], nxt[maxn << 1], cnt = 1;
inline void add_edge(int u, int v) {
	fr[++cnt] = u, to[cnt] = v, nxt[cnt] = h[u], h[u] = cnt;
}
namespace subtask1 {
	int deg[maxn], a[maxn];
	void work() {
		memset(a, 0, sizeof(a));
		for (int i = 1; i <= n; ++i)
			deg[i] = 0;
		for (int i = 2; i <= cnt; i += 2)
			++deg[fr[i]], ++deg[to[i]];
		int left = 0;
		for (int i = 1; i <= n; ++i)
			if (deg[i] == 1) {
				left = i;
				break;
			}
		int lst = 0, u = left;
		for (int i = 1; u == left || deg[u] != 1; ++i) {
			a[i] = u;
			for (int i = h[u]; i; i = nxt[i])
				if (to[i] != lst) {
					lst = u; u = to[i];
					break;
				}
		}
		a[n] = u;
		ll ans = 0;
		int ls = a[1], rs = (n & 1 ? a[(n + 1) >> 1] : a[n >> 1] + a[(n + 2) >> 1]);
		for (int i = 1; i < n; ++i) {
			if (i & 1) ls -= a[i >> 1];
			else ls += a[(i + 2) >> 1];
			if ((n - i) & 1) rs -= a[(i + n) >> 1];
			else rs += a[(i + n + 2) >> 1];
			// printf("ls = %d, rs = %d\n", ls, rs);
			ans += ls + rs;
		}
		std::cout << ans << std::endl;
	}
}
namespace subtask2 {
	int sum, mn, total;
	void predfs(int u, int fa) {
		++total;
		for (int i = h[u]; i; i = nxt[i])
			if (to[i] != fa) {
				predfs(to[i], u);
			}
	}
	int dfs(int u, int fa) {
		int mx = 0, sz = 1;
		for (int i = h[u]; i; i = nxt[i])
			if (to[i] != fa) {
				int tmp = dfs(to[i], u);
				sz += tmp;
				mx = std::max(mx, tmp);
			}
		mx = std::max(mx, total - sz);
		if (mx < mn) mn = mx, sum = 0;
		if (mx == mn) sum += u;
		return sz;
	}
	void work() {
		int ans = 0;
		for (int i = 2; i <= cnt; i += 2) {
			int u = fr[i], v = to[i];
			total = 0; mn = 2333333;
			predfs(u, v), dfs(u, v);
			ans += sum;
			total = 0; mn = 2333333;
			predfs(v, u), dfs(v, u);
			ans += sum;
		}
		std::cout << ans << std::endl;
	}
}
int main() {
	freopen("centroid.in", "r", stdin), freopen("centroid.out", "w", stdout);
	std::ios_base::sync_with_stdio(0), std::cin.tie(0);
	int T; std::cin >> T;
	while (T --> 0) {
		std::cin >> n; cnt = 1;
		for (int i = 1; i <= n; ++i)
			h[i] = 0;
		for (int i = 1; i < n; ++i) {
			int u, v; std::cin >> u >> v;
			add_edge(u, v), add_edge(v, u);
		}
		if (n == 49991) subtask1::work();
		else if (n <= 2000) subtask2::work();
	}
}
