#include <iostream>
#include <iomanip>
#include <cstdio>
#include <bitset>
const int maxn = 50000010;
typedef long long ll;
struct starcy {
	int enable, x, y, z, m;
	int a[maxn], b[maxn], p[maxn];
	void init(int n, int type) {
		enable = type;
		if (!enable) return;
		std::cin >> x >> y >> z >> b[1] >> b[2] >> m;
		for (int i = 3; i <= n; ++i)
			b[i] = (1ll * x * b[i - 1] + 1ll * y * b[i - 2] + z) % (1 << 30);
		for (int i = 1; i <= m; ++i) {
			int l, r; std::cin >> p[i] >> l >> r;
			for (int j = p[i - 1] + 1; j <= p[i]; ++j)
				a[j] = (b[j] % (r - l + 1)) + l;
		}
	}
	int read(const int& i) {
		if (!enable) {
			int ret; std::cin >> ret;
			return ret;
		}
		return a[i];
	}
} debber;
const ll limit = 1e18;
struct cint {
	ll a, b;
	cint() {}
	cint(ll x) : a(0), b(x) {}
	cint(ll a, ll b) : a(a), b(b) {}
	cint operator=(const cint& rhs) {
		a = rhs.a, b = rhs.b;
		return *this;
	}
	cint operator+(const cint& rhs) const {
		cint c;
		c.a = a + rhs.a, c.b = b + rhs.b;
		if (c.b > limit) ++c.a, c.b -= limit;
		return c;
	}
	cint sqr() {
		static int t[233];
		ll x = b;
		t[0] = x % 1000000, x /= 1000000;
		t[1] = x % 1000000, x /= 1000000;
		t[2] = x % 1000000, x /= 1000000;
		a = 1ll * t[2] * t[2] * 1000000;
		a += 2ll * t[2] * t[1];
		a += 1ll * t[1] * t[1] / 1000000;
		a += 2ll * t[2] * t[0] / 1000000;
		b = 1ll * t[0] * t[0];
		b += 2ll * t[1] * t[0] * 1000000;
		b += 1ll * t[1] * t[1] % 1000000 * 1000000000000ll;
		b += 2ll * t[2] * t[0] % 1000000 * 1000000000000ll;
		while (b >= limit) b -= limit, ++a;
		return *this;
	}
} ;
std::ostream& operator<<(std::ostream& os, const cint& x) {
	static char buffer[233], *p = buffer;
	if (!x.a) return os << x.b;
	os << x.a;
	ll tmp = x.b;
	for (int i = 0; i < 18; ++i)
		*p++ = tmp % 10 + '0', tmp /= 10;
	for (int i = 0; i < 18; ++i)
		os.put(*--p);
	return os;
}
cint sqr(cint x) {
	return x.sqr();
}
ll s[maxn], f[maxn], q[maxn];
cint dp[maxn];
int main() {
	freopen("partition.in", "r", stdin), freopen("partition.out", "w", stdout);
	std::ios_base::sync_with_stdio(0), std::cin.tie(0);
	int n, type; std::cin >> n >> type;
	debber.init(n, type);
	int h = 0, t = 0; q[h] = 0;
	for (int i = 1; i <= n; ++i) {
		int x = debber.read(i);
		s[i] = s[i - 1] + x;
		while (h < t && s[i] >= f[q[h + 1]]) ++h;
		dp[i] = dp[q[h]] + sqr(s[i] - s[q[h]]);
		f[i] = s[i] - s[q[h]] + s[i];
		while (h <= t && f[q[t]] > f[i]) --t;
		q[++t] = i;
	}
	std::cout << dp[n] << std::endl;
}
