#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>
#include <algorithm>
using namespace std;
typedef long long ll;
const int N = 300007;
int n, ans, d, ecnt, head[N], vet[N << 1], nxt[N << 1], all, siz[N], deg[N];

inline void eadd(int u, int v) {
	vet[++ecnt] = v;
	nxt[ecnt] = head[u];
	head[u] = ecnt;
}

void dfs(int u, int f) {
	siz[u] = 1;
	for (int e = head[u]; e; e = nxt[e]) {
		if (vet[e] == f || (e >> 1) == d) continue;
		dfs(vet[e], u);
		siz[u] += siz[vet[e]];
	}
}

void solve(int u, int f) {
	bool check = (f == 0 || all - siz[u] <= (all >> 1));
	for (int e = head[u]; e; e = nxt[e]) {
		if (vet[e] == f || (e >> 1) == d) continue;
		solve(vet[e], u);
		if (siz[vet[e]] > (all >> 1)) check = false;
	}
	if (check) ans += u;	
}

namespace A {
	int a[N];
	void dfs(int i) {
		if (i == n - 1) return;
		for (int e = head[a[i]]; e; e = nxt[e])
			if (vet[e] != a[i - 1]) a[i + 1] = vet[e], dfs(i + 1);
	}
	void doit() {
		memset(a, 0, sizeof(a));
		for (int i = 1; i <= n; ++i)
			if (deg[i] == 1) {
				if (!a[1]) a[1] = i;
				else {
					a[n] = i;
					break;
				}
			}
		dfs(1);
		if (n % 2) {
			ll ans = 0;
			for (int i = 1; i <= n; ++i)
				if (i == 1 || i == n || i == (n + 1) / 2) ans += a[i] * 2;
				else ans += a[i] * 3;
			printf("%lld\n", ans);
		} else {
			ll ans = 0;
			for (int i = 1; i <= n; ++i)
				if (i == 1 || i == n/2 || i == n/2 + 1 || i == n) ans += a[i] * 2;
				else ans += a[i] * 3;
			printf("%lld\n", ans);
		}
	}
}

namespace B {
	int dep[N], q[N], qhead, qtail;
	void doit() {
		memset(dep, 0, sizeof(dep)); qhead = 0; qtail = -1;
		for (int i = 1; i <= n; ++i)
			if (deg[i] == 1) dep[i] = 18, q[++qtail] = i;
		while (qhead <= qtail) {
			int u = q[qhead++];
			for (int e = head[u]; e; e = nxt[e])
				if (!dep[vet[e]]) dep[vet[e]] = dep[u] - 1, q[++qtail] = vet[e];
		}
		ll ans = 0;
		for (int i = 1; i <= n; ++i)
			if (dep[i] <= 2) ans += 131072LL * i, fprintf(stderr, "%d\n", i);
			else ans += i;
		printf("%lld\n", ans);
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T; scanf("%d", &T);
	while (T--) {
		scanf("%d", &n); 
		ecnt = 1;
		memset(head, 0, sizeof(head));
		if (n == 49991 || n == 262143) memset(deg, 0, sizeof(deg));
		for (int i = 1; i < n; ++i) {
			int u, v; scanf("%d%d", &u, &v);
			eadd(u, v); eadd(v, u);
			if (n == 49991 || n == 262143) ++deg[u], ++deg[v];
		}
		if (n == 49991) {
			A::doit();
			continue;
		}
		if (n == 262143) {
			B::doit();
			continue;
		}
		ans = 0;
		for (d = 1; d < n; ++d) {
			dfs(vet[d << 1], 0);
			dfs(vet[d << 1 | 1], 0);
			all = siz[vet[d << 1]]; solve(vet[d << 1], 0);
			all = siz[vet[d << 1 | 1]]; solve(vet[d << 1 | 1], 0);
//			printf("%d\n", ans);
		}
		printf("%d\n", ans);
	}
	return 0;
}
