#include <cstdio>
#include <cstring>
#include <iostream>
using namespace std;
#define gc c = getchar()
int read() {
	int x = 0, f = 1; char gc;
	for (; !isdigit(c); gc) if (c == '-') f = -1;
	for (; isdigit(c); gc) x = x * 10 + c - '0';
	return x * f;
}
#undef gc
const int N = 3e5 + 5;
int nedge, head[N];
struct Edge {
	int to, nxt;
} edge[N << 1];
void add(int x, int y) {
	edge[++nedge].to = y;
	edge[nedge].nxt = head[x];
	head[x] = nedge;
}
int n;
struct E {
	int x, y;
} e[N];
namespace Subtask1 {
	bool check() { return n <= 2000; }
	int siz[2005], son[2005], col[2005];
	void dfs(int x, int fa, int c) {
		siz[x] = 1;
		col[x] = c;
		for (int i = head[x]; i; i = edge[i].nxt) {
			int y = edge[i].to;
			if (y == fa) continue;
			dfs(y, x, c);
			siz[x] += siz[y];
			if (siz[y] > son[x]) son[x] = siz[y];
		}
	}
	void Main() {
		int ans = 0;
		for (int i = 1; i < n; i++) {
			memset(siz, 0, sizeof(siz));
			memset(col, 0, sizeof(col));
			memset(son, 0, sizeof(son));
			dfs(e[i].x, e[i].y, 1);
			dfs(e[i].y, e[i].x, 2);
			for (int j = 1; j <= n; j++) {
				if (col[j] == 1) {
					son[j] = max(son[j], siz[e[i].x] - siz[j]);
					if (son[j] <= siz[e[i].x] / 2) ans += j;
				}
				if (col[j] == 2) {
					son[j] = max(son[j], siz[e[i].y] - siz[j]);
					if (son[j] <= siz[e[i].y] / 2) ans += j;
				}
			}
		}
		printf("%d\n", ans);
	}
}
namespace Subtask2 {
	int deg[N];
	bool check() {
		for (int i = 1; i < n; i++) deg[i] = 0;
		for (int i = 1; i < n; i++)
			deg[e[i].x]++, deg[e[i].y]++;
		for (int i = 1; i <= n; i++)
			if (deg[i] > 2) return 0;
		return 1;
	}
	int tot, p[N], id[N];
	void dfs(int x, int fa) {
		id[x] = ++tot;
		p[tot] = x;
		for (int i = head[x]; i; i = edge[i].nxt) {
			int y = edge[i].to;
			if (y == fa) continue;
			dfs(y, x);
		}
	}
	void Main() {
		tot = 0;
		for (int i = 1; i <= n; i++)
			if (deg[i] == 1) {
				dfs(i, 0);
				break;
			}
		long long ans = 0;
		for (int i = 1; i < n; i++) {
			int a = id[e[i].x], b = id[e[i].y];
			if (a > b) swap(a ,b);
			if (a & 1) {
				ans += p[(a + 1) / 2];
			} else {
				ans += p[a / 2];
				ans += p[a / 2 + 1];
			}
			if ((n - b + 1) & 1) {
				ans += p[b + (n - b + 1) / 2];
			} else {
				ans += p[b + (n - b + 1) / 2 - 1];
				ans += p[b + (n - b + 1) / 2];
			}
		}
		printf("%lld\n", ans);
	}
}
void init() {
	nedge = 0;
	memset(head, 0, sizeof(head));
}
void solve() {
	n = read();
	for (int i = 1; i < n; i++) {
		e[i].x = read(), e[i].y = read();
		if (e[i].x > e[i].y) swap(e[i].x, e[i].y);
		add(e[i].x, e[i].y), add(e[i].y, e[i].x);
	}
	if (Subtask1::check()) Subtask1::Main();
	else if (Subtask2::check()) Subtask2::Main();
}
int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	for (int T = read(); T; T--) {
		init();
		solve(); 
	} 
}
