#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstring>

using namespace std;
typedef long long ll;
const int maxn=50000+100;

int E,to[2*maxn],nxt[2*maxn],frm[2*maxn],head[maxn];
int fa[maxn],size[maxn],vis[maxn],degree[maxn],a[maxn];
int n,edg,u,v,T;

void allclear(){
	E=0,edg=0,n=0;
	memset(to,0,sizeof(to));memset(nxt,0,sizeof(nxt));
	memset(frm,0,sizeof(frm));memset(head,0,sizeof(head));
	memset(degree,0,sizeof(degree));memset(a,0,sizeof(a));
}

void addedge(int u,int v){
	nxt[++E]=head[u];frm[E]=u;
	to[E]=v;head[u]=E;
}

int find(int x){
	if (fa[x]!=x) fa[x]=find(fa[x]);
	return fa[x];
}

void Union(int x,int y){
	int rx=find(x),ry=find(y);
	if (rx!=ry) fa[rx]=ry;
}

bool oK(int e1,int e2){
	if (frm[e1]==frm[e2] && to[e1]==to[e2]) return false;
	if (frm[e1]==to[e2] && to[e1]==frm[e2]) return false;
	return true;
}

void dfs(int u,int F){
	size[u]=1;
	for (int e=head[u];e;e=nxt[e]){
		if (!oK(e,edg)) continue;
		int v=to[e];
		if (v==F) continue;
		dfs(v,u);
		size[u]+=size[v];
	}
}

int main(){
	freopen("centroid.in","r",stdin);
	freopen("centroid.out","w",stdout);
	scanf("%d",&T);
	while (T--){
		allclear();
		scanf("%d",&n);
		for (int i=1;i<n;i++){
			scanf("%d%d",&u,&v);
			addedge(u,v);addedge(v,u);
			degree[u]++;degree[v]++;
		}
		int lnk=1;ll ans=0ll;
		for (int i=1;i<=n;i++) if (degree[i]>2) lnk=0;
		if (lnk){
			a[1]=0;
			for (int i=1;i<=n;i++)
			    if (degree[i]==1) a[1]=i;
			for (int i=2;i<=n;i++){
				for (int e=head[a[i-1]];e;e=nxt[e]){
					int v=to[e];
					if (v!=a[i-2]) a[i]=v;
				}
			}
			for (int i=1;i<n;i++){
				int r=i,l=i+1;
				if (r&1) ans+=1ll*a[r/2+1];
					else ans+=1ll*a[r/2]+1ll*a[r/2+1];
				if ((n-i)&1) ans+=1ll*a[l+(n-i)/2];
					else ans+=1ll*a[l+(n-i)/2]+1ll*a[l+(n-i)/2-1];
			}
			printf("%lld\n",ans);
		}else{
			for (edg=1;edg<=E;edg++){
				memset(vis,0,sizeof(vis));
				for (int i=1;i<=n;i++) fa[i]=i;
				for (int i=1;i<=E;i++)
				    if (oK(edg,i)) Union(frm[i],to[i]);
				for (int rrt=1;rrt<=n;rrt++){
					memset(size,0,sizeof(size));
					int rt=find(rrt);
					if (vis[rt]) continue;
					vis[rt]=1;
					dfs(rt,-1);
					int N=size[rt];
					for (int i=1;i<=n;i++){
						int flag=1;
						if (N-size[i]>N/2) flag=0;
						for (int e=head[i];e;e=nxt[e]){
							if (!oK(e,edg)) continue;
							int v=to[e];
							if (size[v]>size[i]) continue;
							if (size[v]>N/2) flag=0;
						}
						if (flag) ans+=1ll*i;
					}
				}
			}
			printf("%lld\n",ans/2);
		}
	}
	return 0;
}
