#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N = 3e5 + 5;

struct _edge {
  int to, nt;
} E[N << 1];

struct Edge {
  int u, v;
} edge[N];

int n, edgeCnt;
int H[N], de[N];

void init() {
  edgeCnt = 0;
  for (int i = 1; i <= n; i++)
    H[i] = 0, de[i] = 0;
  memset(E, 0, sizeof E);
  memset(edge, 0, sizeof edge);
}

void addEdge(int u, int v) {
  E[++edgeCnt] = (_edge){v, H[u]};
  H[u] = edgeCnt;
}

namespace forcebrute {
  
  const int NN = 2000 + 5;
  
  int id[10][10];
  int cnt[10];
  int siz[N], mxs[N];
  int now;
  
  void dfs1(int u, int fff) {
    siz[u] = 1;
    for (int e = H[u]; e; e = E[e].nt) {
      int v = E[e].to;
      if (v == fff)
        continue;
      dfs1(v, u);
      siz[u] += siz[v];
    }
  }
  
  void find(int u, int fff, int tot, int opt) {
    mxs[u] = 0, siz[u] = 1;
    for (int e = H[u]; e; e = E[e].nt) {
      int v = E[e].to;
      if (v == fff)
        continue;
      find(v, u, tot, opt);
      siz[u] += siz[v];
      mxs[u] = max(mxs[u], siz[v]);
    }
    mxs[u] = max(mxs[u], tot - siz[u]);
    if (mxs[u] < now)
      cnt[opt] = 1, id[opt][1] = u, now = mxs[u];
    else if (mxs[u] == now) 
      id[opt][++cnt[opt]] = u;
  }
  
  int main() {
    ll ans = 0;
    for (int i = 1; i < n; i++) {
      for (int j = 1; j <= n; j++)
        siz[j] = 0, mxs[j] = 0;
      for (int j = 0; j <= 1; j++)
        for (int k = 0; k <= 1; k++)
          id[j][k] = 0;
      cnt[0] = cnt[1] = 0;
      dfs1(edge[i].u, edge[i].v);
      dfs1(edge[i].v, edge[i].u);
      now = 1e9;
      find(edge[i].u, edge[i].v, siz[edge[i].u], 0);
      now = 1e9;
      find(edge[i].v, edge[i].u, siz[edge[i].v], 1);
      for (int j = 1; j <= cnt[0]; j++) 
        ans += id[0][j];
      for (int j = 1; j <= cnt[1]; j++) 
        ans += id[1][j];
    }
    printf("%lld\n", ans);
    return 0; 
  }
}

namespace subtaskchain {
  
  int root, m;
  int seq[N], pre[N], suf[N];
  
  void dfs2(int u, int fff) {
    seq[++m] = u;
    for (int e = H[u]; e; e = E[e].nt) {
      int v = E[e].to;
      if (v == fff) 
        continue;
      dfs2(v, u);
    }
  }
  
  int main() {
    root = 0, m = 0;
    for (int i = 1; i <= n; i++) 
      if (de[i] == 1) 
        root = i;
    dfs2(root, 0);
    ll ans = 0;
    for (int i = 1; i < n; i++) {
      if (i % 2 == 1) {
        ans += seq[(i + 1) / 2];
      } else {
        ans += seq[i / 2] + seq[i / 2 + 1];
      }
    }
    for (int i = n; i >= 2; i--) {
      if ((n - i) % 2 == 0) {
        ans += seq[i + (n - i) / 2];
      } else {
        ans += seq[i + (n - i) / 2] + seq[i + (n - i) / 2 + 1];
      }
    }
    printf("%lld\n", ans);
    return 0;
  }
}

namespace subtask3 {
  int bel[N], mxs[N], rev[N], tmp[N], ft[N];
  int siz[N], root, MXX;
  int res[15];
  
  void dfs1(int u, int fff) {
    siz[u] = 1, mxs[u] = 0; 
    for (int e = H[u]; e; e = E[e].nt) {
      int v = E[e].to;
      if (v == fff)
        continue;
      dfs1(v, u);
      siz[u] += siz[v];
      mxs[u] = max(mxs[u], siz[v]);
    }
    mxs[u] = max(mxs[u], n - siz[u]);
    if (!root || mxs[u] < mxs[root])
      root = mxs[u];
  }
  
  void dfs2(int u, int fff, int tot) {
    siz[u] = 1, mxs[u] = 0;
    for (int e = H[u]; e; e = E[e].nt) {
      int v = E[e].to;
      if (v == fff) 
        continue;
      dfs2(v, u, tot);
      siz[u] += siz[v];
      mxs[u] = max(mxs[u], tot - mxs[u]);
    }
    if (mxs[u] < MXX) {
      res[0] = 1;
      res[1] = u;
    } else if (mxs[u] == MXX) {
      res[++res[0]] = u;
    }
  }
  
  void dfs3(int u, int fff) {
    tmp[u] = 1;
    for (int e = H[u]; e; e = E[e].nt) {
      int v = E[e].to;
      if (v == fff)
        continue;
      dfs3(v, u);
      tmp[u] += tmp[v];
    }
  }
  
  queue<int> q;
  int cnt;
  
  int main() {
    for (int i = 1; i <= n; i++)
      bel[i] = 0, rev[i] = 0;
    dfs1(1, 0);
    while (!q.empty()) 
      q.pop();
    q.push(root); 
    cnt = 0;
    while (!q.empty()) {
      int u = q.front();
      q.pop();
      bel[u] = ++cnt;
      rev[cnt] = u;
      for (int e = H[u]; e; e = E[e].nt) {
        int v = E[e].to;
        if (bel[v]) 
          continue;
        ft[v] = u;
        q.push(v);
      }
    }
    
    ft[root] = 0;
    
    dfs3(root, 0);
    
    ll ans = 0;
    
    for (int i = 1; i <= 17; i++) {
      int id = (1 << i);
      res[0] = 0;
      dfs2(ft[rev[id]], rev[id], n - tmp[rev[id]]);
      int mid = (id + (1 << (i + 1)) - 1) / 2;
      for (int j = id; j < (id * 2); j++) {
        ans += rev[j];
        if (j <= mid) {
          for (int k = 1; k <= res[0]; k++) {
            ans += rev[res[k]];
          }
        } else {
          for (int k = 1; k <= res[0]; k++) {
            int r = res[k];
            int kk = log2(res[k]);
            int p = (1 << kk) - r;
            ans += res[p];
          }
        }
      }
    }
    printf("%lld\n", ans);
    return 0;
  }
}

void solve() {
  scanf("%d", &n);
  init();
  int maxde = 0;
  for (int i = 1; i < n; i++) {
    scanf("%d %d", &edge[i].u, &edge[i].v);
    addEdge(edge[i].u, edge[i].v);
    addEdge(edge[i].v, edge[i].u);
    de[edge[i].u]++, de[edge[i].v]++;
    maxde = max(maxde, de[edge[i].u]);
    maxde = max(maxde, de[edge[i].v]);
  }
  if (n <= 2000) {
    forcebrute::main();
    return;
  }
  if (maxde == 2) {
    subtaskchain::main();
    return;
  }
  
  subtask3::main();
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  
  int T; scanf("%d", &T);
  while (T--) {
    solve();
  }
  return 0; 
}
