#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cctype>
#include <algorithm>
#define MAXN 300000
using namespace std;

struct fls {
	int to, next;
}edge[MAXN << 1];

int head[MAXN << 1], x[MAXN], y[MAXN], degree[MAXN], cnt, n, lim;

inline int read () {
	register int s = 0, w = 1;
	register char ch = getchar ();
	while (! isdigit (ch)) {if (ch == '-') w = -1; ch = getchar ();}
	while (isdigit (ch)) {s = (s << 3) + (s << 1) + (ch ^ 48); ch = getchar ();}
	return s * w;
}

inline void connect (int u, int v) {
	edge[++cnt].to = v, edge[cnt].next = head[u], head[u] = cnt;
}

namespace PTS1 {

	int father[MAXN], size[MAXN], ans = 0, tot1, tot2;

	void DFS (int now, int fa) {
		father[now] = fa, size[now] = 1;
		for (register int i = head[now]; i; i = edge[i].next) {
			int v = edge[i].to; if (v == fa) continue;
			DFS (v, now), size[now] += size[v];
		}
	}

	void getans (int now, int ban, int root) {
		bool flag = 1;
		for (register int i = head[now]; i; i = edge[i].next) {
			int v = edge[i].to; if (v == ban) continue;
			if (v == father[now]) {
				int u = size[root] - size[now];
				if (u > lim) flag = 0;
			}
			else {
				if (size[v] > lim) flag = 0;
				getans (v, ban, root);
			}
		}
		if (flag) ans += now;
	}

	void bruteforce () {
        ans = 0; 
		for (register int i = 1; i < n; i++) {
			DFS (x[i], y[i]), DFS (y[i], x[i]);
			lim = size[x[i]] / 2, getans (x[i], y[i], x[i]),
            lim = size[y[i]] / 2, getans (y[i], x[i], y[i]);
		}
		printf ("%d\n", ans);
	}

}

namespace PTS2 {

    int depth[MAXN], Depth[MAXN];

	void DFS (int now, int fa, int d) {
		depth[now] = d; Depth[d] = now;
		for (register int i = head[now]; i; i = edge[i].next) {
			int v = edge[i].to; if (v == fa) continue;
			DFS (v, now, d + 1);
		}
	}

    void chain () {
    	int pos; long long ans = 0;
        for (register int i = 1; i <= n; i++)
		 	if (degree[i] == 1) {pos = i; break;}
		DFS (pos, -1, 1);
		for (register int i = 1; i < n; i++) {
			if (depth[x[i]] < depth[y[i]]) {
				if (depth[x[i]] % 2 == 1)
					ans += Depth[(1 + depth[x[i]]) / 2] + Depth[(n + depth[y[i]]) / 2] + Depth[(n + depth[y[i]]) / 2 + 1];
				else
					ans += Depth[(1 + depth[x[i]]) / 2] + Depth[(1 + depth[x[i]]) / 2 + 1] + Depth[(n + depth[y[i]]) / 2];
			}
			else {
				if (depth[y[i]] % 2 == 1)
					ans += Depth[(1 + depth[y[i]]) / 2] + Depth[(n + depth[x[i]]) / 2] + Depth[(n + depth[x[i]]) / 2 + 1];
				else
					ans += Depth[(1 + depth[y[i]]) / 2] + Depth[(1 + depth[y[i]]) / 2 + 1] + Depth[(n + depth[x[i]]) / 2];
			}
		}
		printf ("%lld\n", ans);
    }

}

int main () {
    freopen ("centroid.in", "r", stdin), freopen ("centroid.out", "w", stdout);
	int T = read ();
	for (register int I = 1; I <= T; I++) {
		memset (head, 0, sizeof head), memset (edge, 0, sizeof edge), cnt = 0;
		memset (degree, 0, sizeof degree);
		n = read (); int sum1 = 0, sum2 = 0;
		for (register int i = 1; i < n; i++) {
			int u = read (), v = read (); degree[u]++, degree[v]++;
			connect (u, v), connect (v, u), x[i] = u, y[i] = v;
		}
		for (register int i = 1; i <= n; i++)
			if (degree[i] == 1) sum1++; else if (degree[i] == 2) sum2++;
		if (sum1 == 2 && sum2 == n - 2) PTS2 :: chain ();
		else PTS1 :: bruteforce ();
	}
	return 0;
}
