#include <bits/stdc++.h>
typedef long long ll;
typedef unsigned long long ull;

using std::cin;
using std::cout;
using std::endl;

const int N = 5e5 + 5;
const int MAX = 1e9;

int aa[N];

struct BigInt {
	ll num[10];
	int len;
	
	BigInt() {memset(num, 0, sizeof(num)); len = 1;}
	
	void Transfer(ll a) {
		if(a == 0) return;
		len = 0;
		while(a) {
			num[len] = a % MAX;
			len++; a /= MAX;
		}
	}
	
	void operator = (const BigInt& a) {len = a.len; for(int i = 0; i < len; i++) num[i] = a.num[i];}
	
	BigInt operator + (const BigInt& a) const {
		BigInt ans;
		ans.len = std::min(a.len, len);
		for(int i = 0; i < ans.len; i++)
			ans.num[i] = a.num[i] + num[i];
		for(int i = 0; i < ans.len; i++)
			if(ans.num[i] >= MAX) {
				ans.num[i + 1] += ans.num[i] / MAX;
				ans.num[i] %= MAX;
			}
		while(ans.num[ans.len]) ans.len++;
		return ans;
	}
	
	BigInt operator * (const BigInt& a) const {
		BigInt ans;
		ans.len = a.len + len;
		for(int i = 0; i < len; i++)
			for(int j = 0; j < a.len; j++) ans.num[i + j] = a.num[j] * num[i];
		for(int i = 0; i < ans.len; i++)
			if(ans.num[i] >= MAX) {
				ans.num[i + 1] += ans.num[i] / MAX;
				ans.num[i] %= MAX;
			}
		while(ans.num[ans.len]) ans.len++;
		return ans;			
	}
	
	bool operator < (const BigInt& a) const {
		if(len != a.len) return len < a.len;
		for(int i = len - 1; i >= 0; i--) if(num[i] != a.num[i]) return num[i] < a.num[i];
		return false;
	}
	
	bool operator <= (const BigInt& a) const {
		if(len != a.len) return len < a.len;
		for(int i = len - 1; i >= 0; i--) if(num[i] != a.num[i]) return num[i] < a.num[i];
		return true;
	}
	
	void Div2() {
		int tag = 0;
		for(int i = len - 1; i > 0; i--) {
			if(num[i] % 2) tag = 1;
			num[i] /= 2;
			if(tag) num[i - 1] += MAX;
		}
		num[0] /= 2;
		while(num[len - 1] == 0) len--;
	}
	
	void output() {
		for(int i = len - 1; i >= 0; i--) printf("%lld", num[i]);
		printf("\n");
	}
};

bool check(ull k, ull now, int pos, int n, ull last) {
	//k.output(); now.output(); last.output(); printf("\n");
	//cout << k << ' ' << now << ' ' << last << ' ' << pos << '\n';
	if(k < now) return false;
	if(pos >= n) return now <= k;
	ull tmp = 0;
	for(int i = pos + 1; i <= n; i++) {
		tmp = tmp + aa[i];
		if(now + tmp * tmp > k) return false;
		if(last <= tmp * tmp)
			if(check(k, now + tmp * tmp, i, n, tmp * tmp)) return true;
	}
	return false;
}

int main() {
	freopen("partition.in", "r", stdin);
	freopen("partition.out", "w", stdout);
	int n, type;
	scanf("%d%d", &n, &type);
	ull l = 0, r = 0;
	for(int i = 1; i <= n; i++) {
		scanf("%d", aa + i);
		l += aa[i] * aa[i];
		r += aa[i];
	}
	r = r * r;
	while(l < r) {
		ull mid = l + r;
		mid >>= 1;
		if(check(mid, 0, 0, n, 0)) r = mid;
		else l = mid + 1;
	}
	printf("%llu", l);
	return 0;
}
