#include <bits/stdc++.h>

using namespace std;

#define DEBUG(x) cerr << #x << " = " << x << endl

inline int read () {
	int x = 0, f = 1; char ch;
	do {ch = getchar (); if (ch == '-') f = -1;} while (ch > '9' || ch < '0');
	do {x = x * 10 + ch - '0'; ch = getchar ();} while (ch <= '9' && ch >= '0');
	return f * x;
}

typedef long long ll;

const int N = 299995 + 5;

struct EDGE {
	int to, u, next;
} edge[N << 1];

int head[N], cnt;

inline void addedge (int u, int v) {
	edge[++cnt].to = v;
	edge[cnt].u = u;
	edge[cnt].next = head[u];
	head[u] = cnt;
}

int n, T, X[N], Y[N];

namespace subtask1 {
	int x, y, ans, size[N], f[N];
	inline void dfs (int u, int fa, int now) {
		size[u] = 1;
		f[u] = fa;
		for (int i = head[u]; i; i = edge[i].next) {
			int v = edge[i].to;
			if (((x == u && y == v) ||  (x == v && y == u)) || v == f[u]) continue;
			dfs (v, u, now);
			size[u] += size[v];
		}
	}
	inline void calc (int now) {
		for (int i = 1; i <= n; i ++ ) {
			bool flag = 1;
			for (int j = head[i]; j; j = edge[j].next) {
				int v = edge[j].to, u = edge[j].u;	
				if (((x == u && y == v) ||  (x == v && y == u)) || v == f[u]) continue;
				if (size[v] > size[now] / 2 && flag) flag = 0;
			}
			if (flag && (size[now] - size[i]) <= size[now] / 2) {
				ans += i;
			}
		}
	}
	inline void AFO () {puts ("AFO");}
	inline void main () {
		ans = 0;
		for (int i = 1; i < n; i ++ ) {
			x = X[i], y = Y[i];
			dfs (x, -1, x);
			calc (x);
			memset (size, 0, sizeof (size));
			dfs (y, -1, y);
			calc (y);
			memset (size, 0, sizeof (size));
		}
		cout << ans << endl;
	}
}

namespace subtask2 {
	ll ans = 0;
	inline void main () {
		for (int i = 1; i < n; i ++ ) {
			if ((n - i) % 2 == 0) ans += 1ll *  (n + i)  + 1;
			if ((n - i) % 2 == 1) ans += 1ll * (n + i + 1) / 2;
			if (i % 2 == 0) ans += i + 1;
			if (i % 2 == 1) ans += (i + 1) / 2;
		}
		cout << ans << endl;
		exit (0);
	}
}

inline void file () {
	freopen ("centroid.in", "r", stdin);
	freopen ("centroid.out", "w", stdout);
}

signed main () {
	file ();
	T = read ();
	while (T -- ) {
		memset (head, 0, sizeof (head));
		n = read ();
		for (int i = 1; i < n; i ++ ) {
			int u = read (), v = read ();
			X[i] = u; Y[i] = v;
			addedge (u, v);
			addedge (v, u);
		}
		if (n <= 1999) subtask1::main (); // 40pts
		else if (n == 49991) subtask2::main ();
	}
} 
