#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <string>
#include <cstring>
using namespace std;

const int MAXN=2003;
struct edge {
  int x, y, nxt, del;
} E[MAXN<<1];
int head[MAXN], vis[MAXN], siz[MAXN], mxz[MAXN];
int n, m, tot, cnt, T, ans, clk;

inline void AddEdge(int x, int y) {
  E[++tot]=(edge){x, y, head[x], 0};
  head[x]=tot;
}

void DFS(int x, int f) {
  vis[x]=clk;
  siz[x]=1; mxz[x]=0;
  for(int i=head[x];~i;i=E[i].nxt) {
    int to=E[i].y;
    if(to!=f && E[i].del==0) {
      DFS(to, x);
      siz[x]+=siz[to];
      mxz[x]=max(mxz[x], siz[to]);
    }
  }
}

void Work(int x, int y) {
  memset(vis, 0, sizeof vis);
  ++clk;
  DFS(x, y);
  int all=siz[x];
  for(int i=1;i<=n;++i) {
    if(vis[i]==clk) {
      if(max(mxz[i], all-siz[i])<=all/2) ans+=i;
    }
  }
  ++clk;
  DFS(y, x);
  all=siz[y];
  for(int i=1;i<=n;++i) {
    if(vis[i]==clk) {
      if(max(mxz[i], all-siz[i])<=all/2) ans+=i;
    }
  }
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);
  scanf("%d", &T);
  while(T--) {
    memset(head, -1, sizeof head);
    memset(vis, 0, sizeof vis);
    scanf("%d", &n);
    tot=0;
    ans=0;
    clk=0;
    for(int i=1, x, y;i<n;++i) {
      scanf("%d%d", &x, &y);
      AddEdge(x, y);
      AddEdge(y, x);
    }
    for(int i=1;i<2*n;i+=2) {
      E[i].del=E[i+1].del=1;
      Work(E[i].x, E[i].y);
      E[i].del=E[i+1].del=0;
    }
    printf("%d\n", ans);
  }
  fclose(stdin);
  fclose(stdout);
  return 0;
}
