#include <cstdio>
#include <cstring>
#include <algorithm>

#define FILL(a, n, x) memset((a), (x), sizeof ((a)[0]) * (n))

using namespace std;

typedef long long li;

const int mod = 998244353;

inline int Add(int x) { return x >= mod ? x - mod : x; }
inline void Add(int &x, int y) { x += y; if (x >= mod) x -= mod; }
inline int Sub(int x) { return x < 0 ? x + mod : x; }
inline void Sub(int &x, int y) { x -= y; if (x < 0) x += mod; }
inline int Mul(int x, int y) { return (li)x * y % mod; }
inline int Mul(int x, int y, int z) { return Mul(Mul(x, y), z); }

int Pow(int x, int y) {
  int z = 1;
  for (; y; y >>= 1) {
    if (y & 1) z = Mul(z, x);
    x = Mul(x, x);
  }
  return z;
}

// ------------------------------------------------------------

const int maxn = 100, maxm = 2000;

int n, m;
int a[maxn][maxm];
int sum_row[maxn];
int way0[maxn], way1[maxn];
int dp[2][maxn * 2 + 1];

int main(void) {
  freopen("meal.in", "r", stdin);
  freopen("meal.out", "w", stdout);

  scanf("%d%d", &n, &m);
  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      scanf("%d", a[i] + j);
      Add(sum_row[i], a[i][j]);
    }
  }
  int ans = 1;
  for (int i = 0; i < n; ++i) {
    ans = Mul(ans, Add(sum_row[i] + 1));
  }

  for (int i = 0; i < m; ++i) {
    for (int j = 0; j < n; ++j) {
      way0[j] = a[j][i];
      way1[j] = Sub(sum_row[j] - way0[j]);
    }
    int cur = 0, nxt = 1;
    FILL(dp[cur], n * 2 + 1, 0);
    dp[cur][n] = 1;
    for (int j = 0; j < n; ++j) {
      FILL(dp[nxt], n * 2 + 1, 0);
      for (int x = n - j; x <= n + j; ++x) {
        int val = dp[cur][x];
        Add(dp[nxt][x + 1], Mul(val, way0[j]));
        Add(dp[nxt][x - 1], Mul(val, way1[j]));
        Add(dp[nxt][x], val);
      }
      swap(cur, nxt);
    }
    for (int x = n + 1; x <= 2 * n; ++x) {
      Sub(ans, dp[cur][x]);
    }
  }

  Sub(ans, 1);
  printf("%d\n", ans);
  return 0;
}
