#include <bits/stdc++.h>
using namespace std;

#define ll long long
#define ull unsigned long long

const int N = 500005;
struct query {
  int u, v;
} e[N];

struct Edge {
  int to, nxt; 
  Edge (int _to = 0, int _nxt = 0):
    to(_to), nxt(_nxt) {}
} edge[N << 1];
int head[N], tot;

inline void add(int u, int v) {
  edge[++tot] = Edge(v, head[u]);
  head[u] = tot;
}

int dp[N], sz[N], n, cnt;
long long ans = 0LL;

//int times[N];

namespace subtask1 {

void dfs(int u, int fa) {
  sz[u] = 1; dp[u] = 0, cnt++;
  for (int i = head[u]; i; i = edge[i].nxt) {
    int v = edge[i].to;
    if (v == fa) continue;
    dfs(v, u); sz[u] += sz[v];
    dp[u] = max(dp[u], sz[v]);
  }
}

void solve() {
  for (int del = 1; del < n; del++) {
    //printf("Case edge(%d): \n", del);
    int L = e[del].u, R = e[del].v;
    // memset
    for (int i = 1; i <= n; i++) {
      head[i] = 0; dp[i] = -1; sz[i] = 0;
    }
    tot = 0;
    
    for (int i = 1; i < n; i++) {
      if (i != del) {
        add(e[i].u, e[i].v);
        add(e[i].v, e[i].u);
      }
    }
    
    int Min = 1e9;
    cnt = 0; dfs(L, 0);
    for (int i = 1; i <= n; i++) {
      if (dp[i] != -1) {
        dp[i] = max(dp[i], cnt - sz[i]);
        if (Min > dp[i]) {
          Min = dp[i];
        }
      }
    }
    for (int i = 1; i <= n; i++) {
      if (dp[i] != -1 && dp[i] == Min) {
        ans += i; //times[i]++;
        //printf("%d ", i);
      }
    }
    //puts("");
    
    // memset
    Min = 1e9;
    for (int i = 1; i <= n; i++) {
      dp[i] = -1, sz[i] = 0;
    }

    cnt = 0; dfs(R, 0);
    for (int i = 1; i <= n; i++) {
      if (dp[i] != -1) {
        dp[i] = max(dp[i], cnt - sz[i]);
        if (Min > dp[i]) {
          Min = dp[i]; 
        }
      }
    }
    for (int i = 1; i <= n; i++) {
      if (dp[i] != -1 && dp[i] == Min) {
        ans += i; //times[i]++;
        //printf("%d ", i);
      } 
    }
    //puts("");
  } 
  //for (int i = 1; i <= n; i++) {
  //  printf("times[%d] = %d\n", i, times[i]);
  //}
  printf("%lld\n", ans);
  return ;
}

}

int dag[N], dfn[N];
namespace subtask2 {

void dfs6(int u, int fa, int ff) {
  dfn[ff] = u;
  for (int i = head[u]; i; i = edge[i].nxt) {
    int v = edge[i].to;
    if (v == fa) continue;
    dfs6(v, u, ff + 1);
  }
}

void solve() {
  ans = 0LL;
  for (int i = 1; i < n; i++) {
    dag[e[i].u]++;
    dag[e[i].v]++;
    add(e[i].u, e[i].v);
    add(e[i].v, e[i].u);
  }
  int fir = 0;
  for (int i = 1; i <= n; i++) {
    if (dag[i] == 1) {
      fir = i;
      break;
    }
  }
  dfs6(fir, 0, 1);
  //for (int i = 1; i <= n; i++) {
  //  printf("dfn[%d] = %d\n", i, dfn[i]);
  //}
  //if (dfn[n]) puts("!");
  for (int del = 1; del < n; del++) {
    int Leftl = 1, Leftr = del;
    int Rightl = del + 1, Rightr = n;
    if ((Leftr - Leftl + 1) % 2 == 1)
      ans += dfn[(Leftl + Leftr + 1) / 2];
    else
      ans += dfn[(Leftl + Leftr) / 2] + 
             dfn[(Leftl + Leftr + 2) / 2];
    if ((Rightr - Rightl + 1) % 2 == 1)
      ans += dfn[(Rightl + Rightr + 1) / 2];
    else
      ans += dfn[(Rightl + Rightr) / 2] + 
             dfn[(Rightl + Rightr + 2) / 2];
  }
  printf("%lld\n", ans);
}

}

namespace subtask3 {
int rt = 0;
int vis[N];
int dis[N], fro[N];
void dfs(int u, int fa) {
  for (int i = head[u]; i; i = edge[i].nxt) {
    int v = edge[i].to;
    if (v == fa) continue;
    dis[v] = dis[u] + 1;
    fro[v] = u;
    dfs(v, u);
  }
}

void solve() {
  rt = 0;
  for (int i = 1; i < n; i++) {
    add(e[i].u, e[i].v);
    add(e[i].v, e[i].u);
  }
  dfs(1, 0);
  int st = 1;
  for (int i = 1; i <= n; i++) {
    if (dis[i] > dis[st]) {
      st = i;
    }
  }
  for (int i = 1; i <= n; i++) {
    dis[i] = 0;
  }
  dfs(st, 0);
  int st2 = 0;
  for (int i = 1; i <= n; i++) {
    if (dis[i] > dis[st2]) {
      st2 = i;
    }
  }
  
  int ff = 0;
  for (int i = st2; i != st; i = fro[i]) {
    dfn[++ff] = i;
  }
  dfn[++ff] = st;
  
  rt = dfn[(ff + 1) / 2];
  //cerr << "root = " << rt << '\n';
  ll vals = (n + 1) / 2;
  ans = (vals * rt);
  for (int i = 1; i <= n; i++) {
    vis[i] = 0;
  }
  vis[rt] = 1;
  for (int i = head[rt]; i; i = edge[i].nxt) {
    ans += vals * edge[i].to;
    vis[edge[i].to] = 1;
  }
  for (int i = 1; i <= n; i++) {
    if (!vis[i])
      ans += i;
  }
  printf("%lld\n", ans);
  return ;
}

}

void work() {
  scanf("%d", &n); ans = 0;
  for (int i = 1; i <= n; i++) {
    head[i] = 0; dag[i] = 0;
  } tot = cnt = 0;

  for (int i = 1; i < n; i++) {
    scanf("%d%d", &e[i].u, &e[i].v);
  }
  
  if (n <= 3000) {
    subtask1::solve();
    return ;
  }
  if (n <= 50000) {
    subtask2::solve();
    return ;
  }
  if (n <= 262148) {
    subtask3::solve();
    return ;
  }
  subtask1::solve();
  return ;
}

int main() {
  freopen("centroid.in", "r", stdin);
  freopen("centroid.out", "w", stdout);

  int T; scanf("%d", &T);
  while (T--) work();
  return 0;
}
