#include <cstdio>
#include <cctype>
#include <cstring>
#include <iostream>
#include <algorithm>

using namespace std;

inline char gc() {
	static const int L = 2333333;
	static char sxd[L], *sss = sxd, *ttt = sxd;
	if (sss == ttt) {
		ttt = (sss = sxd) + fread(sxd, 1, L, stdin);
		if (sss == ttt) {
			return EOF;
		}
	}
	return *sss++;
}

#define dd c = gc()
template <class T>
inline bool read(T& x) {
	bool flg = false;
	char dd;
	x = 0;
	for (; !isdigit(c); dd) {
		if (c == '-') {
			flg = true;
		} else if (c == EOF) {
			return false;
		}
	}
	for (; isdigit(c); dd) {
		x = (x * 10) + (c ^ 48);
	}
	if (flg) {
		x = -x;
	}
	return true;
}
#undef dd

const int maxn = 300005;

typedef long long LL;

int n;

namespace BF {
	struct Edge {
		int to, nxt;
	} e[maxn << 1];

	int first[maxn];

	int cnt;
	inline void add_edge(int from, int to) {
		e[++cnt].nxt = first[from];
		first[from] = cnt;
		e[cnt].to = to;
		e[++cnt].nxt = first[to];
		first[to] = cnt;
		e[cnt].to = from;
	}

	struct EDGE {
		int u, v;
	} ee[maxn];

	int siz[maxn];
	int u, v;
	LL ans;

	inline void dfs1(int now, int fa) {
		siz[now] = 1;
		for (int i = first[now]; i; i = e[i].nxt) {
			int to = e[i].to;
			if (to != fa && to != u && to != v) {
				dfs1(to, now);
				siz[now] += siz[to];
			}
		}
	}

	inline void dfs2(int now, int fa, int S) {
		bool flg = ((S - siz[now]) <= (S >> 1));
		for (int i = first[now]; i; i = e[i].nxt) {
			int to = e[i].to;
			if (to != fa && to != u && to != v) {
				flg &= (siz[to] <= (S >> 1));
				dfs2(to, now, S);
			}
		}
		if (flg) {
//		    cout << "now = " << now << endl;
			ans += now;
		}
	}

	inline void init() {
		cnt = 0;
		ans = 0;
		memset(first, 0, sizeof(first));
	}

	inline void solve() {
		init();
		for (int i = 1; i < n; ++i) {
			read(ee[i].u), read(ee[i].v);
			add_edge(ee[i].u, ee[i].v);
		}
		for (int i = 1; i < n; ++i) {
			u = ee[i].u, v = ee[i].v;
//			cout << "u = " << u << ' ' << "v = " << v << endl;
			dfs1(u, 0);
			dfs1(v, 0);
			dfs2(u, 0, siz[u]);
			dfs2(v, 0, siz[v]);
		}
		printf("%lld\n", ans);
	}
}

namespace LIAN {
	int p[maxn];

	inline int get(int l, int r) {
		int len = r - l + 1;
		int mid = (l + r) >> 1;
		if (len & 1) {
			return p[mid];
		} else {
			return p[mid] + p[mid + 1];
		}
	}

	inline void solve() {
		for (int i = 1; i < n; ++i) {
			read(p[i]), read(p[n]);
		}
		LL ans = 0;
		for (int i = 1; i < n; ++i) {
			ans += get(1, i) + get(i + 1, n);
//			cout << "alb " << get(1, i) << ' ' << get(i + 1, n) << endl;
		}
		printf("%lld\n", ans);
	}
}

inline void solve() {
	read(n);
	if (n <= 2000) {
		BF::solve();
	} else {
		LIAN::solve();
	}
}

int main() {
	freopen("centroid.in", "r", stdin);
	freopen("centroid.out", "w", stdout);
	int T;
	read(T);
	while (T--) {
		solve();
	}
	fclose(stdin);
	fclose(stdout);
	return 0;
}

/*
1
5
1 2
2 3
3 4
4 5
*/
